      SUBROUTINE COEF(NM,ME,NS,NBHI,B,C,A,AINV,BETA,
     &                BFBETA,IBHI,GAMMA,OMEGA,ERRC,
     &                ORDERP1,EMBORDERP1,ERRFAC,EXPM,EXPERR,
     &                IERRJAC,STIFFLYACC)
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: NM
      INTEGER, INTENT(IN   ) :: ME(NM)
      INTEGER, INTENT(IN   ) :: NS
      INTEGER, INTENT(IN   ) :: NBHI
      REAL   , INTENT(  OUT) :: B(NS)
      REAL   , INTENT(  OUT) :: C(NS)
      REAL   , INTENT(  OUT) :: A(NS,NS,NM)
      REAL   , INTENT(  OUT) :: AINV(NS,NS,NM)
      REAL   , INTENT(  OUT) :: BETA(NS)
      REAL   , INTENT(  OUT) :: BFBETA(NS,NM)
      INTEGER, INTENT(  OUT) :: IBHI(NS)
      REAL   , INTENT(  OUT) :: GAMMA(NS,NM)
      REAL   , INTENT(  OUT) :: OMEGA(NS,NS,NM)
      REAL   , INTENT(  OUT) :: ERRC(NS+1)
      REAL   , INTENT(  OUT) :: ORDERP1
      REAL   , INTENT(  OUT) :: EMBORDERP1
      REAL   , INTENT(  OUT) :: ERRFAC
      REAL   , INTENT(  OUT) :: EXPM
      REAL   , INTENT(  OUT) :: EXPERR
      INTEGER, INTENT(  OUT) :: IERRJAC
      INTEGER, INTENT(  OUT) :: STIFFLYACC(NM)
C    LOCAL VARIABLES
      INTEGER                :: IS,M,MEM,ME1
      REAL                   :: ERRC2,ERRC3,SQRT3,GAMMAM,SQRT5,SQRT6
      REAL                   :: SQRT15
c      INTEGER                :: JS
c      REAL                   :: BFBETAISM
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE COEF
C-----------------------------------------------------------------------
      ME1=ME(1)

      DO IS=1,NBHI
         IBHI(IS)=IS
      ENDDO
      DO IS=NBHI+1,NS
         IBHI(IS)=NBHI
      ENDDO

      IF     (NS== 3) THEN

         SQRT3 =SQRT( 3.0)
         SQRT5 =SQRT( 5.0)
         SQRT6 =SQRT( 6.0)
         SQRT15=SQRT(15.0)

         IF     ((ME1>= 1).AND.(ME1<=10)) THEN

C --------------------------------
C ----------- LOBATTO FAMILY -----
C --------------------------------
C ----------- ERROR COEFFICIENTS ERRC(I) -----
            ERRC3=-2.0/3.0
c           ERRC(0)=ERRC3*( 5.0)
            ERRC(1)=ERRC3*(-4.0)
            ERRC(2)=ERRC3*(-2.0)
            ERRC(3)=ERRC3*(-4.0)
            ERRC(4)=ERRC3*( 5.0)
c ----------- nonstiff order +1 -----
c            ORDERP1=5.0
c            ERRFAC=0.047
c ----------- stiff order +1 -----
            ORDERP1=4.0
            EMBORDERP1=2.0
            ERRFAC=1.0/6.0
            IERRJAC=1
C ----------- B(IS) -----
            B(1)=1.0/6.0
            B(2)=2.0/3.0
            B(3)=1.0/6.0
C ----------- C(IS) -----
            C(1)=0.0
            C(2)=0.5
            C(3)=1.0
C ----------- BETA(IS) -----
            BETA(1)=0.0
            BETA(2)=0.0
            BETA(3)=1.0
            DO M=1,NM
               MEM=ME(M)
               IF     (MEM== 1) THEN
C ----------------- LOBATTO IIIA -----
                  STIFFLYACC(M)=1
C ----------------- A(IS,JS,M) -----
                  A(1,1,M)=0.0
                  A(1,2,M)=0.0
                  A(1,3,M)=0.0
                  A(2,1,M)=5.0/24.0
                  A(2,2,M)=1.0/3.0
                  A(2,3,M)=-1.0/24.0
                  A(3,1,M)=B(1)
                  A(3,2,M)=B(2)
                  A(3,3,M)=B(3)
C ----------------- AINV(IS,JS,M) -----
                  AINV(1,1,M)=0.0
                  AINV(1,2,M)=0.0
                  AINV(1,3,M)=0.0
                  AINV(2,1,M)=-0.5
                  AINV(2,2,M)=2.0
                  AINV(2,3,M)=0.5
                  AINV(3,1,M)=1.0
                  AINV(3,2,M)=-8.0
                  AINV(3,3,M)=4.0
C ----------------- BFBETA(IS,M) -----
                  BFBETA(1,M)=0.0
                  BFBETA(2,M)=0.0
                  BFBETA(3,M)=0.0
C ----------------- GAMMA(IS,M) -----
                  IF     (NBHI== 1) THEN
                     GAMMAM=0.5/SQRT3
                     GAMMA(1,M)=0.0
                     GAMMA(2,M)=GAMMAM
                     GAMMA(3,M)=GAMMAM
                  ELSEIF (NBHI== 2) THEN
                     GAMMAM=0.5/SQRT3
                     GAMMA(1,M)=0.0
                     GAMMA(2,M)=GAMMAM
                     GAMMA(3,M)=GAMMAM
                  ELSEIF (NBHI==NS) THEN
                     GAMMA(1,M)=0.0
                     GAMMA(2,M)=0.2083266
                     GAMMA(3,M)=0.4000131
                  ENDIF
C ----------------- OMEGA(IS,JS,M) -----
                  OMEGA(1,1,M)=0.0
                  OMEGA(1,2,M)=0.0
                  OMEGA(1,3,M)=0.0
                  OMEGA(2,1,M)=-GAMMA(2,M)*AINV(2,1,M)
                  OMEGA(2,2,M)= GAMMA(2,M)*AINV(2,2,M)*GAMMA(2,M)
                  OMEGA(2,3,M)= GAMMA(2,M)*AINV(2,3,M)*GAMMA(3,M)
                  OMEGA(3,1,M)=-GAMMA(3,M)*AINV(3,1,M)
                  OMEGA(3,2,M)= GAMMA(3,M)*AINV(3,2,M)*GAMMA(2,M)
                  OMEGA(3,3,M)= GAMMA(3,M)*AINV(3,3,M)*GAMMA(3,M)
               ELSEIF (MEM== 2) THEN
C ----------------- LOBATTO IIIB -----
                  STIFFLYACC(M)=0
C ----------------- A(IS,JS,M) -----
                  A(1,1,M)=B(1)
                  A(1,2,M)=-1.0/6.0
                  A(1,3,M)=0.0
                  A(2,1,M)=B(1)
                  A(2,2,M)=1.0/3.0
                  A(2,3,M)=0.0
                  A(3,1,M)=B(1)
                  A(3,2,M)=5.0/6.0
                  A(3,3,M)=0.0
C ----------------- AINV(IS,JS,M) -----
                  AINV(1,1,M)=4.0
                  AINV(1,2,M)=2.0
                  AINV(1,3,M)=0.0
                  AINV(2,1,M)=-2.0
                  AINV(2,2,M)=2.0
                  AINV(2,3,M)=0.0
                  AINV(3,1,M)=1.0
                  AINV(3,2,M)=-2.0
                  AINV(3,3,M)=0.0
C ----------------- BFBETA(IS,M) -----
                  BFBETA(1,M)=0.0
                  BFBETA(2,M)=-1.0/6.0
                  BFBETA(3,M)=B(3)
C ----------------- GAMMA(IS,M) -----
                  IF     (NBHI== 1) THEN
                     GAMMAM=0.5/SQRT3
                     GAMMA(1,M)=GAMMAM
                     GAMMA(2,M)=GAMMAM
                     GAMMA(3,M)=0.0
                  ELSEIF (NBHI== 2) THEN
                     GAMMAM=0.5/SQRT3
                     GAMMA(1,M)=GAMMAM
                     GAMMA(2,M)=GAMMAM
                     GAMMA(3,M)=0.0
                  ELSEIF (NBHI==NS) THEN
                     GAMMA(1,M)=0.4000131
                     GAMMA(2,M)=0.2083266
                     GAMMA(3,M)=0.0
                  ENDIF
C ----------------- OMEGA(IS,JS,M) -----
                  OMEGA(1,1,M)=GAMMA(1,M)*AINV(1,1,M)*GAMMA(1,M)
                  OMEGA(1,2,M)=GAMMA(1,M)*AINV(1,2,M)*GAMMA(2,M)
                  OMEGA(1,3,M)=0.0
                  OMEGA(2,1,M)=GAMMA(2,M)*AINV(2,1,M)*GAMMA(1,M)
                  OMEGA(2,2,M)=GAMMA(2,M)*AINV(2,2,M)*GAMMA(2,M)
                  OMEGA(2,3,M)=0.0
                  OMEGA(3,1,M)=          -AINV(3,1,M)*GAMMA(1,M)
                  OMEGA(3,2,M)=          -AINV(3,2,M)*GAMMA(2,M)
                  OMEGA(3,3,M)=0.0
               ELSEIF (MEM== 3) THEN
C ----------------- LOBATTO IIIC -----
                  STIFFLYACC(M)=1
C ----------------- A(IS,JS,M) -----
                  A(1,1,M)=B(1)
                  A(1,2,M)=-1.0/3.0
                  A(1,3,M)=1.0/6.0
                  A(2,1,M)=B(1)
                  A(2,2,M)=5.0/12.0
                  A(2,3,M)=-1.0/12.0
                  A(3,1,M)=B(1)
                  A(3,2,M)=B(2)
                  A(3,3,M)=B(3)
C ----------------- AINV(IS,JS,M) -----
                  AINV(1,1,M)=3.0
                  AINV(1,2,M)=4.0
                  AINV(1,3,M)=-1.0
                  AINV(2,1,M)=-1.0
                  AINV(2,2,M)=0.0
                  AINV(2,3,M)=1.0
                  AINV(3,1,M)=1.0
                  AINV(3,2,M)=-4.0
                  AINV(3,3,M)=3.0
C ----------------- BFBETA(IS,M) -----
                  BFBETA(1,M)=0.0
                  BFBETA(2,M)=0.0
                  BFBETA(3,M)=0.0
C ----------------- GAMMA(IS,M) -----
                  IF     (NBHI== 1) THEN
                     GAMMAM=0.330770364638776720
                     GAMMA(1,M)=GAMMAM
                     GAMMA(2,M)=GAMMAM
                     GAMMA(3,M)=GAMMAM
                  ELSEIF (NBHI== 2) THEN
                     GAMMAM=0.330770364638776720
                     GAMMA(1,M)=GAMMAM
                     GAMMA(2,M)=GAMMAM
                     GAMMA(3,M)=GAMMAM
                  ELSEIF (NBHI==NS) THEN
                     GAMMA(1,M)=0.75
                     GAMMA(2,M)=0.174
                     GAMMA(3,M)=0.351
                  ENDIF
C ----------------- OMEGA(IS,JS,M) -----
                  OMEGA(1,1,M)=GAMMA(1,M)*AINV(1,1,M)*GAMMA(1,M)
                  OMEGA(1,2,M)=GAMMA(1,M)*AINV(1,2,M)*GAMMA(2,M)
                  OMEGA(1,3,M)=GAMMA(1,M)*AINV(1,3,M)*GAMMA(3,M)
                  OMEGA(2,1,M)=GAMMA(2,M)*AINV(2,1,M)*GAMMA(1,M)
                  OMEGA(2,2,M)=GAMMA(2,M)*AINV(2,2,M)*GAMMA(2,M)
                  OMEGA(2,3,M)=GAMMA(2,M)*AINV(2,3,M)*GAMMA(3,M)
                  OMEGA(3,1,M)=GAMMA(3,M)*AINV(3,1,M)*GAMMA(1,M)
                  OMEGA(3,2,M)=GAMMA(3,M)*AINV(3,2,M)*GAMMA(2,M)
                  OMEGA(3,3,M)=GAMMA(3,M)*AINV(3,3,M)*GAMMA(3,M)
               ELSEIF (MEM== 4) THEN
C ----------------- LOBATTO IIIC* -----
                  STIFFLYACC(M)=0
C ----------------- A(IS,JS,M) -----
                  A(1,1,M)=0.0
                  A(1,2,M)=0.0
                  A(1,3,M)=0.0
                  A(2,1,M)=0.25
                  A(2,2,M)=0.25
                  A(2,3,M)=0.0
                  A(3,1,M)=0.0
                  A(3,2,M)=1.0
                  A(3,3,M)=0.0
C ----------------- AINV(IS,JS,M) -----
                  AINV(1,1,M)=0.0
                  AINV(1,2,M)=0.0
                  AINV(1,3,M)=0.0
                  AINV(2,1,M)=4.0
                  AINV(2,2,M)=-1.0
                  AINV(2,3,M)=0.0
                  AINV(3,1,M)=0.0
                  AINV(3,2,M)=1.0
                  AINV(3,3,M)=0.0
C ----------------- BFBETA(IS,M) -----
                  BFBETA(1,M)=B(1)
                  BFBETA(2,M)=-1.0/3.0
                  BFBETA(3,M)=B(3)
C ----------------- GAMMA(IS,M) -----
                  GAMMA(1,M)=0.0
                  GAMMA(2,M)=0.0
                  GAMMA(3,M)=0.0
C ----------------- OMEGA(IS,JS,M) -----
                  OMEGA(1,1,M)=0.0
                  OMEGA(1,2,M)=0.0
                  OMEGA(1,3,M)=0.0
                  OMEGA(2,1,M)=0.0
                  OMEGA(2,2,M)=0.0
                  OMEGA(2,3,M)=0.0
                  OMEGA(3,1,M)=0.0
                  OMEGA(3,2,M)=0.0
                  OMEGA(3,3,M)=0.0
               ELSEIF (MEM== 5) THEN
C ----------------- LOBATTO IIID -----
                  STIFFLYACC(M)=0
C ----------------- A(IS,JS,M) -----
                  A(1,1,M)=1.0/12.0
                  A(1,2,M)=-1.0/6.0
                  A(1,3,M)=1.0/12.0
                  A(2,1,M)=5.0/24.0
                  A(2,2,M)=1.0/3.0
                  A(2,3,M)=-1.0/24.0
                  A(3,1,M)=1.0/12.0
                  A(3,2,M)=5.0/6.0
                  A(3,3,M)=1.0/12.0
C ----------------- AINV(IS,JS,M) -----
                  AINV(1,1,M)=3.0
                  AINV(1,2,M)=4.0
                  AINV(1,3,M)=-1.0
                  AINV(2,1,M)=-1.0
                  AINV(2,2,M)=0.0
                  AINV(2,3,M)=1.0
                  AINV(3,1,M)=7.0
                  AINV(3,2,M)=-4.0
                  AINV(3,3,M)=3.0
C ----------------- BFBETA(IS,M) -----
                  BFBETA(1,M)=1.0/12.0
                  BFBETA(2,M)=-1.0/6.0
                  BFBETA(3,M)=1.0/12.0
C ----------------- GAMMA(IS,M) -----
                  IF     (NBHI== 1) THEN
                     GAMMAM=0.257881726603440794
                     GAMMA(1,M)=GAMMAM
                     GAMMA(2,M)=GAMMAM
                     GAMMA(3,M)=GAMMAM
                  ELSEIF (NBHI== 2) THEN
                     GAMMAM=0.257881726603440794
                     GAMMA(1,M)=GAMMAM
                     GAMMA(2,M)=GAMMAM
                     GAMMA(3,M)=GAMMAM
                  ELSEIF (NBHI==NS) THEN
                     GAMMA(1,M)=0.905
                     GAMMA(2,M)=0.0915
                     GAMMA(3,M)=0.1505
                  ENDIF
C ----------------- OMEGA(IS,JS,M) -----
                  OMEGA(1,1,M)=GAMMA(1,M)*AINV(1,1,M)*GAMMA(1,M)
                  OMEGA(1,2,M)=GAMMA(1,M)*AINV(1,2,M)*GAMMA(2,M)
                  OMEGA(1,3,M)=GAMMA(1,M)*AINV(1,3,M)*GAMMA(3,M)
                  OMEGA(2,1,M)=GAMMA(2,M)*AINV(2,1,M)*GAMMA(1,M)
                  OMEGA(2,2,M)=GAMMA(2,M)*AINV(2,2,M)*GAMMA(2,M)
                  OMEGA(2,3,M)=GAMMA(2,M)*AINV(2,3,M)*GAMMA(3,M)
                  OMEGA(3,1,M)=GAMMA(3,M)*AINV(3,1,M)*GAMMA(1,M)
                  OMEGA(3,2,M)=GAMMA(3,M)*AINV(3,2,M)*GAMMA(2,M)
                  OMEGA(3,3,M)=GAMMA(3,M)*AINV(3,3,M)*GAMMA(3,M)
               ENDIF
            ENDDO

         ELSEIF ((ME1>=11).AND.(ME1<=20)) THEN

C -----------------------------------
C ----------- RADAU II FAMILY -------
C -----------------------------------
C ----------- ERROR COEFFICIENTS ERRC(IS) -----
            ERRC3=-1.0/6.0
c           ERRC(0)=0.0
            ERRC(1)=ERRC3*(1.0+1.5*SQRT6)
            ERRC(2)=ERRC3*(1.0-1.5*SQRT6)
            ERRC(3)=ERRC3
            ERRC(4)=0.0
c ----------- nonstiff order +1 -----
c            ORDERP1=6.0
c            ERRFAC=0.0125
c ----------- stiff order +1 -----
            ORDERP1=4.0
            EMBORDERP1=3.0
c            ERRFAC=0.454
            ERRFAC=0.1
            IERRJAC=1
C ----------- B(IS) -----
            B(1)=(16.0-SQRT6)/36.0
            B(2)=(16.0+SQRT6)/36.0
            B(3)=1.0/9.0
C ----------- C(IS) -----
            C(1)=(4.0-SQRT6)/10.0
            C(2)=(4.0+SQRT6)/10.0
            C(3)=1.0
C ----------- BETA(IS) -----      
            BETA(1)=0.0
            BETA(2)=0.0
            BETA(3)=1.0
            DO M=1,NM
               MEM=ME(M)
               IF     (MEM==11) THEN
C ----------------- RADAU IIA -----
                  STIFFLYACC(M)=1
C ----------------- A(IS,JS,M) -----
                  A(1,1,M)=(88.0-7.0*SQRT6)/360.0
                  A(1,2,M)=(296.0-169.0*SQRT6)/1800.0
                  A(1,3,M)=(-2.0+3.0*SQRT6)/225.0
                  A(2,1,M)=(296.0+169.0*SQRT6)/1800.0
                  A(2,2,M)=(88.0+7.0*SQRT6)/360.0
                  A(2,3,M)=(-2.0-3.0*SQRT6)/225.0
                  A(3,1,M)=B(1)
                  A(3,2,M)=B(2)
                  A(3,3,M)=B(3)
C ----------------- AINV(IS,JS,M) -----
                  AINV(1,1,M)=2.0+0.5*SQRT6
                  AINV(1,2,M)=-1.2+29.0*SQRT6/30.0
                  AINV(1,3,M)=0.4-4.0*SQRT6/15.0
                  AINV(2,1,M)=-1.2-29.0*SQRT6/30.0
                  AINV(2,2,M)=2.0-0.5*SQRT6
                  AINV(2,3,M)=0.4+4.0*SQRT6/15.0
                  AINV(3,1,M)=-1.0+8.0*SQRT6/3.0
                  AINV(3,2,M)=-1.0-8.0*SQRT6/3.0
                  AINV(3,3,M)=5.0
C ----------------- BFBETA(IS,M) -----
                  BFBETA(1,M)=0.0
                  BFBETA(2,M)=0.0
                  BFBETA(3,M)=0.0
C ----------------- GAMMA(IS,M) -----
                  IF     (NBHI== 1) THEN
                     GAMMAM=0.246232757526440536
                     GAMMA(1,M)=GAMMAM
                     GAMMA(2,M)=GAMMAM
                     GAMMA(3,M)=GAMMAM
                  ELSEIF (NBHI== 2) THEN
                     GAMMAM=0.246232757526440536
                     GAMMA(1,M)=GAMMAM
                     GAMMA(2,M)=GAMMAM
                     GAMMA(3,M)=GAMMAM
                  ELSEIF (NBHI==NS) THEN
                     GAMMA(1,M)=0.3640
                     GAMMA(2,M)=0.1450
                     GAMMA(3,M)=0.4495
                  ENDIF
C ----------------- OMEGA(IS,JS,M) -----
                  OMEGA(1,1,M)=GAMMA(1,M)*AINV(1,1,M)*GAMMA(1,M)
                  OMEGA(1,2,M)=GAMMA(1,M)*AINV(1,2,M)*GAMMA(2,M)
                  OMEGA(1,3,M)=GAMMA(1,M)*AINV(1,3,M)*GAMMA(3,M)
                  OMEGA(2,1,M)=GAMMA(2,M)*AINV(2,1,M)*GAMMA(1,M)
                  OMEGA(2,2,M)=GAMMA(2,M)*AINV(2,2,M)*GAMMA(2,M)
                  OMEGA(2,3,M)=GAMMA(2,M)*AINV(2,3,M)*GAMMA(3,M)
                  OMEGA(3,1,M)=GAMMA(3,M)*AINV(3,1,M)*GAMMA(1,M)
                  OMEGA(3,2,M)=GAMMA(3,M)*AINV(3,2,M)*GAMMA(2,M)
                  OMEGA(3,3,M)=GAMMA(3,M)*AINV(3,3,M)*GAMMA(3,M)
               ENDIF
            ENDDO

         ELSEIF ((ME1>=21).AND.(ME1<=30)) THEN

C -----------------------------------
C ----------- GAUSS FAMILY ----------
C -----------------------------------
C ----------- ERROR COEFFICIENTS ERRC(IS) -----
            ERRC2=-4.0/3.0
c           ERRC(0)=0.0
            ERRC(1)=ERRC2*(-SQRT15-5.0)*0.25
            ERRC(2)=ERRC2
            ERRC(3)=ERRC2*( SQRT15-5.0)*0.25
            ERRC(4)=0.0
c ----------- nonstiff order +1 -----
c            ORDERP1=7.0
c ----------- stiff order +1 -----
c            ORDERP1=4.0
c works better!!!
            ORDERP1=2.0
            EMBORDERP1=3.0
            ERRFAC=0.454
            IERRJAC=1
C ----------- B(IS) -----
            B(1)=5.0/18.0
            B(2)=4.0/9.0
            B(3)=5.0/18.0
C ----------- C(IS) -----
            C(1)=0.5-SQRT15/10.0
            C(2)=0.5
            C(3)=0.5+SQRT15/10.0
C ----------- BETA(IS) -----
            BETA(1)=(5.0-SQRT15)/6.0
            BETA(2)=-2.0/3.0
            BETA(3)=(5.0+SQRT15)/6.0
            DO M=1,NM
               MEM=ME(M)
               IF     (MEM==21) THEN
C ----------------- GAUSS -----
                  STIFFLYACC(M)=0
C ----------------- A(IS,JS,M) -----
                  A(1,1,M)=5.0/36.0
                  A(1,2,M)=2.0/9.0-SQRT15/15.0
                  A(1,3,M)=5.0/36.0-SQRT15/30.0
                  A(2,1,M)=5.0/36.0+SQRT15/24.0
                  A(2,2,M)=2.0/9.0
                  A(2,3,M)=5.0/36.0-SQRT15/24.0
                  A(3,1,M)=5.0/36.0+SQRT15/30.0
                  A(3,2,M)=2.0/9.0+SQRT15/15.0
                  A(3,3,M)=5.0/36.0
C ----------------- AINV(IS,JS,M) -----
                  AINV(1,1,M)=5.0
                  AINV(1,2,M)=-4.0+4.0*SQRT15/3.0
                  AINV(1,3,M)=5.0-4.0*SQRT15/3.0
                  AINV(2,1,M)=-2.5-5.0*SQRT15/6.0
                  AINV(2,2,M)=2.0
                  AINV(2,3,M)=-2.5+5.0*SQRT15/6.0
                  AINV(3,1,M)=5.0+4.0*SQRT15/3.0
                  AINV(3,2,M)=-4.0-4.0*SQRT15/3.0
                  AINV(3,3,M)=5.0
C ----------------- BFBETA(IS,M) -----
                  BFBETA(1,M)=1.0/18.0
                  BFBETA(2,M)=-1.0/9.0
                  BFBETA(3,M)=1.0/18.0
c                  DO IS=1,NS
c                     BFBETAISM=B(IS)
c                     DO JS=1,NS
c                        BFBETAISM=BFBETAISM-BETA(JS)*A(JS,IS,M)
c                     ENDDO
c                     BFBETA(IS,M)=BFBETAISM
c                  ENDDO
C ----------------- GAMMA(IS,M) -----
                  IF     (NBHI== 1) THEN
                     GAMMAM=0.196731007326674604
                     GAMMA(1,M)=GAMMAM
                     GAMMA(2,M)=GAMMAM
                     GAMMA(3,M)=GAMMAM
                  ELSEIF (NBHI== 2) THEN
                     GAMMAM=0.196731007326674604
                     GAMMA(1,M)=GAMMAM
                     GAMMA(2,M)=GAMMAM
                     GAMMA(3,M)=GAMMAM
                  ELSEIF (NBHI==NS) THEN
                     GAMMA(1,M)=0.305
                     GAMMA(2,M)=0.103
                     GAMMA(3,M)=0.235
                  ENDIF
C ----------------- OMEGA(IS,JS,M) -----
                  OMEGA(1,1,M)=GAMMA(1,M)*AINV(1,1,M)*GAMMA(1,M)
                  OMEGA(1,2,M)=GAMMA(1,M)*AINV(1,2,M)*GAMMA(2,M)
                  OMEGA(1,3,M)=GAMMA(1,M)*AINV(1,3,M)*GAMMA(3,M)
                  OMEGA(2,1,M)=GAMMA(2,M)*AINV(2,1,M)*GAMMA(1,M)
                  OMEGA(2,2,M)=GAMMA(2,M)*AINV(2,2,M)*GAMMA(2,M)
                  OMEGA(2,3,M)=GAMMA(2,M)*AINV(2,3,M)*GAMMA(3,M)
                  OMEGA(3,1,M)=GAMMA(3,M)*AINV(3,1,M)*GAMMA(1,M)
                  OMEGA(3,2,M)=GAMMA(3,M)*AINV(3,2,M)*GAMMA(2,M)
                  OMEGA(3,3,M)=GAMMA(3,M)*AINV(3,3,M)*GAMMA(3,M)
c                  DO IS=1,NS
c                     DO JS=1,NS
c                        OMEGA(IS,JS,M)=
c     &                            -GAMMA(IS,M)*AINV(IS,JS,M)*GAMMA(JS,M)
c                     ENDDO
c                  ENDDO
               ENDIF
            ENDDO

         ENDIF

      ENDIF

      EXPM=ORDERP1/EMBORDERP1
      EXPERR=1.0/ORDERP1

      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE COEF
C-----------------------------------------------------------------------
