      SUBROUTINE COMPUTEDEV(T,NY,NU,NV,Y,ECN,DEVCN,IDEVCN,LDEV,DEV,
     &                      E0,UROUND,RPAR,IPAR)
C-----------------------------------------------------------------------
C     COMPUTE QUANTITIES NEEDED FOR THE APPROXIMATE JACOBIAN Ev (DEV) 
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      REAL   , INTENT(IN   ) :: T
      INTEGER, INTENT(IN   ) :: NY
      INTEGER, INTENT(IN   ) :: NU
      INTEGER, INTENT(IN   ) :: NV
      REAL   , INTENT(INOUT) :: Y(NY) ! actually not an OUTPUT 
      EXTERNAL                  ECN
      EXTERNAL                  DEVCN
      INTEGER, INTENT(IN   ) :: IDEVCN
      INTEGER, INTENT(IN   ) :: LDEV
      REAL   , INTENT(  OUT) :: DEV(LDEV)
      REAL   , INTENT(IN   ) :: E0(NV)
      REAL   , INTENT(IN   ) :: UROUND
      REAL   , INTENT(IN   ) :: RPAR(*)
      INTEGER, INTENT(IN   ) :: IPAR(*)
C    LOCAL VARIABLES
      INTEGER                :: INDDEV,J,NUPJ
      REAL                   :: DELT,VJSAVE
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE COMPUTEDEV
C-----------------------------------------------------------------------
      IF     (IDEVCN==0) THEN
C -------- COMPUTE MATRIX OF PARTIAL DERIVATIVES Ev NUMERICALLY -----
C -------- DEV IS FULL                                          -----
         DO J=1,NV
            NUPJ=NU+J
            VJSAVE=Y(NUPJ)
            DELT=SQRT(UROUND*MAX(1.E-5,ABS(VJSAVE)))
            Y(NUPJ)=VJSAVE+DELT
            INDDEV=(J-1)*NV+1
            CALL ECN(T,NY,NU,NV,Y    ,DEV(INDDEV),RPAR,IPAR)
            CALL DAXPY(NV  ,-1.0,E0,1,DEV(INDDEV),1)
            CALL DSCAL(NV  ,1.0/DELT ,DEV(INDDEV),1)
            Y(NUPJ)=VJSAVE
         ENDDO
      ELSEIF (IDEVCN==1) THEN
C -------- COMPUTE QUANTITIES NEEDED FOR THE APPROXIMATE JACOBIAN Ev WITH DEVCN -----
         CALL DEVCN(T,NY,NU,NV,Y,LDEV,DEV,RPAR,IPAR)
      ELSEIF (IDEVCN==2) THEN
C -------- NO COMPUTATION FOR Ev REQUIRED -----
      ENDIF

      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE COMPUTEDEV
C-----------------------------------------------------------------------
