      SUBROUTINE COMPUTEDFYM(M,T,NY,NU,NV,Y,FCNM,DFYCNM,IDFMYCN,
     &                       IDFMYVECCN,LDFMY,DFMY,
     &                       FM0,UROUND,RPAR,IPAR)
C-----------------------------------------------------------------------
C     COMPUTE QUANTITIES NEEDED FOR THE APPROXIMATE JACOBIAN Fmy (DFMY)
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: M
      REAL   , INTENT(IN   ) :: T
      INTEGER, INTENT(IN   ) :: NY
      INTEGER, INTENT(IN   ) :: NU
      INTEGER, INTENT(IN   ) :: NV
      REAL   , INTENT(INOUT) :: Y(NY) ! actually not an OUTPUT 
      EXTERNAL                  FCNM
      EXTERNAL                  DFYCNM
      INTEGER, INTENT(IN   ) :: IDFMYCN
      INTEGER, INTENT(IN   ) :: IDFMYVECCN
      INTEGER, INTENT(IN   ) :: LDFMY
      REAL   , INTENT(  OUT) :: DFMY(LDFMY)
      REAL   , INTENT(  OUT) :: FM0(NY)
      REAL   , INTENT(IN   ) :: UROUND
      REAL   , INTENT(IN   ) :: RPAR(*)
      INTEGER, INTENT(IN   ) :: IPAR(*)
C    LOCAL VARIABLES
      INTEGER                :: INDDFMY,J
      REAL                   :: DELT,YJSAVE
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE COMPUTEDFYM
C-----------------------------------------------------------------------
      IF     (IDFMYCN==0) THEN
         IF (IDFMYVECCN/=1) THEN
            CALL FCNM(M,T,NY,NU,NV,Y,FM0,RPAR,IPAR)
         ENDIF
C -------- COMPUTE MATRICES OF PARTIAL DERIVATIVES Fmy NUMERICALLY -----
C -------- DFY IS FULL                                             -----
         DO J=1,NY
            YJSAVE=Y(J)
            DELT=SQRT(UROUND*MAX(1.E-5,ABS(YJSAVE)))
            Y(J)=YJSAVE+DELT
            INDDFMY=(J-1)*NY+1
            CALL FCNM(M,T,NY,NU,NV,Y,DFMY(INDDFMY),RPAR,IPAR)
            CALL DAXPY(NY,-1.0,FM0,1,DFMY(INDDFMY),1)
            CALL DSCAL(NY,1.0/DELT  ,DFMY(INDDFMY),1)
            Y(J)=YJSAVE
         ENDDO
      ELSEIF (IDFMYCN==1) THEN
C -------- COMPUTE QUANTITIES NEEDED FOR THE APPROXIMATE JACOBIANS Fmy WITH DFYCNM -----
         CALL DFYCNM(M,T,NY,NU,NV,Y,LDFMY,DFMY,RPAR,IPAR)
      ELSEIF (IDFMYCN==2) THEN
C -------- NO COMPUTATION FOR Fmy REQUIRED -----
      ENDIF

      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE COMPUTEDFYM
C-----------------------------------------------------------------------
