      FUNCTION CONTRY(I,T,YTAG,NY,Y,NS,ISNY,C,IC1CS,
     &                HSOLY,TSOLY,NCONTY,CONTY)
C-----------------------------------------------------------------------
C     THE FOLLOWING FUNCTION CONTRY CAN BE USED FOR CONTINUOUS OUTPUT. 
C     IT PROVIDES AN APPROXIMATION TO THE I-TH COMPONENT OF THE 
C     SOLUTION AT T. IT GIVES THE VALUE OF THE DENSE OUTPUT POLYNOMIAL, 
C     DEFINED FOR THE LAST SUCCESSFULLY COMPUTED STEP BY SPARK3.
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      REAL                   :: CONTRY
      INTEGER, INTENT(IN   ) :: I
      REAL   , INTENT(IN   ) :: T
      LOGICAL, INTENT(IN   ) :: YTAG
      INTEGER, INTENT(IN   ) :: NY
      REAL   , INTENT(IN   ) :: Y(NY)
      INTEGER, INTENT(IN   ) :: NS
      INTEGER, INTENT(IN   ) :: ISNY(NS)
      REAL   , INTENT(IN   ) :: C(NS)
      INTEGER, INTENT(IN   ) :: IC1CS
      REAL   , INTENT(IN   ) :: HSOLY
      REAL   , INTENT(IN   ) :: TSOLY
      INTEGER, INTENT(IN   ) :: NCONTY
      REAL   , INTENT(IN   ) :: CONTY(NCONTY)
C    LOCAL VARIABLES
      REAL                   :: X
C-----------------------------------------------------------------------
C    BEGINNING OF FUNCTION CONTRY
C-----------------------------------------------------------------------
      X=(T-TSOLY)/HSOLY
      IF (YTAG) THEN
         CONTRY=Y(I)
      ELSE
         CONTRY=0.0
      ENDIF

      IF (NS==3) THEN

         IF     (IC1CS==0) THEN
C ----------- WHEN C(NS) =1.0 AND C(1) =0.0 -----
            CONTRY=CONTRY+
     &             (X-1.0)*(CONTY(I)+
     &                      (X-C( 2))*(CONTY(ISNY(1)+I)))
         ELSEIF (IC1CS==1) THEN
C ----------- WHEN C(NS) =1.0 AND C(1)<>0.0 -----
            CONTRY=CONTRY+
     &             (X-1.0)*(CONTY(I)+
     &                      (X-C( 2))*(CONTY(ISNY(1)+I)+
     &                                 (X-C(1))*CONTY(ISNY(2)+I)))
         ELSEIF (IC1CS==2) THEN
C ----------- WHEN C(NS)<>1.0               -----
            CONTRY=CONTRY+
     &             (X-1.0)*(CONTY(I)+
     &                      (X-C(NS))*(CONTY(ISNY(1)+I)+
     &                                 (X-C(2))*CONTY(ISNY(2)+I)))
         ENDIF

      ENDIF

      RETURN
C-----------------------------------------------------------------------
      END FUNCTION CONTRY
C-----------------------------------------------------------------------
