      SUBROUTINE DENSEOUTPUT(NS,NY,NCONTY,CONTY,ZY,ZNY,ISNY,
     &                       IC1CS,C,CINV)
C-----------------------------------------------------------------------
C     FILL CONTY FOR DENSE OUTPUT 
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: NS
      INTEGER, INTENT(IN   ) :: NY
      INTEGER, INTENT(IN   ) :: NCONTY
      REAL   , INTENT(  OUT) :: CONTY(NCONTY)
      REAL   , INTENT(IN   ) :: ZY(NY,NS)
      REAL   , INTENT(IN   ) :: ZNY(NY)
      INTEGER, INTENT(IN   ) :: ISNY(NS)
      INTEGER, INTENT(IN   ) :: IC1CS
      REAL   , INTENT(IN   ) :: C(NS)
      REAL   , INTENT(IN   ) :: CINV(NS)
C    LOCAL VARIABLES
      INTEGER                :: N1YP1,N2YP1
      REAL                   :: C1INV,C2INV,CSINV,C2MC1,CSMC2,C1M1,C2M1
      REAL                   :: CSM1,C1M1INV,C2M1INV,C2MC1INV,CSM1INV
      REAL                   :: CSMC2INV,ONEMC2INV,ONEMCSINV
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE DENSEOUTPUT
C-----------------------------------------------------------------------
      IF (NS==3) THEN

         N1YP1=ISNY(1)+1
         N2YP1=ISNY(2)+1
         C1INV=CINV(1)
         C2INV=CINV(2)
         CSINV=CINV(NS)
         C2MC1=C( 2)-C(1)
         CSMC2=C(NS)-C(2)
         C1M1=C( 1)-1.0
         C2M1=C( 2)-1.0
         CSM1=C(NS)-1.0
         C1M1INV=1.0/C1M1
         C2M1INV=1.0/C2M1
         ONEMC2INV=-C2M1INV
         C2MC1INV=1.0/C2MC1
         CSMC2INV=1.0/CSMC2
         CSM1INV=1.0/CSM1
         ONEMCSINV=-CSM1INV

         IF     (IC1CS==0) THEN
C -------- C(NS) =1.0 (ZSY REPLACED BY ZNY) -----
C -------- C( 1) =0.0 (Z1Y REPLACED BY 0)   -----
C -------- FOR CONTRY WHEN IC1CS=0          -----
           CALL DCOPY(NY              ,ZY(1, 2),1,CONTY(    1),1)
           CALL DAXPY(NY,-1.0         ,ZNY     ,1,CONTY(    1),1)
           CALL DSCAL(NY, C2M1INV                ,CONTY(    1),1)
           CALL DCOPY(NY              ,ZY(1, 2),1,CONTY(N1YP1),1)
           CALL DSCAL(NY,-C2INV                  ,CONTY(N1YP1),1)
           CALL DAXPY(NY, 1.0     ,CONTY(    1),1,CONTY(N1YP1),1)
         ELSEIF (IC1CS==1) THEN
C -------- C(NS) =1.0 (ZSY REPLACED BY ZNY) -----
C -------- C( 1)<>0.0 -----
           CALL DCOPY(NY              ,ZNY     ,1,CONTY(    1),1)
           CALL DAXPY(NY,-1.0         ,ZY(1, 2),1,CONTY(    1),1)
           CALL DSCAL(NY, ONEMC2INV              ,CONTY(    1),1)
           CALL DCOPY(NY              ,ZY(1, 2),1,CONTY(N1YP1),1)
           CALL DAXPY(NY,-1.0         ,ZY(1, 1),1,CONTY(N1YP1),1)
           CALL DSCAL(NY, C2MC1INV               ,CONTY(N1YP1),1)
           CALL DCOPY(NY              ,ZY(1, 1),1,CONTY(N2YP1),1)
           CALL DSCAL(NY, C1INV                  ,CONTY(N2YP1),1)
           CALL DAXPY(NY,-1.0     ,CONTY(N1YP1),1,CONTY(N2YP1),1)
           CALL DSCAL(NY, C2INV                  ,CONTY(N2YP1),1)
C                                 warning: the following 1 are not typos
           CALL DAXPY(NY,-1.0     ,CONTY(    1),1,CONTY(N1YP1),1)
           CALL DSCAL(NY, C1M1INV                ,CONTY(N1YP1),1)
C                                 warning: the following 2 is  not a typo
           CALL DAXPY(NY, 1.0     ,CONTY(N1YP1),1,CONTY(N2YP1),1)
         ELSEIF (IC1CS==2) THEN
C -------- CS<>1.0 -----
           CALL DCOPY(NY              ,ZNY     ,1,CONTY(    1),1)
           CALL DAXPY(NY,-1.0         ,ZY(1,NS),1,CONTY(    1),1)
           CALL DSCAL(NY, ONEMCSINV              ,CONTY(    1),1)
           CALL DCOPY(NY              ,ZY(1,NS),1,CONTY(N1YP1),1)
           CALL DAXPY(NY,-1.0         ,ZY(1, 2),1,CONTY(N1YP1),1)
           CALL DSCAL(NY, CSMC2INV               ,CONTY(N1YP1),1)
           CALL DCOPY(NY              ,ZY(1, 2),1,CONTY(N2YP1),1)
           CALL DSCAL(NY, C2INV                  ,CONTY(N2YP1),1)
           CALL DAXPY(NY,-1.0     ,CONTY(N1YP1),1,CONTY(N2YP1),1)
           CALL DSCAL(NY, CSINV                  ,CONTY(N2YP1),1)
C                                 warning: the following 1 are not typos
           CALL DAXPY(NY,-1.0     ,CONTY(    1),1,CONTY(N1YP1),1)
           CALL DSCAL(NY, C2M1INV                ,CONTY(N1YP1),1)
C                                 warning: the following 2 is  not a typo
           CALL DAXPY(NY, 1.0     ,CONTY(N1YP1),1,CONTY(N2YP1),1)
         ENDIF

      ENDIF

      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE DENSEOUTPUT
C-----------------------------------------------------------------------
