      SUBROUTINE DEVVECFD(T,NY,NU,NV,Y,ECN,DELTV,VPTR,TMPNY,E0,
     &                    VEC,DEVVEC,RPAR,IPAR)
C-----------------------------------------------------------------------
C     COMPUTE THE JACOBIAN Ev-VECTOR PRODUCT BY
C     FINITE DIFFERENCES ON e(t,y): 
C     DEVVEC ~= e_v*VEC
C     THIS SUBROUTINE IS USED IN SPARK WHEN IDEVVECCN=1
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      REAL   , INTENT(IN   ) :: T
      INTEGER, INTENT(IN   ) :: NY
      INTEGER, INTENT(IN   ) :: NU
      INTEGER, INTENT(IN   ) :: NV
      REAL   , INTENT(IN   ) :: Y(NY)
      EXTERNAL                  ECN
      REAL   , INTENT(IN   ) :: DELTV
      INTEGER, INTENT(IN   ) :: VPTR
      REAL   , INTENT(  OUT) :: TMPNY(NY)
      REAL   , INTENT(IN   ) :: E0(NV)
      REAL   , INTENT(IN   ) :: VEC(NV)
      REAL   , INTENT(  OUT) :: DEVVEC(NV)
      REAL   , INTENT(IN   ) :: RPAR(*)
      INTEGER, INTENT(IN   ) :: IPAR(*)
C    LOCAL VARIABLES
      REAL                   :: DELTVEC,DNORMVEC
C    LEVEL 1 BLAS FUNCTIONS
      DOUBLE PRECISION       :: DNRM2
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE DEVVECFD
C-----------------------------------------------------------------------
      DNORMVEC=DNRM2(NV,VEC,1)
      IF (DNORMVEC>=0.0) THEN
         DELTVEC=DELTV/DNORMVEC
         CALL DCOPY(NY        ,Y  ,1,TMPNY      ,1)
         CALL DAXPY(NV,DELTVEC,VEC,1,TMPNY(VPTR),1)
         CALL ECN(T,NY,NU,NV        ,TMPNY,DEVVEC,RPAR,IPAR)
         CALL DAXPY(NV,-1.0,E0,1          ,DEVVEC,1)
         CALL DSCAL(NV,1.0/DELTVEC        ,DEVVEC,1)
      ELSE
c ----- VEC is the zero vector -----
c         DEVVEC=0.0
         CALL DSCAL(NV,0.0                ,DEVVEC,1)
      ENDIF

      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE DEVVECFD
C-----------------------------------------------------------------------
