      SUBROUTINE DFYVECFDM(M,T,NY,NU,NV,Y,FCNM,DELTY,TMPNY,FM0,
     &                     VEC,DFMYVEC,RPAR,IPAR)
C-----------------------------------------------------------------------
C     APPROXIMATE THE mth JACOBIAN Fmy-VECTOR PRODUCT BY
C     FINITE DIFFERENCES ON f_m(t,y): 
C     DFMYVEC ~= f_{my}*VEC
C     THIS SUBROUTINE IS USED IN SPARK WHEN IDFYVECCNM(M)=1
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: M
      REAL   , INTENT(IN   ) :: T
      INTEGER, INTENT(IN   ) :: NY
      INTEGER, INTENT(IN   ) :: NU
      INTEGER, INTENT(IN   ) :: NV
      REAL   , INTENT(IN   ) :: Y(NY)
      EXTERNAL                  FCNM
      REAL   , INTENT(IN   ) :: DELTY
      REAL   , INTENT(  OUT) :: TMPNY(NY)
      REAL   , INTENT(IN   ) :: FM0(NY)
      REAL   , INTENT(IN   ) :: VEC(NY)
      REAL   , INTENT(  OUT) :: DFMYVEC(NY)
      REAL   , INTENT(IN   ) :: RPAR(*)
      INTEGER, INTENT(IN   ) :: IPAR(*)
C    LOCAL VARIABLES
      REAL                   :: DELTVEC,DNORMVEC
C    LEVEL 1 BLAS FUNCTIONS
      DOUBLE PRECISION       :: DNRM2
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE DFYVECFDM
C-----------------------------------------------------------------------
      DNORMVEC=DNRM2(NY,VEC,1)
      IF (DNORMVEC>=0.0) THEN
         DELTVEC=DELTY/DNORMVEC
c         TMPNY=Y+VEC
         CALL DCOPY(NY        ,Y  ,1,TMPNY        ,1)
         CALL DAXPY(NY,DELTVEC,VEC,1,TMPNY        ,1)
         CALL FCNM(M,T,NY,NU,NV     ,TMPNY,DFMYVEC,RPAR,IPAR)
         CALL DAXPY(NY,-1.0,FM0,1         ,DFMYVEC,1)
         CALL DSCAL(NY,1.0/DELTVEC        ,DFMYVEC,1)
      ELSE
c ----- VEC is the zero vector -----
c         DFMYVEC=0.0
         CALL DSCAL(NY,0.0                ,DFMYVEC,1)
      ENDIF

      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE DFYVECFDM
C-----------------------------------------------------------------------
