       SUBROUTINE ERROREST(IERRJAC,ERR,
     &                     EXPM,ERRFAC,FACNORMNY,
     &                     NS,NY,NU,NV,Y,PRECSOL,RTOLY,ATOLY,ITOLY,
     &                     ISTEPSIZE,RPAR,ERRC,
     &                     ZY,ZNY, LBHIS, BHIERRJAC,IPAR,
     &                            LIBHIS,IBHIERRJAC,
     &                     TMPNY,SCALYINV)
C-----------------------------------------------------------------------
C     ERROR ESTIMATION
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: IERRJAC
      REAL   , INTENT(  OUT) :: ERR
      REAL   , INTENT(IN   ) :: EXPM
      REAL   , INTENT(IN   ) :: ERRFAC
      REAL   , INTENT(IN   ) :: FACNORMNY
      INTEGER, INTENT(IN   ) :: NS
      INTEGER, INTENT(IN   ) :: NY
      INTEGER, INTENT(IN   ) :: NU
      INTEGER, INTENT(IN   ) :: NV
      REAL   , INTENT(IN   ) :: Y(NY)
      EXTERNAL                  PRECSOL
      REAL   , INTENT(IN   ) :: RTOLY(*)
      REAL   , INTENT(IN   ) :: ATOLY(*)
      INTEGER, INTENT(IN   ) :: ITOLY
      INTEGER, INTENT(IN   ) :: ISTEPSIZE
      REAL   , INTENT(IN   ) :: RPAR(*)
      REAL   , INTENT(IN   ) :: ERRC(NS+1)
      REAL   , INTENT(IN   ) :: ZY(NY,NS)
      REAL   , INTENT(IN   ) :: ZNY(NY)
      INTEGER, INTENT(IN   ) :: LBHIS
      REAL   , INTENT(IN   ) :: BHIERRJAC(LBHIS)
      INTEGER, INTENT(IN   ) :: IPAR(*)
      INTEGER, INTENT(IN   ) :: LIBHIS
      INTEGER, INTENT(IN   ) :: IBHIERRJAC(LIBHIS)
      REAL   , INTENT(  OUT) :: TMPNY(NY)
      REAL   , INTENT(  OUT) :: SCALYINV(NY)
C    LOCAL VARIABLES
      INTEGER                :: I,IS
C    LEVEL 1 BLAS FUNCTIONS
      DOUBLE PRECISION       :: DNRM2
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE ERROREST
C-----------------------------------------------------------------------
      IF (ISTEPSIZE/=1) THEN
         CALL COMPUTESCAL(NY,Y,RTOLY,ATOLY,ITOLY,.TRUE.,ZY(1,NS),ZNY,
     &                    SCALYINV)
c         TMPNY=0.0
         CALL    DSCAL(NY,0.0                  ,TMPNY,1)
         DO IS=1,NS
            CALL DAXPY(NY,ERRC(  IS),ZY(1,IS),1,TMPNY,1)
         ENDDO
            CALL DAXPY(NY,ERRC(NS+1),ZNY     ,1,TMPNY,1)
         CALL PRECSOL(IERRJAC,NY,NU,NV,BHIERRJAC,IBHIERRJAC,
     &                TMPNY,RPAR,IPAR)
         DO I=1,NY
            TMPNY(I)=(ABS(TMPNY(I))**EXPM)*SCALYINV(I)
         ENDDO
         ERR=ERRFAC*DNRM2(NY,TMPNY,1)*FACNORMNY
         ERR=MAX(ERR,1.E-10)
      ENDIF

      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE ERROREST
C-----------------------------------------------------------------------
