       SUBROUTINE GIVENS(A,B,C,S)
C-----------------------------------------------------------------------
C    COMPUTE GIVENS ROTATION GIVEN BY C AND S SUCH THAT
C
C    [ C S] [A]   [*]
C    [-S C] [B]   [0]
C
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      REAL   , INTENT(IN   ) :: A  ! FIRST  COMPONENT OF 2x1 VECTOR
      REAL   , INTENT(IN   ) :: B  ! SECOND COMPONENT OF 2x1 VECTOR TO BE ANNIHILATED
      REAL   , INTENT(  OUT) :: C  ! COSINE OF GIVENS ROTATION
      REAL   , INTENT(  OUT) :: S  !   SINE OF GIVENS ROTATION
C    LOCAL VARIABLES
      REAL                   :: TEMP
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE GIVENS
C-----------------------------------------------------------------------
      IF     (B==0.0)        THEN
         C=1.0
         S=0.0
      ELSEIF (ABS(B)>ABS(A)) THEN
         TEMP=A/B
         S=1.0/SQRT(1.0+TEMP**2)
         C=TEMP*S
      ELSE
         TEMP=B/A
         C=1.0/SQRT(1.0+TEMP**2)
         S=TEMP*C
      ENDIF

      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE GIVENS
C-----------------------------------------------------------------------