      SUBROUTINE INITCONSTANTS(NM,LDFYM,MAXNEWT,NSTEP,NY,NU,NV,NBIGSYS,
     &         NS,C,CINV,ABSHMIN,ABSHMAX,T,TEND,THETADNEWEVAL,
     &         IRTRN,KDFYM,CFAC,FACNORMNY,FACNORMNBIGSYS,
     &         NSM1,NSP1,VPTR,VNPTR,C1EQ0,IC1CS,
     &         ISNY,ISM1TNYP1,FIRST,REJECTITER,REJECTERR,
     &         POSNEG,H,HNEWFACINV,DIVERGING,CONVRESTRICT,
     &         THETADNEWEVALEQ0,HOLD,TOLD,THETAOLD,THETA)
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: NM
      INTEGER, INTENT(IN   ) :: LDFYM(NM)
      INTEGER, INTENT(IN   ) :: MAXNEWT
      INTEGER, INTENT(  OUT) :: NSTEP
      INTEGER, INTENT(IN   ) :: NY
      INTEGER, INTENT(IN   ) :: NU
      INTEGER, INTENT(IN   ) :: NV
      INTEGER, INTENT(IN   ) :: NBIGSYS
      INTEGER, INTENT(IN   ) :: NS
      REAL   , INTENT(IN   ) :: C(NS)
      REAL   , INTENT(  OUT) :: CINV(NS)
      REAL   , INTENT(IN   ) :: ABSHMIN
      REAL   , INTENT(IN   ) :: ABSHMAX
      REAL   , INTENT(IN   ) :: T
      REAL   , INTENT(IN   ) :: TEND
      REAL   , INTENT(IN   ) :: THETADNEWEVAL
      INTEGER, INTENT(  OUT) :: IRTRN
      INTEGER, INTENT(  OUT) :: KDFYM(NM)
      REAL   , INTENT(  OUT) :: CFAC
      REAL   , INTENT(  OUT) :: FACNORMNY
      REAL   , INTENT(  OUT) :: FACNORMNBIGSYS
      INTEGER, INTENT(  OUT) :: NSM1
      INTEGER, INTENT(  OUT) :: NSP1
      INTEGER, INTENT(  OUT) :: VPTR
      INTEGER, INTENT(  OUT) :: VNPTR
      LOGICAL, INTENT(  OUT) :: C1EQ0
      INTEGER, INTENT(  OUT) :: IC1CS
      INTEGER, INTENT(  OUT) :: ISNY(NS)
      INTEGER, INTENT(  OUT) :: ISM1TNYP1(NS)
      LOGICAL, INTENT(  OUT) :: FIRST
      LOGICAL, INTENT(  OUT) :: REJECTITER
      LOGICAL, INTENT(  OUT) :: REJECTERR
      REAL   , INTENT(  OUT) :: POSNEG
      REAL   , INTENT(  OUT) :: H
      REAL   , INTENT(  OUT) :: HNEWFACINV
      LOGICAL, INTENT(  OUT) :: DIVERGING
      LOGICAL, INTENT(  OUT) :: CONVRESTRICT
      LOGICAL, INTENT(  OUT) :: THETADNEWEVALEQ0
      REAL   , INTENT(  OUT) :: HOLD
      REAL   , INTENT(  OUT) :: TOLD
      REAL   , INTENT(  OUT) :: THETAOLD
      REAL   , INTENT(  OUT) :: THETA
C    LOCAL VARIABLES
      INTEGER                :: IS,KDFMY,M
      LOGICAL                :: CSEQ1
      REAL                   :: DUMMY
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE INITCONSTANTS
C-----------------------------------------------------------------------
      NSTEP=0
      KDFMY=1
      DO M=1,NM
         KDFYM(M)=KDFMY
         KDFMY=KDFMY+LDFYM(M)
      ENDDO
      IRTRN=1
      CFAC=REAL(1+2*MAXNEWT)
      FACNORMNY     =1.0/SQRT(REAL(NY))
      FACNORMNBIGSYS=1.0/SQRT(REAL(NBIGSYS))
C ----- ISNY(NS),IC1CS ARE USED IN CONTRY                            -----
C ----- IC1CS DETERMINES WHICH CONTINUOUS SOLUTION IS USED IN CONTRY -----
C ----- DEPENDING ON THE VALUES OF C(1) AND C(NS)                    -----
      C1EQ0=(C( 1)==0.0)
      CSEQ1=(C(NS)==1.0)
      DO IS=1,NS
         ISNY(IS)     =IS*NY
         ISM1TNYP1(IS)=(IS-1)*NY+1
      ENDDO
      NSM1  =NS-1
      NSP1  =NS+1
      IF (NV>0) THEN
         VPTR=NU+1
         VNPTR=NY*NS+1
      ELSE
         VPTR=1  ! dummy value
         VNPTR=1 ! dummy value
      ENDIF
      DUMMY=1.E10
      DO IS=1,NS
         IF (.NOT.(C(IS)==0.0)) THEN
            CINV(IS)=1.0/C(IS)
         ELSE
            CINV(IS)=DUMMY
         ENDIF
      ENDDO
      IF (CSEQ1) THEN
         IF (C1EQ0) THEN
            IC1CS=0
         ELSE
            IC1CS=1
         ENDIF
      ELSE
            IC1CS=2
      ENDIF
      FIRST     =.TRUE.
      REJECTITER=.FALSE.
      REJECTERR =.FALSE.
C ----- POSNEG: DIRECTION OF TIME INTEGRATION -----
      POSNEG=SIGN(1.0,TEND-T)
      H=POSNEG*MAX(ABSHMIN,MIN(ABS(H),ABSHMAX,ABS(TEND-T)))
      HNEWFACINV=1.0
      DIVERGING   =.FALSE.
      CONVRESTRICT=.TRUE.
      THETADNEWEVALEQ0=(THETADNEWEVAL==0.0)
      HOLD=H
      TOLD=T
      THETAOLD=0.0
      THETA   =1.0

      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE INITCONSTANTS
C-----------------------------------------------------------------------
