      SUBROUTINE MATVECPROD(NM,ME,T,NY,NU,NV,LNV,NVGE1,Y,
     &   FCNM,DFYVECCNM,IDFYVECCNM,KDFYM,LDFYM,LDFY,DFY,
     &   ECN ,DEVVECCN ,IDEVVECCN             ,LDEV,DEV,
     &   H,
     &   RPAR,IPAR,
     &   NS,A,BETA,BFBETA,STIFFLYACC,
     &   TMPNY,
     &   F0M,E0,
     &   VECMIS,DFMYVECMIS,
     &   SOLVEVN,
     &   XK,XKN,VEC,VECN,
     &   DELTY,DELTV,VPTR)
C-----------------------------------------------------------------------
C     PERFORM THE MATRIX-VECTOR PRODUCT
C     VEC_ <-- K*XK_
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: NM
      INTEGER, INTENT(IN   ) :: ME(NM)
      REAL   , INTENT(IN   ) :: T
      INTEGER, INTENT(IN   ) :: NY
      INTEGER, INTENT(IN   ) :: NU
      INTEGER, INTENT(IN   ) :: NV
      INTEGER, INTENT(IN   ) :: LNV
      LOGICAL, INTENT(IN   ) :: NVGE1
      REAL   , INTENT(IN   ) :: Y(NY)
      EXTERNAL                  FCNM
      EXTERNAL                  DFYVECCNM
      INTEGER, INTENT(IN   ) :: IDFYVECCNM(NM)
      INTEGER, INTENT(IN   ) :: KDFYM(NM)
      INTEGER, INTENT(IN   ) :: LDFYM(NM)
      INTEGER, INTENT(IN   ) :: LDFY
      REAL   , INTENT(IN   ) :: DFY(LDFY)
      EXTERNAL                  ECN
      EXTERNAL                  DEVVECCN
      INTEGER, INTENT(IN   ) :: IDEVVECCN
      INTEGER, INTENT(IN   ) :: LDEV
      REAL   , INTENT(IN   ) :: DEV(LDEV)
      REAL   , INTENT(IN   ) :: H
      REAL   , INTENT(IN   ) :: RPAR(*)
      INTEGER, INTENT(IN   ) :: IPAR(*)
      INTEGER, INTENT(IN   ) :: NS
      REAL   , INTENT(IN   ) :: A(NS,NS,NM)
      REAL   , INTENT(IN   ) :: BETA(NS)
      REAL   , INTENT(IN   ) :: BFBETA(NS,NM)
      INTEGER, INTENT(IN   ) :: STIFFLYACC(NM)
      REAL   , INTENT(  OUT) :: TMPNY(NY)
      REAL   , INTENT(IN   ) :: F0M(NY,NM)
      REAL   , INTENT(IN   ) :: E0(LNV)
      REAL   , INTENT(  OUT) :: VECMIS(NY)
      REAL   , INTENT(  OUT) :: DFMYVECMIS(NY)
      LOGICAL, INTENT(IN   ) :: SOLVEVN
      REAL   , INTENT(IN   ) :: XK(NY,NS)
      REAL   , INTENT(IN   ) :: XKN(LNV)
      REAL   , INTENT(  OUT) :: VEC(NY,NS)
      REAL   , INTENT(  OUT) :: VECN(LNV)
      REAL   , INTENT(IN   ) :: DELTY
      REAL   , INTENT(IN   ) :: DELTV
      INTEGER, INTENT(IN   ) :: VPTR
C    LOCAL VARIABLES
      INTEGER                :: IS,JS,M
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE MATVECPROD
C-----------------------------------------------------------------------
      IF (SOLVEVN) THEN
            CALL DEVVECSP(T,NY,NU,NV,Y,        ECN,DEVVECCN,IDEVVECCN,
     &                    DELTV,VPTR,TMPNY,E0,
     &                    LDEV,DEV,XKN        ,VECN        ,RPAR,IPAR)
      ENDIF

      DO IS=1,NS
         CALL DCOPY(NU,XK(1,IS),1,VEC(1,IS),1)
         IF (NVGE1) THEN
            CALL DEVVECSP(T,NY,NU,NV,Y,        ECN,DEVVECCN,IDEVVECCN,
     &                    DELTV,VPTR,TMPNY,E0,
     &                    LDEV,DEV,XK(VPTR,IS),VEC(VPTR,IS),RPAR,IPAR)
            IF (SOLVEVN) THEN
               CALL DAXPY(NV,-BETA(IS),VEC(VPTR,IS),1,VECN,1)
            ENDIF
         ENDIF
         DO M=1,NM
            IF (A(IS,IS,M)/=0.0) THEN
               CALL DCOPY(NY,XK(1,IS),1,VECMIS,1)
            ENDIF
            CALL    DSCAL(NY,A(IS,IS,M),VECMIS,1)
            DO JS=1,NS
               IF (JS/=IS) THEN
                  CALL DAXPY(NY,A(IS,JS,M),XK(1,JS),1,VECMIS,1)
               ENDIF
            ENDDO
            CALL DFYVECSPM(M,T,NY,NU,NV,Y,FCNM,DFYVECCNM,IDFYVECCNM,
     &                     DELTY,TMPNY,F0M(1,M),LDFYM(M),DFY(KDFYM(M)),
     &                     VECMIS,DFMYVECMIS,RPAR,IPAR)
            CALL DAXPY(NY,-H,DFMYVECMIS,1,VEC(1,IS),1)
         ENDDO
      ENDDO

      IF (SOLVEVN) THEN
         DO M=1,NM
            IF (STIFFLYACC(M)==0) THEN
               CALL DSCAL(NY,0.0,VECMIS,1)
               DO JS=1,NS
                  CALL DAXPY(NY,BFBETA(JS,M),XK(1,JS),1,VECMIS,1)
               ENDDO
               CALL DFYVECSPM(M,T,NY,NU,NV,Y,FCNM,DFYVECCNM,IDFYVECCNM,
     &                        DELTY,TMPNY,F0M(1,M),
     &                        LDFYM(M),DFY(KDFYM(M)),
     &                        VECMIS,DFMYVECMIS,RPAR,IPAR)
               CALL DAXPY(NV,-H,DFMYVECMIS(VPTR),1,VECN,1)
            ENDIF
         ENDDO
      ENDIF

      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE MATVECPROD
C-----------------------------------------------------------------------
