      SUBROUTINE NEWSTEPSIZE(ISTEPSIZE,HNEWFACINV,ERR,EXPERR,
     &                       FIRST,CONVRESTRICT,NEWT,MAXNEWT,
     &                       SAFE,CFAC,FACR,FACL,H,NSTEP,
     &                       HACCEPT,          ERRACCEPT,
     &                       HREJECT,REJECTERR,ERRREJECT,
     &                       CALJAC,CALJACVN)
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: ISTEPSIZE
      REAL   , INTENT(INOUT) :: HNEWFACINV
      REAL   , INTENT(IN   ) :: ERR
      REAL   , INTENT(IN   ) :: EXPERR
      LOGICAL, INTENT(IN   ) :: FIRST
      LOGICAL, INTENT(INOUT) :: CONVRESTRICT
      INTEGER, INTENT(IN   ) :: NEWT
      INTEGER, INTENT(IN   ) :: MAXNEWT
      REAL   , INTENT(IN   ) :: SAFE
      REAL   , INTENT(IN   ) :: CFAC
      REAL   , INTENT(IN   ) :: FACR
      REAL   , INTENT(IN   ) :: FACL
      REAL   , INTENT(IN   ) :: H
      INTEGER, INTENT(IN   ) :: NSTEP
      REAL   , INTENT(INOUT) :: HACCEPT
      REAL   , INTENT(INOUT) :: ERRACCEPT
      REAL   , INTENT(INOUT) :: HREJECT
      LOGICAL, INTENT(INOUT) :: REJECTERR
      REAL   , INTENT(INOUT) :: ERRREJECT
      LOGICAL, INTENT(IN   ) :: CALJAC
      LOGICAL, INTENT(IN   ) :: CALJACVN
C    LOCAL VARIABLES
      REAL                   :: EXPONENT,FACGUS,FACINV
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE NEWSTEPSIZE
C-----------------------------------------------------------------------
      IF     (ISTEPSIZE==1) THEN
C -------- CONSTANT STEP IS ACCEPTED -----
         REJECTERR=.FALSE.
         HNEWFACINV=1.0
      ELSE
         IF (ERR<=1.0) THEN
C ----------- VARIABLE STEP IS ACCEPTED -----
c            write(6,*) 'ACCEPTED NSTEP,H,ERR =',NSTEP,H,ERR
            EXPONENT=EXPERR
C ----------- COMPUTATION FOR CLASSICAL VARIABLE STEPSIZE FORMULA -----                
            FACINV=(ERR**EXPONENT)/SAFE
            IF    ((ISTEPSIZE==0).OR.(FIRST).OR.(CONVRESTRICT)) THEN
               FACINV=FACINV*REAL(NEWT+2*MAXNEWT)/CFAC
            ELSEIF (ISTEPSIZE==2) THEN
C -------------- COMPUTATION FOR PREDICTIVE STEPSIZE CONTROLLER OF GUSTAFSSON -----
               FACGUS=(HACCEPT/H)*
     &              ((1.25*ERR**2)/MAX(ERRACCEPT,0.0001))**EXPONENT
               FACINV=MAX(FACINV,FACGUS)
            ENDIF
            HACCEPT=H
            ERRACCEPT=ERR
            IF (REJECTERR) THEN
C -------------- PREVIOUS ATTEMPTED WAS REJECTED -----
               FACINV=MAX(0.9,FACINV/SAFE)
            ENDIF
            REJECTERR=.FALSE.
         ELSE
C ----------- VARIABLE STEP IS REJECTED -----
            write(6,*) 'REJECTED NSTEP,H,ERR =',NSTEP,H,ERR
            IF (REJECTERR) THEN
C -------------- PREVIOUS ATTEMPTED STEP WAS ALSO REJECTED -----
               EXPONENT=LOG(ERR/ERRREJECT)/LOG(H/HREJECT)
               EXPONENT=MIN(EXPERR,MAX(0.1,EXPONENT))
c               EXPONENT=EXPERR
            ELSE
               EXPONENT=EXPERR
c               EXPONENT=LOG(ERR/MAX(ERRACCEPT,0.0001))/LOG(H/HACCEPT)
c               EXPONENT=MIN(EXPERR,MAX(0.1,EXPONENT))
            ENDIF
C ----------- COMPUTATION FOR CLASSICAL VARIABLE STEPSIZE FORMULA -----
            FACINV=(ERR**EXPONENT)/SAFE
            IF    ((ISTEPSIZE==0).OR.(FIRST).OR.(CONVRESTRICT)) THEN
               FACINV=FACINV*REAL(NEWT+2*MAXNEWT)/CFAC
            ELSEIF (ISTEPSIZE==2) THEN
C -------------- COMPUTATION FOR PREDICTIVE STEPSIZE CONTROLLER OF GUSTAFSSON -----
               FACGUS=(HACCEPT/H)*
     &              ((1.25*ERR**2)/MAX(ERRACCEPT,0.0001))**EXPONENT
               FACINV=MAX(FACINV,FACGUS)
            ENDIF
            HREJECT=H
            REJECTERR=.TRUE.
            ERRREJECT=ERR
         ENDIF
         IF ((CALJAC).AND.(CALJACVN).AND.(HNEWFACINV>=FACINV)) THEN
            FACINV=HNEWFACINV
            CONVRESTRICT=.TRUE.
         ELSE
            CONVRESTRICT=.FALSE.
         ENDIF
C -------- WE REQUIRE RWORK(8)<=HNEW/H<=RWORK(9) -----
         HNEWFACINV=MAX(FACR,MIN(FACL,FACINV))
c         HNEWFACINV=MAX(0.1**EXPONENT,FACR,MIN(FACL,FACINV))
      ENDIF

      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE NEWSTEPSIZE
C-----------------------------------------------------------------------
