      SUBROUTINE NOSYS(N,VWORK,LDVWORK,REVCOM,CLX,CLY,XCOM,IER)
C
C COMPUTE x=P^{-1}b 
C
C VWORK:      VWORK(:,1): ON EXIT CONTAINS x=P^{-1}b 
C             VWORK(:,2): ON ENTRY CONTAINS THE RIGHT-HAND SIDE b
C
C REVCOM:     ON ENTRY REVCOM =  0
C             ON EXIT  REVCOM =  2 MATRIX VECTOR PRODUCT BY P^{-1}
C                      REVCOM =  3 MATRIX VECTOR PRODUCT BY D
C                      REVCOM =  4 INNER PRODUCT
C                      REVCOM = -1 EXIT
C
C IER:        IER =  1 SUCCESSFUL COMPUTATION
C
C CAUTION: ONLY THE INPUT ONES CAN BE MODIFIED DURING OUT OF CORE COMPUTATIONS
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: N       ! SIZE OF THE PROBLEM
      INTEGER, INTENT(IN   ) :: LDVWORK ! LEADING DIMENSION OF VWORK, N IN GENERAL
      REAL   , INTENT(INOUT) :: VWORK(LDVWORK,2)
      INTEGER, INTENT(INOUT) :: REVCOM
      INTEGER, INTENT(  OUT) :: CLX     ! COLUMN OF  INPUT IN VWORK FOR REVERSE COMMUNICATION
      INTEGER, INTENT(  OUT) :: CLY     ! COLUMN OF OUTPUT IN VWORK FOR REVERSE COMMUNICATION
      REAL   , INTENT(INOUT) :: XCOM    ! ON ENTRY CONTAINS INNER PRODUCT WHEN REVCOM = 4
      INTEGER, INTENT(  OUT) :: IER
C    LOCAL SAVED VARIABLES
      INTEGER, SAVE          :: ICOM
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE NOSYS
C-----------------------------------------------------------------------
      IF (REVCOM==0) ICOM=REVCOM
      IF     (ICOM==1) THEN
         GOTO 10
      ELSEIF (ICOM==2) THEN
         GOTO 20
      ELSEIF (ICOM==3) THEN
         GOTO 30
      ENDIF
C-----------------------------------------------------------------------
      CLX    =  2
      CLY    =  1
      ICOM   =  1
      REVCOM =  2
C-----------------------------------------------------------------------
C    ASK THE USER TO PERFORM y <- P^{-1}x
C-----------------------------------------------------------------------
      RETURN
  10  CLX    =  1
      CLY    =  2
      ICOM   =  2
      REVCOM =  3
C-----------------------------------------------------------------------
C    ASK THE USER TO PERFORM y <- Dx
C-----------------------------------------------------------------------
      RETURN
  20  CLX    =  2
      CLY    =  2
      ICOM   =  3
      REVCOM =  4
C-----------------------------------------------------------------------
C    ASK THE USER TO PERFORM INNER PRODUCT XCOM <- y^Tx
C-----------------------------------------------------------------------
      RETURN
  30  XCOM   = SQRT(XCOM)
      IER    =  1  
      REVCOM = -1
C-----------------------------------------------------------------------
C    SUCCESSFUL COMPUTATION, EXIT SUBROUTINE NOSYS
C-----------------------------------------------------------------------
      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE NOSYS
C-----------------------------------------------------------------------
