      SUBROUTINE PLEFTPREC(NM,ME,T,NY,NU,NV,LNV,NVGE1,Y,
     &   FCNM,DFYVECCNM,IDFYVECCNM,KDFYM,LDFYM,LDFY,DFY,
     &   ECN ,DEVVECCN ,IDEVVECCN             ,LDEV,DEV,
     &   PRECSOL,PRSOLVN,
     &   H,
     &   RPAR,IPAR,
     &   NS,OMEGA,STIFFLYACC,
     &   TMPNY,
     &   F0M,E0,
     &   VECMIS,DFMYVECMIS,
     &   NBHI,IBHI,
     &    LBHI, BH, LVP, VP,SOLVEVN,VEC,VECN,DY,DNY,
     &   LIBHI,IBH,LIVP,IVP,
     &   DELTY,DELTV,VPTR,IER,
     &   MYID,COMM)
C-----------------------------------------------------------------------
C     PERFORM THE LEFT PRECONDITIONING
C     D_Y <-- P^{-1}*VEC_
C  !! VEC_ IS DESTROYED ON EXIT !!
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
      INCLUDE '../INC/mpipath.h'
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: NM
      INTEGER, INTENT(IN   ) :: ME(NM)
      REAL   , INTENT(IN   ) :: T
      INTEGER, INTENT(IN   ) :: NY
      INTEGER, INTENT(IN   ) :: NU
      INTEGER, INTENT(IN   ) :: NV
      INTEGER, INTENT(IN   ) :: LNV
      LOGICAL, INTENT(IN   ) :: NVGE1
      REAL   , INTENT(IN   ) :: Y(NY)
      EXTERNAL                  FCNM
      EXTERNAL                  DFYVECCNM
      INTEGER, INTENT(IN   ) :: IDFYVECCNM(NM)
      INTEGER, INTENT(IN   ) :: KDFYM(NM)
      INTEGER, INTENT(IN   ) :: LDFYM(NM)
      INTEGER, INTENT(IN   ) :: LDFY
      REAL   , INTENT(IN   ) :: DFY(LDFY)
      EXTERNAL                  ECN
      EXTERNAL                  DEVVECCN
      INTEGER, INTENT(IN   ) :: IDEVVECCN
      INTEGER, INTENT(IN   ) :: LDEV
      REAL   , INTENT(IN   ) :: DEV(LDEV)
      EXTERNAL                  PRECSOL
      EXTERNAL                  PRSOLVN
      REAL   , INTENT(IN   ) :: H
      REAL   , INTENT(IN   ) :: RPAR(*)
      INTEGER, INTENT(IN   ) :: IPAR(*)
      INTEGER, INTENT(IN   ) :: NS
      REAL   , INTENT(IN   ) :: OMEGA(NS,NS,NM)
      INTEGER, INTENT(IN   ) :: STIFFLYACC(NM)
      REAL   , INTENT(  OUT) :: TMPNY(NY)
      REAL   , INTENT(IN   ) :: F0M(NY,NM)
      REAL   , INTENT(IN   ) :: E0(LNV)
      REAL   , INTENT(  OUT) :: VECMIS(NY)
      REAL   , INTENT(  OUT) :: DFMYVECMIS(NY)
      INTEGER, INTENT(IN   ) :: NBHI
      INTEGER, INTENT(IN   ) :: IBHI(NS)
      INTEGER, INTENT(IN   ) :: LBHI
      REAL   , INTENT(IN   ) :: BH(LBHI,NBHI)
      INTEGER, INTENT(IN   ) :: LVP
      REAL   , INTENT(IN   ) :: VP(LVP)
      LOGICAL, INTENT(IN   ) :: SOLVEVN
      REAL   , INTENT(INOUT) :: VEC(NY,NS)
      REAL   , INTENT(INOUT) :: VECN(LNV)
      REAL   , INTENT(  OUT) :: DY(NY,NS)
      REAL   , INTENT(  OUT) :: DNY(LNV)
      INTEGER, INTENT(IN   ) :: LIBHI
      INTEGER, INTENT(IN   ) :: IBH(LIBHI,NBHI)
      INTEGER, INTENT(IN   ) :: LIVP
      INTEGER, INTENT(IN   ) :: IVP(LIVP)
      REAL   , INTENT(IN   ) :: DELTY
      REAL   , INTENT(IN   ) :: DELTV
      INTEGER, INTENT(IN   ) :: VPTR
      INTEGER, INTENT(IN   ) :: IER
      INTEGER, INTENT(IN   ) :: MYID
      INTEGER, INTENT(IN   ) :: COMM
C    LOCAL VARIABLES
      INTEGER                :: IBHIIS,IS,JS,M
      INTEGER                :: ERRMPI
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE PLEFTPREC
C-----------------------------------------------------------------------
      IS=MYID+1
      IF (IS<=NS) THEN
         IBHIIS=IBHI(IS)
         CALL PRECSOL(IBHIIS,NY,NU,NV,BH(1,IBHIIS),IBH(1,IBHIIS),
     &                VEC(1,IS),RPAR,IPAR)
         CALL DCOPY(NU,VEC(1,IS),1,DY(1,IS),1)
         IF (NVGE1) THEN
            CALL DEVVECSP(T,NY,NU,NV,Y,        ECN,DEVVECCN,IDEVVECCN,
     &                    DELTV,VPTR,TMPNY,E0,
     &                    LDEV,DEV,VEC(VPTR,IS),DY(VPTR,IS),RPAR,IPAR)
         ENDIF
      ENDIF
C-----------------------------------------------------------------------
C    GLOBAL EXCHANGE OF VEC(:,JS)
C-----------------------------------------------------------------------
      DO JS=1,NS
         CALL MPI_BCAST(VEC(1,JS),NY,MPI_DOUBLE_PRECISION,JS-1,
     &                  COMM,ERRMPI)              
      ENDDO
      IF (IS<=NS) THEN

         DO M=1,NM
c            VECMIS=0.0
            CALL    DSCAL(NY,0.0                       ,VECMIS,1)
            DO JS=1,NS
               CALL DAXPY(NY,OMEGA(IS,JS,M),VEC(1,JS),1,VECMIS,1)
            ENDDO
            CALL DFYVECSPM(M,T,NY,NU,NV,Y,FCNM,DFYVECCNM,IDFYVECCNM,
     &                     DELTY,TMPNY,F0M(1,M),LDFYM(M),DFY(KDFYM(M)),
     &                     VECMIS,DFMYVECMIS,RPAR,IPAR)
            CALL DAXPY(NY,-H,DFMYVECMIS,1,DY(1,IS),1)
         ENDDO
         IBHIIS=IBHI(IS)
         CALL PRECSOL(IBHIIS,NY,NU,NV,BH(1,IBHIIS),IBH(1,IBHIIS),
     &                DY(1,IS),RPAR,IPAR)

      ELSEIF ((IS==(NS+1)).AND.SOLVEVN) THEN

         CALL PRSOLVN(NY,NU,NV,VP,IVP,VECN,RPAR,IPAR)
         CALL DCOPY(NV,VECN,1,DNY,1)

      ENDIF

      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE PLEFTPREC
C-----------------------------------------------------------------------
