      SUBROUTINE PSPARK3(NS,NM,ME,T,TEND,NY,NU,NV,Y,
     &                  FCNM,DFYCNM,IDFYCNM,DFYVECCNM,IDFYVECCNM,LDFYM,
     &                  ECN ,DEVCN ,IDEVCN ,DEVVECCN ,IDEVVECCN ,LDEV ,
     &                  PRECDEC,PRECSOL,
     &                  PRDECVN,PRSOLVN,
     &                  H,ITOLY,RTOLY,ATOLY,
     &                  IOUT,SOLOUT,
     &                  LRWORK,RWORK,LIWORK,IWORK,
     &                  LRPAR ,RPAR ,LIPAR ,IPAR ,
     &                  IDID,
     &                  MYID,COMM)
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: NS
      INTEGER, INTENT(IN   ) :: NM
      INTEGER, INTENT(IN   ) :: ME(*)
      REAL   , INTENT(INOUT) :: T
      REAL   , INTENT(IN   ) :: TEND
      INTEGER, INTENT(IN   ) :: NY
      INTEGER, INTENT(IN   ) :: NU
      INTEGER, INTENT(IN   ) :: NV
      REAL   , INTENT(INOUT) :: Y(*)
      EXTERNAL                  FCNM
      EXTERNAL                  DFYCNM
      INTEGER, INTENT(INOUT) :: IDFYCNM(NM)
      EXTERNAL                  DFYVECCNM
      INTEGER, INTENT(INOUT) :: IDFYVECCNM(NM)
      INTEGER, INTENT(INOUT) :: LDFYM(NM)
      EXTERNAL                  ECN
      EXTERNAL                  DEVCN
      INTEGER, INTENT(INOUT) :: IDEVCN
      EXTERNAL                  DEVVECCN
      INTEGER, INTENT(INOUT) :: IDEVVECCN
      INTEGER, INTENT(INOUT) :: LDEV
      EXTERNAL                  PRECDEC
      EXTERNAL                  PRECSOL
      EXTERNAL                  PRDECVN
      EXTERNAL                  PRSOLVN
      REAL   , INTENT(INOUT) :: H
      INTEGER, INTENT(IN   ) :: ITOLY
      REAL   , INTENT(IN   ) :: RTOLY(*)
      REAL   , INTENT(IN   ) :: ATOLY(*)
      INTEGER, INTENT(IN   ) :: IOUT
      EXTERNAL                  SOLOUT
      INTEGER, INTENT(IN   ) :: LRWORK
      REAL   , INTENT(INOUT) :: RWORK(*)
      INTEGER, INTENT(IN   ) :: LIWORK
      INTEGER, INTENT(INOUT) :: IWORK(*)
      INTEGER, INTENT(IN   ) :: LRPAR
      REAL   , INTENT(IN   ) :: RPAR(*)
      INTEGER, INTENT(IN   ) :: LIPAR
      INTEGER, INTENT(IN   ) :: IPAR(*)
      INTEGER, INTENT(  OUT) :: IDID
      INTEGER, INTENT(IN   ) :: MYID
      INTEGER, INTENT(IN   ) :: COMM
C    LOCAL PARAMETERS
      INTEGER, PARAMETER     :: LIWORKPARAMETER = 128
      INTEGER, PARAMETER     :: LRWORKPARAMETER =  64
C    LOCAL VARIABLES
      INTEGER :: I,IEA,IEAINV,IEB,IEBETA,IEBFBETA,IEBH,IEC
      INTEGER :: IECINV,IECONTY,IEDEV,IEDEVVEC,IEDFMYVEC
      INTEGER :: IEDFY,IEE,IEEN,IEERRC,IEE0,IEF,IEF0M,IEGAMMA,IEHWORK
      INTEGER :: IEKDFYM,IEIBH,IEIBHI,IEISM1TNYP1,IEISNY,IEIVP,IEOMEGA
      INTEGER :: IESCALYINV,IESTIFFLYACC,IETPCHIS,IETMP1NY,IETMP2NY
      INTEGER :: IEVEC,IEVECN,IEVP,IEVWORK,IEZNY,IEZY
      INTEGER :: ISTARTNEWT,ISTEPSIZE,LBHI,LBHINBHI,LDFY,LIBHI
      INTEGER :: LIBHINBHI,LINIT,LISTORE,LIVP,LNV,LRSTORE,LVP,M
      INTEGER :: MAXKRYLOV,MAXLINIT,MAXNEWT,MINNEWT,NBCOLVWORK,NBIGSYS
      INTEGER :: NCONTY,NMAX,NBHI,NSLNV,NSNM,NS2,NS2NM,NV2,NYNM,NYNMNS
      INTEGER :: NYNS,NY2
      LOGICAL                :: INVALID,NVGE1,SOLVEVN
      REAL                   :: ABSHMAX,ABSHMIN,FACL,FACR,FLINIT,FNEWT
      REAL                   :: SAFE,THET,THETADNEWEVAL,THETAJNEWDEC
      REAL                   :: UROUND
      INTEGER                :: IS
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE PSPARK3
C-----------------------------------------------------------------------
      IS=MYID+1
C-----------------------------------------------------------------------
C    INITIALIZATION OF IWORK OUTPUT VALUES
C-----------------------------------------------------------------------
      DO I=30,LIWORKPARAMETER
         IF ((IWORK(I))<=(-1)) IWORK(I)=0
      ENDDO
C-----------------------------------------------------------------------
C    SETTING THE PARAMETERS
C-----------------------------------------------------------------------
      INVALID=.FALSE.
      IF (NY<=0) THEN
         IF (IS==1) WRITE(6,*)' WARNING: NY=', NY,' <= 0'
         IDID=1
C --------  NO EQUATION TO BE SOLVED: SUCCESSFUL RETURN -----
         RETURN
      ENDIF
      IF     (NU< 0) THEN
         IF (IS==1) WRITE(6,*)' INVALID INPUT FOR NU=',NU
         IF (IS==1) WRITE(6,*)' NU=', NU,' MUST BE >= 0'
         INVALID=.TRUE.
      ELSEIF (NU>NY) THEN
         IF (IS==1) WRITE(6,*)' INVALID INPUT FOR NU=',NU
         IF (IS==1) WRITE(6,*)' NU=', NU,' MUST BE <= ',NY
         INVALID=.TRUE.
      ENDIF
      IF     (NV< 0) THEN
         IF (IS==1) WRITE(6,*)' INVALID INPUT FOR NV=',NV
         IF (IS==1) WRITE(6,*)' NV=', NV,' MUST BE >= 0'
         INVALID=.TRUE.
      ELSEIF (NV>NY) THEN
         IF (IS==1) WRITE(6,*)' INVALID INPUT FOR NV=',NV
         IF (IS==1) WRITE(6,*)' NV=', NV,' MUST BE <= ',NY
         INVALID=.TRUE.
      ENDIF
      NVGE1=(NV>=1)
      IF  (NU+NV/=NY) THEN
         IF (IS==1) WRITE(6,*)' INVALID INPUT FOR NY=',NY
         IF (IS==1) WRITE(6,*)'                   NU=',NU
         IF (IS==1) WRITE(6,*)'                OR NV=',NV
         IF (IS==1) WRITE(6,*)' NY=', NY,' MUST BE EQUAL TO NU+NV=',
     &                           NU+NV
         INVALID=.TRUE.
      ENDIF

      IF     (NM<= 0) THEN
         IF (IS==1) WRITE(6,*)' INVALID INPUT FOR NM=',NM
         IF (IS==1) WRITE(6,*)' NM=', NM,' MUST BE >= 1'
         INVALID=.TRUE.
      ENDIF

      NS2    =NS*NS
      NSNM   =NS*NM
      NS2NM  =NS2*NM
      NYNS   =NY*NS
      NCONTY =NYNS
      NYNM   =NY*NM
      NYNMNS =NYNM*NS
      NY2    =NY*NY
      NV2    =NV*NV

C ----- NMAX: MAXIMUM NUMBER OF ALLOWED STEPS -----
      IF (IWORK(1)>=1) THEN
         NMAX=IWORK(1)
      ELSE
         NMAX=100000
      ENDIF
C ----- MINNEWT: MINIMUM NUMBER OF INEXACT APPROXIMATE SIMPLIFIED -----
C ----- NEWTON ITERATIONS AT EACH STEP                            -----
      IF (IWORK(2)>=1) THEN
         MINNEWT=IWORK(2)
      ELSE
         MINNEWT=1
      ENDIF
C ----- MAXNEWT: MAXIMUM NUMBER OF INEXACT APPROXIMATE SIMPLIFIED -----
C ----- NEWTON ITERATIONS AT EACH STEP                            -----
      IF (IWORK(3)>=1) THEN
         MAXNEWT=IWORK(3)
      ELSE
         MAXNEWT=7
      ENDIF
      IF (MINNEWT>MAXNEWT) THEN
         IF (IS==1) WRITE(6,*)' INVALID INPUT FOR IWORK(2)=',
     &                          IWORK(2),'OR IWORK(3)=',IWORK(3)
         IF (IS==1) WRITE(6,*)' WE MUST HAVE IWORK(2) <= IWORK(3)'
         INVALID=.TRUE.
      ENDIF
C ----- ISTARTNEWT: SWITCH FOR THE STARTING VALUES OF INEXACT -----
C ----- APPROXIMATE SIMPLIFIED NEWTON ITERATIONS              -----
      IF ((IWORK(4)>=0).AND.(IWORK(4)<=1)) THEN
         ISTARTNEWT=IWORK(4)
      ELSE
         ISTARTNEWT=1
      ENDIF
C ----- SOLVEVN: SWITCH FOR ADDITIONAL EQUATION TO BE SOLVED FOR v_n -----
      IF ((IWORK(5)>=0).AND.(IWORK(5)<=1)) THEN
         SOLVEVN=((IWORK(5)==1).AND.(NVGE1))
      ELSE
         SOLVEVN=.FALSE.
      ENDIF
      IF (SOLVEVN) THEN
         NBIGSYS=NYNS+NV
      ELSE
         NBIGSYS=NYNS
      ENDIF
C ----- LINIT: SWITCH FOR THE PRECONDITIONED LINEAR ITERATIVE METHOD -----
      IF ((IWORK(6)>=0).AND.(IWORK(6)<=2)) THEN
         LINIT=IWORK(6)
      ELSE
         LINIT=2
      ENDIF
C ----- NBHI: NUMBER OF MATRICES H_i TO DECOMPOSE -----
      IF ((IWORK(7)==1).OR.(IWORK(7)==NS)) THEN
         NBHI=IWORK(7)
      ELSE
         NBHI=1
      ENDIF
C ----- ISTEPSIZE: SWITCH FOR STEPSIZE CONTROL STRATEGY -----
      IF ((IWORK(8)>=0).AND.(IWORK(8)<=2)) THEN
         ISTEPSIZE=IWORK(8)
      ELSE
         ISTEPSIZE=2
      ENDIF
C ----- LBHI: LENGTH OF EACH REAL WORKSPACE BHI      -----
      LBHI =MAX(1,IWORK( 9))
C ----- LVP: LENGTH OF REAL WORKSPACE VP             -----
      LVP  =MAX(1,IWORK(10))
C ----- LIBHI: LENGTH OF EACH INTEGER WORKSPACE IBHI -----
      LIBHI=MAX(1,IWORK(11))
C ----- LIVP: LENGTH OF INTEGER WORKSPACE IVP        -----
      LIVP =MAX(1,IWORK(12))
C ----- IDFYCNM(M)   : SWITCHES FOR THE COMPUTATION OF    DFYCNM(M,...) -----
      DO M=1,NM
         IF (   (IDFYCNM(M)<=-1).OR.(   IDFYCNM(M)>=3)) THEN
            IDFYCNM(M)=0
         ENDIF
      ENDDO
C ----- IDFYVECCNM(M): SWITCHES FOR THE COMPUTATION OF DFYVECCNM(M,...) -----
      DO M=1,NM
         IF ((IDFYVECCNM(M)<=-1).OR.(IDFYVECCNM(M)>=3)) THEN
            IDFYVECCNM(M)=0
         ENDIF
      ENDDO
C ----- LDFY: LENGTH OF REAL WORKSPACE DFY -----
      LDFY=0
      DO M=1,NM
         IF (IDFYCNM(M)==0) LDFYM(M)=NY2
         IF ( LDFYM(M)<=-1) LDFYM(M)=0
         LDFY=LDFY+LDFYM(M)
      ENDDO
      LDFY=MAX(1,LDFY)
C ----- IDEVCN   : SWITCH FOR THE COMPUTATION OF DEVCN    -----
      IF     (.NOT.(NVGE1)) THEN
         IDEVCN=2
      ELSEIF ((IDEVCN<=-1).OR.(IDEVCN>=3)) THEN
         IDEVCN=0
      ENDIF
C ----- IDEVVECCN: SWITCH FOR THE COMPUTATION OF DEVVECCN -----
      IF ((IDEVVECCN<=-1).OR.(IDEVVECCN>=3)) THEN
         IDEVVECCN=0
      ENDIF
C ----- LDEV: LENGTH OF REAL WORKSPACE DEV -----
      LDEV=MAX(1,LDEV)
C ----- MAXLINIT: MAXIMUM NUMBER OF ITERATIONS FOR THE -----
C ----- PRECONDITIONED LINEAR ITERATIVE METHOD         -----
      MAXLINIT=IWORK(28)
      IF     (MAXLINIT<=-1) THEN
         MAXLINIT=20
      ELSEIF (MAXLINIT== 0) THEN
         LINIT=0
      ENDIF
      MAXKRYLOV=0
      IF     (LINIT==0) THEN
C ----- INITIALIZATIONS FOR NO INNER PRECONDITIONED LINEAR ITERATIONS -----
         MAXLINIT=0
      ELSEIF (LINIT==1) THEN
C ----- INITIALIZATIONS FOR RICHARDSON -----
      ELSEIF (LINIT==2) THEN
C ----- INITIALIZATIONS FOR GMRES      -----
C -------- MAXKRYLOV: MAXIMUM DIMENSION OF THE KRYLOV SUBSPACE FOR GMRES (RESTART PARAMETER) -----
         MAXKRYLOV=IWORK(29)
         IF     (MAXKRYLOV<=-1) THEN
            MAXKRYLOV=10
         ELSEIF (MAXKRYLOV== 0) THEN
            LINIT=0
         ENDIF
      ENDIF
C ----- UROUND: UNIT ROUNDOFF, SMALLEST NUMBER SATISFYING FL(1.0+UROUND)>FL(1.0)      -----
C ----- IN DOUBLE PRECISION IEEE ARITHMETIC, UROUND=2.0**(-53)=~1.110223024625157E-16 -----
      UROUND=MAX(EPSILON(1.0)/2.0,RWORK(1))
C ----- SAFE: SAFETY FACTOR IN STEPSIZE PREDICTION -----
      IF ((RWORK(2)>=0.001).AND.(RWORK(2)<=1.0)) THEN
         SAFE=RWORK(2)
      ELSE
         SAFE=0.9
      ENDIF
C ----- THET: REFERENCE RATE OF CONVERGENCE FOR THE INEXACT ----- 
C -----       APPROXIMATE SIMPLIFIED NEWTON METHOD          -----
      IF ((RWORK(3)>0.0).AND.(RWORK(3)<1.0)) THEN
         THET=RWORK(3)
      ELSE
         THET=0.15
      ENDIF
C ----- FNEWT: STOPPING CRITERION FOR THE INEXACT   -----
C -----        APPROXIMATE SIMPLIFIED NEWTON METHOD -----
      IF (RWORK(4)>0.0) THEN
         FNEWT=RWORK(4)
      ELSE
         FNEWT=0.01
      ENDIF
C ----- FLINIT: STOPPING CRITERION FACTOR FOR THE      -----
C -----         PRECONDITIONED LINEAR ITERATIVE METHOD -----
      IF ((RWORK(5)>=0.0).AND.(RWORK(5)<1.0)) THEN
         FLINIT=RWORK(5)
      ELSE
         FLINIT=0.1
      ENDIF
C ----- ABSHMIN: MINIMUM STEPSIZE LENGTH -----
      IF (RWORK(6)>0.0) THEN
         ABSHMIN=RWORK(6)
      ELSE
         ABSHMIN=ABS(SQRT(UROUND))
      ENDIF
C ----- ABSHMAX: MAXIMUM STEPSIZE LENGTH -----
      IF (RWORK(7)>0.0) THEN
         ABSHMAX=RWORK(7)
      ELSE
         ABSHMAX=ABS(TEND-T)
      ENDIF
C ----- FACL, FACR: PARAMETERS FOR STEPSIZE SELECTION -----
      IF ((RWORK(8)>0.0).AND.(RWORK(8)<=1.0)) THEN
         FACL=1.0/RWORK(8)
      ELSE
         FACL=5.0
      ENDIF
      IF (RWORK(9)>=1.0) THEN
         FACR=1.0/RWORK(9)
      ELSE
         FACR=1.0/8.0
      ENDIF
C ----- PARAMETERS FOR THE EVALUATION AND DECOMPOSITION OF A NEW APPROXIMATE JACOBIAN -----
      IF ((RWORK(12)>=0.0).AND.(RWORK(12)<=1.0)) THEN
         THETADNEWEVAL=RWORK(12)
      ELSE
         THETADNEWEVAL=0.1
      ENDIF
      IF ((RWORK(13)>=0.0).AND.(RWORK(13)<=1.0)) THEN
         THETAJNEWDEC=RWORK(13)
      ELSE
         THETAJNEWDEC=0.1
      ENDIF
C ----- CHECK IF TOLERANCES ARE OK -----
      IF (ITOLY==0) THEN
         IF (ATOLY(1)<=0.0) THEN
            IF (IS==1) WRITE(6,*)' INVALID INPUT FOR ATOLY=',ATOLY(1)
            IF (IS==1) WRITE(6,*)' ATOLY MUST BE > 0.0'
            INVALID=.TRUE.
         ENDIF
         IF (RTOLY(1)<UROUND) THEN
            IF (IS==1) WRITE(6,*)' INVALID INPUT FOR RTOLY=',RTOLY(1)
            IF (IS==1) WRITE(6,*)' RTOLY MUST BE >=',UROUND
            INVALID=.TRUE.
         ENDIF
      ELSE
         DO I=1,NY
            IF (ATOLY(I)<=0.0) THEN
               IF (IS==1) WRITE(6,*)' INVALID INPUT FOR ATOLY(',I,
     &                                                     ')=',ATOLY(I)
               IF (IS==1) WRITE(6,*)' ATOLY(',I,') MUST BE > 0.0'
               INVALID=.TRUE.
            ENDIF
            IF (RTOLY(I)<UROUND) THEN
               IF (IS==1) WRITE(6,*)' INVALID INPUT FOR RTOLY(',I,
     &                                                     ')=',RTOLY(I)
               IF (IS==1) WRITE(6,*)' RTOLY(',I,') MUST BE >=',UROUND
               INVALID=.TRUE.
            ENDIF
         ENDDO
      ENDIF
C-----------------------------------------------------------------------
C    COMPUTATION OF ARRAY ENTRIES
C-----------------------------------------------------------------------
      LNV=MAX(1,NV)
      NSLNV   =NS*LNV
      LBHINBHI = LBHI*NBHI
      LIBHINBHI=LIBHI*NBHI

      IF     (LINIT==0) THEN
C ----- NUMBER OF VECTORS NEEDED FOR NO INNER PRECONDITIONED LINEAR ITERATIONS -----
         NBCOLVWORK=2
      ELSEIF (LINIT==1) THEN
C ----- NUMBER OF VECTORS NEEDED FOR RICHARDSON -----
         NBCOLVWORK=4
      ELSEIF (LINIT==2) THEN
C ----- NUMBER OF VECTORS NEEDED FOR GMRES      -----
         NBCOLVWORK=4+MAXKRYLOV
      ENDIF
C ----- PREPARE THE ENTRY-POINTS FOR THE ARRAYS IN RWORK (REAL WORKSPACE) -----
      IEDFMYVEC    =1           +LRWORKPARAMETER
      IEDFY        =IEDFMYVEC   +NY
      IEDEVVEC     =IEDFY       +LDFY
      IEDEV        =IEDEVVEC    +LNV
      IEB          =IEDEV       +LDEV
      IEC          =IEB         +NS
      IECINV       =IEC         +NS
      IEA          =IECINV      +NS
      IEAINV       =IEA         +NS2NM
      IEBETA       =IEAINV      +NS2NM
      IEBFBETA     =IEBETA      +NS
      IEGAMMA      =IEBFBETA    +NSNM
      IEOMEGA      =IEGAMMA     +NSNM
      IEERRC       =IEOMEGA     +NS2NM
      IETPCHIS     =IEERRC      +(1+NS)
      IECONTY      =IETPCHIS    +NS
      IETMP1NY     =IECONTY     +NCONTY
      IETMP2NY     =IETMP1NY    +NY
      IESCALYINV   =IETMP2NY    +NY
      IEZY         =IESCALYINV  +NY
      IEZNY        =IEZY        +NYNS
      IEF0M        =IEZNY       +NY
      IEF          =IEF0M       +NYNM
      IEE0         =IEF         +NYNMNS
      IEE          =IEE0        +LNV
      IEEN         =IEE         +NSLNV
      IEBH         =IEEN        +LNV
      IEVP         =IEBH        +LBHINBHI
      IEVEC        =IEVP        +LVP
      IEVECN       =IEVEC       +NYNS
      IEVWORK      =IEVECN      +LNV
      IEHWORK      =IEVWORK     +NBCOLVWORK*NBIGSYS
C ----- TOTAL STORAGE REQUIREMENT -----
      LRSTORE      =IEHWORK     +(MAXKRYLOV+1)*(MAXKRYLOV+3)-1
      IF (LRSTORE>LRWORK) THEN
         IF (IS==1) WRITE(6,*)' INSUFFICIENT STORAGE FOR RWORK'
         IF (IS==1) WRITE(6,*)' MINIMUM LRWORK=',LRSTORE
         INVALID=.TRUE.
      ELSE
         IF (IS==1) WRITE(6,*)' STORAGE FOR RWORK, MINIMUM LRWORK=',
     &                            LRSTORE
         DO I=LRWORKPARAMETER+1,LRSTORE
            RWORK(I)=0.0
         ENDDO
      ENDIF

C ----- PREPARE THE ENTRY-POINTS FOR THE ARRAYS IN IWORK (INTEGER WORKSPACE) -----
      IEKDFYM      =1           +LIWORKPARAMETER
      IEISNY       =IEKDFYM     +NM
      IEISM1TNYP1  =IEISNY      +NS
      IEIBHI       =IEISM1TNYP1 +NS
      IEIBH        =IEIBHI      +NS
      IESTIFFLYACC =IEIBH       +LIBHINBHI
      IEIVP        =IESTIFFLYACC+NM
C ----- TOTAL STORAGE REQUIREMENT -----
      LISTORE      =IEIVP       +LIVP-1
      IF (LISTORE>LIWORK) THEN
         IF (IS==1) WRITE(6,*)' INSUFFICIENT STORAGE FOR IWORK'
         IF (IS==1) WRITE(6,*)' MINIMUM LIWORK=',LISTORE
         INVALID=.TRUE.
      ELSE
         IF (IS==1) WRITE(6,*)' STORAGE FOR IWORK, MINIMUM LIWORK=',
     &                            LISTORE
         DO I=LIWORKPARAMETER+1,LISTORE
            IWORK(I)=0
         ENDDO
      ENDIF
C ----- WHEN A FAIL HAS OCCURED, WE RETURN WITH IDID=-1 -----
 100  CONTINUE
      IF (INVALID) THEN
         IDID=-1
         RETURN
      ENDIF
C ----- CALL TO CORE INTEGRATOR -----
      CALL PSPARK3COR(NM,ME,NS,NBHI,T,TEND,NY,NU,NV,NBIGSYS,LNV,
     &   IWORK(IEISNY),IWORK(IEISM1TNYP1),NVGE1,Y,
     &   FCNM,DFYCNM,IDFYCNM,DFYVECCNM,IDFYVECCNM,
     &   RWORK(IEDFMYVEC),IWORK(IEKDFYM),LDFYM,LDFY,RWORK(IEDFY),
     &   ECN ,DEVCN ,IDEVCN ,DEVVECCN ,IDEVVECCN,
     &   RWORK(IEDEVVEC)                      ,LDEV,RWORK(IEDEV),
     &   PRECDEC,PRECSOL,PRDECVN,PRSOLVN,
     &   H,ABSHMIN,ABSHMAX,FACL,FACR,THETADNEWEVAL,THETAJNEWDEC,
     &   RTOLY,ATOLY,ITOLY,SOLOUT,IOUT,IDID,NMAX,UROUND,SAFE,
     &   THET,FNEWT,MINNEWT,MAXNEWT,ISTARTNEWT,SOLVEVN,
     &   FLINIT,LINIT,MAXLINIT,MAXKRYLOV,ISTEPSIZE,
     &   IWORK(30),IWORK(31),IWORK(32),IWORK(33),IWORK(34),IWORK(35),
     &   IWORK(36),IWORK(37),IWORK(38),IWORK(39),IWORK(40),IWORK(41),
     &   IWORK(42),IWORK(43),IWORK(44),LRPAR,RPAR,RWORK(IEB),RWORK(IEC),
     &   RWORK(IECINV),RWORK(IEA),RWORK(IEAINV),RWORK(IEBETA),
     &   RWORK(IEBFBETA),RWORK(IEGAMMA),RWORK(IEOMEGA),RWORK(IEERRC),
     &   IWORK(IESTIFFLYACC),RWORK(IETPCHIS),NCONTY,
     &   RWORK(IECONTY),RWORK(IETMP1NY),RWORK(IETMP2NY),
     &   RWORK(IESCALYINV),RWORK(IEZY),RWORK(IEZNY),RWORK(IEF0M),
     &   RWORK(IEF),RWORK(IEE0),RWORK(IEE),RWORK(IEEN),IWORK(IEIBHI),
     &   LBHI ,RWORK(IEBH) ,LVP ,RWORK(IEVP),
     &   RWORK(IEVEC),RWORK(IEVECN),
     &   NBCOLVWORK,RWORK(IEVWORK),RWORK(IEHWORK),LIPAR,IPAR,
     &   LIBHI,IWORK(IEIBH),LIVP,IWORK(IEIVP),
     &   MYID,COMM)

      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE PSPARK3
C-----------------------------------------------------------------------
