      SUBROUTINE SETF0ME0(DELTYCOMPUTED,DELTY,DELTV,UROUND,
     &                    NM,T,NY,NU,VPTR,NV,LNV,NVGE1,Y,FCNM,
     &                    IDFYVECCNM,ECN,IDEVVECCN,H,RPAR,IPAR,
     &                    NECN,F0M,E0)
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      LOGICAL, INTENT(  OUT) :: DELTYCOMPUTED
      REAL   , INTENT(  OUT) :: DELTY
      REAL   , INTENT(  OUT) :: DELTV
      REAL   , INTENT(IN   ) :: UROUND
      INTEGER, INTENT(IN   ) :: NM
      REAL   , INTENT(IN   ) :: T
      INTEGER, INTENT(IN   ) :: NY
      INTEGER, INTENT(IN   ) :: NU
      INTEGER, INTENT(IN   ) :: VPTR
      INTEGER, INTENT(IN   ) :: NV
      INTEGER, INTENT(IN   ) :: LNV
      LOGICAL, INTENT(IN   ) :: NVGE1
      REAL   , INTENT(IN   ) :: Y(NY)
      EXTERNAL                  FCNM
      INTEGER, INTENT(IN   ) :: IDFYVECCNM(NM)
      EXTERNAL                  ECN
      INTEGER, INTENT(IN   ) :: IDEVVECCN
      REAL   , INTENT(IN   ) :: H
      REAL   , INTENT(IN   ) :: RPAR(*)
      INTEGER, INTENT(IN   ) :: IPAR(*)
      INTEGER, INTENT(INOUT) :: NECN
      REAL   , INTENT(  OUT) :: F0M(NY,NM)
      REAL   , INTENT(  OUT) :: E0(LNV)
C    LOCAL VARIABLES
      INTEGER                :: M
      REAL                   :: DNORMV,DNORMY
C    LEVEL 1 BLAS FUNCTIONS
      DOUBLE PRECISION       :: DNRM2
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE SETF0ME0
C-----------------------------------------------------------------------
      DELTYCOMPUTED=.FALSE.
      DO M=1,NM
         IF (IDFYVECCNM(M)==1) THEN
            IF (.NOT.(DELTYCOMPUTED)) THEN
               DNORMY=DNRM2(NY,Y      ,1)
               DELTY=SQRT(UROUND*MAX(1.E-5,DNORMY))
               DELTYCOMPUTED=.TRUE.
            ENDIF
C ----------- SET F0M(*,M), NEEDED FOR COMPUTING MATRICES OF PARTIAL DERIVATIVES Fmy NUMERICALLY -----
            CALL FCNM(M,T,NY,NU,NV,Y,F0M(1,M),RPAR,IPAR)
         ENDIF
      ENDDO
      IF (NVGE1) THEN
         IF (IDEVVECCN==1) THEN
               DNORMV=DNRM2(NV,Y(VPTR),1)
               DELTV=SQRT(UROUND*MAX(1.E-5,DNORMV))
         ENDIF
C ----------- SET E0 -----
            CALL ECN(  T,NY,NU,NV,Y,E0     ,RPAR,IPAR)
            NECN=NECN+1
      ENDIF

      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE SETF0ME0
C-----------------------------------------------------------------------
