C2 4 6 8 0 2 4 6 8 0 2 4 6 8 0 2 4 6 8 0 2 4 6 8 0 2 4 6 8 0 2 4 6 8 0 2
C
C    Copyright (C) LAURENT O. JAY 1998, 1999, 2000, 2001.
C
C    SOFTWARE LICENSE AGREEMENT NOTICE - THIS SOFTWARE IS BEING PROVIDED TO
C    YOU BY LAURENT O. JAY UNDER THE FOLLOWING LICENSE. BY DOWN-LOADING,
C    INSTALLING AND/OR USING THE SOFTWARE YOU AGREE THAT YOU HAVE READ,
C    UNDERSTOOD AND WILL COMPLY WITH THESE FOLLOWING TERMS AND CONDITIONS.
C  
C    1 - This software program provided in source code format ("the " Source
C    Code ") and any associated documentation (the " Documentation ") are
C    licensed, not sold, to you.
C  
C    2 - LAURENT O. JAY, referred in this software license agreement as the
C    author, grants you a personal, non-exclusive, non-transferable and
C    royalty-free right to use, copy or modify the Source Code and
C    Documentation, provided that you agree to comply with the terms and
C    restrictions of this agreement. You may modify the Source Code and
C    Documentation to make source code derivative works, object code
C    derivative works and/or documentation derivative Works (called
C    " Derivative Works "). The Source Code, Documentation and Derivative
C    Works (called " Licensed Software ") may be used by you for personal
C    and non-commercial use only. " Non-commercial use " means uses that are
C    not or will not result in the sale, lease or rental of the Licensed
C    Software and/or the use of the Licensed Software in any commercial
C    product or service. The author reserves all rights not expressly granted
C    to you. No other licenses are granted or implied.
C  
C    3 - The Source Code and Documentation are and will remain the sole
C    property of the author. The Source Code and Documentation are copyrighted
C    works. You agree to treat any modification or derivative work of the
C    Licensed Software as if it were part of the Licensed Software itself.
C    In return for this license, you grant the author a non-exclusive perpetual
C    paid-up royalty-free license to make, sell, have made, copy, distribute
C    and make derivative works of any modification or derivative work you
C    make of the Licensed Software.
C  
C    4- The licensee shall acknowledge the contribution of the Source Code
C    in any publication of material dependent upon the use of the Source
C    Code. The licensee shall use reasonable endeavours to send to the author a
C    copy of each such publication.
C  
C    5- The author has no obligation to support the Licensed Software it is
C    providing under this license.
C  
C    THE LICENSED SOFTWARE IS PROVIDED " AS IS " AND the author MAKE NO
C    REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED. BY WAY OF EXAMPLE,
C    BUT NOT LIMITATION, the author MAKE NO REPRESENTATIONS OR WARRANTIES OF
C    MERCHANTIBILY OR FITNESS FOR ANY PARTICULAR PURPOSE OR THAT THE USE OF
C    THE LICENSED SOFTWARE OR DOCUMENTATION WILL NOT INFRINGE ANY THIRD
C    PARTY PATENTS, COPYRIGHTS, TRADEMARKS OR OTHER RIGHTS. the author WILL NOT
C    BE LIABLE FOR ANY CONSEQUENTIAL, INCIDENTAL, OR SPECIAL DAMAGES, OR ANY
C    OTHER RELIEF, OR FOR ANY CLAIM BY ANY THIRD PARTY, ARISING FROM YOUR
C    USE OF THE LICENSED SOFTWARE.
C  
C    6- For information regarding a commercial license for the Source Code
C    and Documentation, please e-mail LAURENT O. JAY at na.ljay@na-net.ornl.gov
C  
C    7- This license is effective until terminated. You may terminate this
C    license at any time by destroying the Licensed Software.
C  
C    I agree all the terms and conditions of the above license agreement.
C
C    Updated versions of this software can be found at
C    ---------------------------------------------
C     http://www.math.uiowa.edu/~ljay/SPARK3.html
C    ---------------------------------------------
      SUBROUTINE SPARK3(NS,NM,ME,T,TEND,NY,NU,NV,Y,
     &                  FCNM,DFYCNM,IDFYCNM,DFYVECCNM,IDFYVECCNM,LDFYM,
     &                  ECN ,DEVCN ,IDEVCN ,DEVVECCN ,IDEVVECCN ,LDEV ,
     &                  PRECDEC,PRECSOL,
     &                  PRDECVN,PRSOLVN,
     &                  H,ITOLY,RTOLY,ATOLY,
     &                  IOUT,SOLOUT,
     &                  LRWORK,RWORK,LIWORK,IWORK,
     &                  LRPAR ,RPAR ,LIPAR ,IPAR ,
     &                  IDID)
C-----------------------------------------------------------------------
C     NUMERICAL SOLUTION OF AN IMPLICIT ODE SYSTEM OF THE FORM
C
C                 (u^T,e(t,y)^T)^T' = f(t,y) = sum_{m=1}^{NM} f_m(t,y)
C
C                 y is partitioned in 2 subvectors y = (u^T,v^T)^T,
C                 y is of dimension NY, u is of dimension NU, v is of 
C                 dimension NV with NU+NV=NY, e(t,y) is of dimension NV.
C                 It is assumed that e_v(t,y) is invertible, hence the
C                 implicit ODE system is of index 0 in the DAE terminology.
C
C-----------------------------------------------------------------------
C     THE METHOD USED IS A 3-STAGE SUPER PARTITIONED ADDITIVE IMPLICIT
C     RUNGE-KUTTA (SPARK) METHOD WITH DENSE OUTPUT, LIKE FOR EXAMPLE
C     THE 3-STAGE LOBATTO IIIA-B-C-C*-D OF (NONSTIFF) ORDER 4.
C     TO APPLY A SPARK METHOD NOT INCLUDED HERE, ALL WHAT IS NEEDED
C     IS TO MODIFY THE SUBROUTINE COEF(...) SETTING THE COEFFICIENTS 
C     RELATED TO THE SPARK METHOD. THE LINEAR SYSTEM SOLVER FOR THE APPROXIMATE
C     SIMPLIFIED NEWTON METHOD APPLIED TO THE NONLINEAR SYSTEM OF IMPLICIT
C     EQUATIONS IS A PRECONDITIONED LINEAR ITERATIVE METHOD WITH PRECONDITIONER
C     BASED ON THE W-TRANSFORMATION OF THE RUNGE-KUTTA COEFFICIENTS USING
C     RICHARDSON OR GMRES ITERATIONS.
C
C     SPARK3 MAKES CALLS TO BLAS (BASIC LINEAR ALGEBRA SUBROUTINES):
C      LEVEL 1 BLAS: DSCAL, DCOPY, DAXPY, DDOT, DNRM2.
C      LEVEL 2 BLAS: DGEMV, DTRSV.
C      LEVEL 3 BLAS: none.
C
C     INNER PRECONDITIONED LINEAR ITERATIVE SOLVER:
C
C     - WHEN IWORK(6)=0 NO INNER LINEAR ITERATIONS (LEADS TO "FIXED-POINT" ITERATIONS).
C
C     - WHEN IWORK(6)=1 RICHARDSON ITERATIONS.
C
C     - WHEN IWORK(6)=2 GMRES ITERATIONS.
C
C     THE CODE IS WRITTEN AND INTENDED FOR MACHINES SUPPORTING
C     DOUBLE PRECISION IEEE ARITHMETIC.
C
C     WARNING: THE CODE SPARK3 AND ITS SUBROUTINES CANNOT BE DISTRIBUTED OR COPIED FOR
C     ANY ACADEMIC, NONCOMMERCIAL, OR COMMERCIAL USE WITHOUT PERMISSION OF THE AUTHOR.
C     AUTHOR AND COPYRIGHT INFORMATION (SEE ABOVE, ALL RIGHTS RESERVED):
C              Laurent O. JAY
C              Department of Mathematics
C              14 MacLean Hall
C              The University of Iowa
C              Iowa City, IA 52242-1419
C              USA
C              E-mail: na.ljay@na-net.ornl.gov
C              Tel: (319)-335-0898
C              Fax: (319)-335-0627
C
C     DESCRIPTIONS OF SOME OF THE TECHNIQUES USED IN SPARK3 ARE GIVEN IN:
C
C        -L. O. JAY:  User's guide to SPARK3. In preparation.
C
C        -L. O. JAY:  Preconditioning and parallel implementation of 
C                     implicit Runge-Kutta methods. In preparation.
C
C        -L. O. JAY:  Inexact simplified Newton iterations for implicit
C                     Runge-Kutta methods.
C                     SIAM J. Num. Anal., Vol. 38, pp. 1369-1388, 2000.
C
C        -L. O. JAY and Th. BRACONNIER:
C                     A parallelizable preconditioner for the iterative
C                     solution of implicit Runge-Kutta type methods.
C                     J. Comput. Appl. Math., Vol. 111, pp. 63-76, 1999.
C
C        -L. O. JAY:  Structure preservation for constrained dynamics
C                     with super partitioned additive Runge-Kutta methods.
C                     SIAM J. Sci. Comput., Vol. 20, pp. 416-446, 1999. 
C
C     VERSION 3.0.0 OF JULY 16TH, 2001
C
C     INPUT PARAMETERS
C     ----------------
C
C     NS          NUMBER OF STAGES OF THE SPARK METHOD
C                 NS MUST BE EQUAL TO 3 AT THE MOMENT!
C
C     NM          NUMBER OF IRK METHODS USED. NM MUST BE >=1
C
C     ME(NM)      POINTER TO COEFFICIENTS OF NM IRK METHODS.
C                 WARNING: IRK METHODS FROM DIFFERENT FAMILIES CANNOT BE MIXED.
C                          ONLY ONE FAMILY OF IRK METHODS MUST BE USED.
C                  M=1,...,NM:
C                  1<= ME(M)<= 10: LOBATTO FAMILY
C                      ME(M) =  1: LOBATTO IIIA
C                      ME(M) =  2: LOBATTO IIIB
C                      ME(M) =  3: LOBATTO IIIC
C                      ME(M) =  4: LOBATTO IIIC*
C                      ME(M) =  5: LOBATTO IIID
C
C                 11<= ME(M)<= 20: RADAU II FAMILY
C                      ME(M) = 11: RADAU IIA
C
C                 21<= ME(M)<= 30: GAUSS FAMILY
C                      ME(M) = 21: GAUSS
C
C     T           INITIAL T-VALUE
C
C     TEND        FINAL T-VALUE (TEND-T MAY BE POSITIVE OR NEGATIVE)
C
C     NY          DIMENSION OF THE VECTOR Y. NY MUST BE >=1 AND WE MUST HAVE NY=NU+NV
C
C     NU          DIMENSION OF THE SUBVECTOR U OF Y; U=(Y(   1),...,Y(   NU))^T
C
C     NV          DIMENSION OF THE SUBVECTOR V OF Y; V=(Y(NU+1),...,Y(NU+NV))^T
C
C     Y(NY)       INITIAL VECTOR Y=(U^T,V^T)^T
C
C     FCNM        NAME (EXTERNAL) OF SUBROUTINE COMPUTING f_m(t,y) (m=1,...,NM):
C                    SUBROUTINE FCNM(M,T,NY,NU,NV,Y,FM,RPAR,IPAR)
Cc                    ONLY THE NONZERO ELEMENTS NEED TO BE SET
Cc                    ARGUMENTS:       T,NY,NU,NV,Y,   RPAR,IPAR AS FOR SPARK3
Cc                               M      (INPUT)  INDEX m
Cc                               FM(NY) (OUTPUT) f_m(t,y)
C                    REAL T,Y(NY),FM(NY)
C                    REAL RPAR(*)
C                    INTEGER IPAR(*)
C                    IF     (M==1) THEN
C                       FM(1)=...
C                    ELSEIF (M==2) THEN
C                       FM(1)=...
C                       ...
C                    ENDIF
C                    RETURN
C                    END
C
C     DFYCNM      NAME (EXTERNAL) OF SUBROUTINE COMPUTING QUANTITIES NEEDED FOR
C                 THE M-TH APPROXIMATE JACOBIAN Fmy (CAPTURING STIFFNESS)
C                 TO (f_m)_y(t,y) (m=1,...,NM):
C                    SUBROUTINE DFYCNM(M,T,NY,NU,NV,Y,LDFMY,DFMY,RPAR,IPAR)
Cc                    ONLY THE NONZERO ELEMENTS NEED TO BE SET
Cc                    ARGUMENTS:         T,NY,NU,NV,Y,           RPAR,IPAR AS FOR SPARK3
Cc                               M          (INPUT)  INDEX m
Cc                               LDFMY      (INPUT)  THE DIMENSION OF DFMY
Cc                               DFMY(....) (OUTPUT) QUANTITIES NEEDED FOR Fmy
C                    REAL T,Y(NY),DFMY(....)
Cc                    THE DIMENSION OF DFMY MUST NOT EXCEED LDFYM. FOR EXAMPLE IF
Cc                    LDFMY>=NY*NY THEN DFMY(NY,NY) IS OK. DFMY(LDFMY) OR DFMY(*)
C                     IS ALWAYS OK.
C                    REAL RPAR(*)
C                    INTEGER IPAR(*)
Cc                    FOR EXAMPLE IF DFMY IS DIMENSIONED AS DFMY(NY,NY)
C                    IF     (M==1) THEN
C                       DFMY(1,1)=...
C                    ELSEIF (M==2) THEN
C                       DFMY(1,1)=...
C                       ...
C                    ENDIF
C                    RETURN
C                    END
C
C     IDFYCNM(NM) SWITCH TO COMPUTE QUANTITIES NEEDED FOR THE APPROXIMATE JACOBIANS Fmy.
C                  M=1,...,NM:
C                   IDFYCNM(M)=0: Fmy ARE COMPUTED INTERNALLY BY USING NUMERICAL
C                                 FINITE DIFFERENCES APPROXIMATIONS TO PARTIAL DERIVATIVES. 
C                                 SUBROUTINE DFYCNM(M,...) IS NOT CALLED. SUPPLY A DUMMY SUBROUTINE.
C                   IDFYCNM(M)=1: QUANTITIES NEEDED FOR Fmy ARE COMPUTED BY SUBROUTINE DFYCNM(M,...).
C                   IDFYCNM(M)=2: NO Fmy ARE COMPUTED, SUBROUTINE DFYCNM(M,...) IS NOT CALLED.
C                                 SUPPLY A DUMMY SUBROUTINE.
C
C     DFYVECCNM   NAME (EXTERNAL) OF SUBROUTINE COMPUTING THE M-TH APPROXIMATE JACOBIAN
C                 Fmy-VECTOR PRODUCT(S) FOR THE PRECONDITIONED LINEAR ITERATIVE METHOD.
C                 USED ONLY WHEN IDFYVECCNM(M)=2, OTHERWISE SUPPLY A DUMMY SUBROUTINE:
C                    SUBROUTINE DFYVECCNM(M,T,NY,NU,NV,Y,LDFMY,DFMY,VEC,DFMYVEC,RPAR,IPAR)
Cc                    ONLY THE NONZERO ELEMENTS NEED TO BE SET
Cc                    ARGUMENTS:            T,NY,NU,NV,Y,                       RPAR,IPAR AS FOR SPARK3
Cc                               M           (INPUT)  INDEX m
Cc                               LDFMY       (INPUT)  THE DIMENSION OF DFMY
Cc                               DFMY(....)  (INPUT)  QUANTITIES NEEDED FOR Fmy
Cc                               VEC(NY)     (INPUT)  THE VECTOR
Cc                               DFMYVEC(NY) (OUTPUT) Fmy-VECTOR PRODUCT
C                    REAL T,Y(NY),VEC(NY),DFMY(....),DFMYVEC(NY)
Cc                    THE DIMENSION OF DFMY MUST NOT EXCEED LDFMY. FOR EXAMPLE IF
Cc                    LDFMY>=NY*NY THEN DFMY(NY,NY) IS OK. DFMY(LDFMY) OR DFMY(*)
Cc                    IS ALWAYS OK.
C                    REAL RPAR(*)
C                    INTEGER IPAR(*)
C                    IF     (M==1) THEN
C                       DFMYVEC(1)=...
C                    ELSEIF (M==2) THEN
C                       DFMYVEC(1)=...
C                       ...
C                    ENDIF
C                    RETURN
C                    END
C
C     IDFYVECCNM(NM) SWITCH TO COMPUTE THE M-TH APPROXIMATE JACOBIAN Fmy-VECTOR PRODUCT
C                 FOR THE PRECONDITIONED LINEAR ITERATIVE METHOD.
C                  M=1,...,NM:
C                   IDFYVECCNM(M)=0: STANDARD PRODUCT USING Fmy EXPLICITLY
C                   IDFYVECCNM(M)=1: Fmy-FREE PRODUCT USING FINITE DIFFERENCES
C                   IDFYVECCNM(M)=2: USER-SUPPLIED SUBROUTINE DFYVECCNM(M,...) (SEE ABOVE)
C
C     LDFYM(NM)   LENGTH OF Fmy IN THE REAL WORKSPACE DFY(...) USED FOR THE PRECONDITIONER TO
C                 H_i = [I O ] - h*sum_m gamma(i,m)*Fmy
C                       [O Ev]
C                 IN SUBROUTINES DFYCNM AND PRECDEC. WORKSPACE REQUIRED BY DFYCNM AND
C                 SPACE FOR DATA TO BE COMMUNICATED TO PRECDEC IS MADE AVAILABLE
C                 IN THE FORM OF ARRAY DFY WHICH IS PART OF ARRAY RWORK.
C
C     ECN         NAME (EXTERNAL) OF SUBROUTINE COMPUTING e(t,y):
C                    SUBROUTINE ECN(T,NY,NU,NV,Y,E,RPAR,IPAR)
Cc                    ONLY THE NONZERO ELEMENTS NEED TO BE SET
Cc                    ARGUMENTS:    T,NY,NU,NV,Y,  RPAR,IPAR AS FOR SPARK3
Cc                               E(NV) (OUTPUT) e(t,y)
C                    REAL T,Y(NY),E(NV)
C                    REAL RPAR(*)
C                    INTEGER IPAR(*)
C                    E(1)=...
C                    RETURN
C                    END
C
C     DEVCN       NAME (EXTERNAL) OF SUBROUTINE COMPUTING QUANTITIES NEEDED FOR
C                 THE APPROXIMATE JACOBIAN Ev TO e_v(t,u,v):
C                    SUBROUTINE DEVCN(T,NY,NU,NV,Y,LDEV,DEV,RPAR,IPAR)
Cc                    ONLY THE NONZERO ELEMENTS NEED TO BE SET
Cc                    ARGUMENTS:      T,NY,NU,NV,Y,         RPAR,IPAR AS FOR SPARK3
Cc                               LDEV      (INPUT)  THE DIMENSION OF DEV
Cc                               DEV(....) (OUTPUT) QUANTITIES NEEDED FOR Ev
C                    REAL T,Y(NY),DEV(....)
Cc                    THE DIMENSION OF DEV MUST NOT EXCEED LDEV. FOR EXAMPLE IF
Cc                    LDEV>=NV*NV THEN DEV(NV,NV) IS OK. DEV(LDEV) OR DEV(*)
Cc                    IS ALWAYS OK.
C                    REAL RPAR(*)
C                    INTEGER IPAR(*)
Cc                    FOR EXAMPLE IF DEV IS DIMENSIONED AS DEV(NV,NV)
C                    DEV(1,1)=...
C                    RETURN
C                    END
C
C     IDEVCN      SWITCH TO COMPUTE QUANTITIES NEEDED FOR THE APPROXIMATE JACOBIAN Ev.
C                   IDEVCN=0: Ev IS COMPUTED INTERNALLY BY USING NUMERICAL
C                              FINITE DIFFERENCES APPROXIMATIONS TO PARTIAL DERIVATIVES. 
C                              SUBROUTINE DEVCN IS NOT CALLED. SUPPLY A DUMMY SUBROUTINE.
C                   IDEVCN=1: QUANTITIES NEEDED FOR Ev ARE COMPUTED BY SUBROUTINE DEVCN.
C                   IDEVCN=2: NV<=0 OR NO Ev IS COMPUTED, SUBROUTINE DEVCN
C                              IS NOT CALLED. SUPPLY A DUMMY SUBROUTINE.
C
C     DEVVECCN    NAME (EXTERNAL) OF SUBROUTINE COMPUTING APPROXIMATE JACOBIAN
C                 Ev-VECTOR PRODUCT FOR THE PRECONDITIONED LINEAR ITERATIVE METHOD.
C                 USED ONLY WHEN IDEVVECCN=2, OTHERWISE SUPPLY A DUMMY SUBROUTINE:
C                    SUBROUTINE DEVVECCN(T,NY,NU,NV,Y,LDEV,DEV,VEC,DEVVEC,RPAR,IPAR)
Cc                    ONLY THE NONZERO ELEMENTS NEED TO BE SET
Cc                    ARGUMENTS:         T,NY,NU,NV,Y,                    RPAR,IPAR AS FOR SPARK3
Cc                               LDEV       (INPUT)  THE DIMENSION OF DEV
Cc                               DEV(....)  (INPUT)  QUANTITIES NEEDED FOR Ev
Cc                               VEC(NV)    (INPUT)  THE VECTOR
Cc                               DEVVEC(NV) (OUTPUT) Ev-VECTOR PRODUCT
C                    REAL T,Y(NY),VEC(NV),DEV(....),DEVVEC(NV)
Cc                    THE DIMENSION OF DEV MUST NOT EXCEED LDEV. FOR EXAMPLE IF
Cc                    LDEV>=NV*NV THEN DEV(NV,NV) IS OK. DEV(LDEV) OR DEV(*)
Cc                    IS ALWAYS OK.
C                    REAL RPAR(*)
C                    INTEGER IPAR(*)
C                    DEVVEC(1)=...
C                    RETURN
C                    END
C
C     IDEVVECCN   SWITCH TO COMPUTE APPROXIMATE JACOBIAN Ev-VECTOR PRODUCTS
C                 FOR THE PRECONDITIONED LINEAR ITERATIVE METHOD.
C                   IDEVVECCN=0: STANDARD PRODUCT USING Ev EXPLICITLY
C                   IDEVVECCN=1: Ev-FREE PRODUCT USING FINITE DIFFERENCES
C                   IDEVVECCN=2: USER-SUPPLIED SUBROUTINE DEVVECCN (SEE ABOVE)
C
C     LDEV        LENGTH OF THE REAL WORKSPACE DEV USED FOR THE PRECONDITIONERS
C                 IN SUBROUTINES DEVCN, PRECDEC, AND PRDECVN. WORKSPACE REQUIRED BY DEVCN AND 
C                 SPACE FOR DATA TO BE COMMUNICATED TO PRECDEC AND PRDECVN IS MADE AVAILABLE
C                 IN THE FORM OF ARRAY DEV WHICH IS PART OF ARRAY RWORK.
C
C     PRECDEC     NAME (EXTERNAL) OF SUBROUTINE COMPUTING A DECOMPOSITION OF A
C                 PRECONDITIONER TO
C                 H_i = [I O ] - h*sum_m gamma(i,m)*Fmy
C                       [O Ev]
C                 THIS WILL BE USED AS PART OF A PRECONDITIONER
C                 FOR THE PRECONDITIONED LINEAR ITERATIVE METHOD.
C
C                    SUBROUTINE PRECDEC(I,NS,T,H,NY,NU,NV,Y,NM,GAMMA,
C                   &                   KDFYM,LDFYM,LDFY,DFY,LDEV,DEV,
C                   &                   BHI,IBHI,IER,RPAR,IPAR)
Cc                    ARGUMENTS:          NS,T,H,NY,NU,NV,Y,NM,       RPAR,IPAR AS FOR SPARK3
Cc                               I            (INPUT) INDEX I OF THE I-TH BLOCK H_i OF THE PRECONDITIONER
Cc                               GAMMA(NS,NM) (INPUT) SPARK COEFFICIENTS
Cc                               KDFYM(NM)    (INPUT) STARTING INDEX OF Fmy IN DFY(...)
Cc                               LDFYM(NM)    (INPUT) LENGTH OF Fmy IN DFY(...) 
Cc                               LDFY         (INPUT) THE DIMENSION OF DFY
Cc                               DFY(....)    (INPUT) QUANTITIES NEEDED FOR Fmy
Cc                               LDEV         (INPUT) THE DIMENSION OF DEV
Cc                               DEV(....)    (INPUT) QUANTITIES NEEDED FOR Ev
Cc                               BHI(*)       (INPUT/OUTPUT) THE REAL SPACE ASSOCIATED TO THE
Cc                                                  I-TH DECOMPOSED BLOCK H_i OF THE PRECONDITIONER
Cc                               IBHI(*)      (OUTPUT) THE INTEGER SPACE ASSOCIATED TO THE
Cc                                                  I-TH DECOMPOSED BLOCK H_i OF THE PRECONDITIONER
Cc                               IER          (OUTPUT) REPORTS ON SUCCESSFULNESS UPON RETURN
C                    INTEGER I
C                    REAL T,H,Y(NY),GAMMA(NS,NM),DFY(....),DEV(....),BHI(*)
C                    INTEGER KDFYM(NM),LDFYM(NM)
Cc                    THE DIMENSION OF DFY MUST NOT EXCEED LDFY. FOR EXAMPLE IF
Cc                    LDFY>=NY*NY*NM THEN DFY(NY,NY,NM) IS OK. DFY(LDFY) OR DFY(*)
Cc                    IS ALWAYS OK.
Cc                    THE DIMENSION OF DEV MUST NOT EXCEED LDEV. FOR EXAMPLE IF
Cc                    LDEV>=NV*NV THEN DEV(NV,NV) IS OK. DEV(LDEV) OR DEV(*)
Cc                    IS ALWAYS OK.
C                    INTEGER IBHI(*)
C                    REAL RPAR(*)
C                    INTEGER IPAR(*)
C                    BHI(1,1)=...GAMMA(I,1)*...
C                    RETURN
C                    END
C
C     PRECSOL     NAME (EXTERNAL) OF SUBROUTINE SOLVING A LINEAR SYSTEM WITH THE
C                 PRECONDITIONER TO
C                 H_i = [I O ] - h*sum_m gamma(i,m)*Fmy
C                       [O Ev]
C                 FOR THE PRECONDITIONED LINEAR ITERATIVE METHOD.
c2
C                    SUBROUTINE PRECSOL(I,NY,NU,NV,BHI,IBHI,VEC,RPAR,IPAR)
Cc                    ARGUMENTS:          NY,NU,NV,             RPAR,IPAR AS FOR SPARK3
Cc                               I       (INPUT) INDEX I OF THE 
Cc                                                  I-TH DECOMPOSED BLOCK H_i OF THE PRECONDITIONER
Cc                               BHI(*)  (INPUT) THE REAL SPACE ASSOCIATED TO THE
Cc                                                  I-TH DECOMPOSED BLOCK H_i OF THE PRECONDITIONER
Cc                               IBHI(*) (INPUT) THE INTEGER SPACE ASSOCIATED TO THE
Cc                                                  I-TH DECOMPOSED BLOCK H_i OF THE PRECONDITIONER
Cc                               VEC(NY) (INPUT/OUTPUT) THE RIGHT-HAND SIDE/THE SOLUTION VECTOR
C                    INTEGER I
c2end
C                    REAL BHI(*)
C                    INTEGER IBHI(*)
C                    REAL VEC(NY)
C                    REAL RPAR(*)
C                    INTEGER IPAR(*)
C                    RETURN
C                    END
C
C     PRDECVN     NAME (EXTERNAL) OF SUBROUTINE COMPUTING A DECOMPOSITION OF A
C                 PRECONDITIONER TO Ev. THIS WILL BE USED AS PART OF A PRECONDITIONER
C                 FOR THE PRECONDITIONED LINEAR ITERATIVE METHOD. USED ONLY WHEN
C                 NV>=1 AND ONE SET OF RK COEFFICIENTS USED FOR e(t,y)'=...
C                 IS NOT STIFFLY ACCURATE. OTHERWISE SUPPLY A DUMMY SUBROUTINE.
C                    SUBROUTINE PRDECVN(T,NY,NU,NV,Y,
C                   &                   LDEV,DEV,VP,IVP,IER,RPAR,IPAR)
Cc                    ARGUMENTS:        T,NY,NU,NV,Y,       RPAR,IPAR AS FOR SPARK3
Cc                               LDEV      (INPUT) THE DIMENSION OF DEV
Cc                               DEV(....) (INPUT) QUANTITIES NEEDED FOR Ev
Cc                               VP(*)     (INPUT/OUTPUT) THE REAL SPACE ASSOCIATED TO THE
Cc                                                 DECOMPOSED PRECONDITIONER TO Ev
Cc                               IVP(*)    (OUTPUT) THE INTEGER SPACE ASSOCIATED TO THE
Cc                                                 DECOMPOSED PRECONDITIONER TO Ev
Cc                               IER       (OUTPUT) REPORTS ON SUCCESSFULNESS UPON RETURN
C                    REAL T,Y(NY),DEV(....),VP(*)
Cc                    THE DIMENSION OF DEV MUST NOT EXCEED LDEV. FOR EXAMPLE IF
Cc                    LDEV>=NV*NV THEN DEV(NV,NV) IS OK. DEV(LDEV) OR DEV(*)
Cc                    IS ALWAYS OK.
C                    INTEGER IVP(*)
C                    REAL RPAR(*)
C                    INTEGER IPAR(*)
C                    VP(1,1)=...
C                    RETURN
C                    END
C
C     PRSOLVN     NAME (EXTERNAL) OF SUBROUTINE SOLVING A LINEAR SYSTEM WITH
C                 THE PRECONDITIONER TO Ev FOR THE PRECONDITIONED LINEAR ITERATIVE METHOD. USED ONLY
C                 WHEN NV>=1 AND ONE SET OF RK COEFFICIENTS USED FOR e(t,y)'=...
C                 IS NOT STIFFLY ACCURATE. OTHERWISE SUPPLY A DUMMY SUBROUTINE.
C                    SUBROUTINE PRSOLVN(NY,NU,NV,VP,IVP,VEC,RPAR,IPAR)
Cc                    ARGUMENTS:        NY,NU,NV,           RPAR,IPAR AS FOR SPARK3
Cc                               VP(*)   (INPUT) THE REAL SPACE ASSOCIATED TO THE
Cc                                               DECOMPOSED PRECONDITIONER TO Ev
Cc                               IVP(*)  (INPUT) THE INTEGER SPACE ASSOCIATED TO THE
Cc                                               DECOMPOSED PRECONDITIONER TO Ev
Cc                               VEC(NV) (INPUT/OUTPUT) THE RIGHT-HAND SIDE/THE SOLUTION VECTOR
C                    REAL VP(*)
C                    INTEGER IVP(*)
C                    REAL VEC(NV)
C                    REAL RPAR(*)
C                    INTEGER IPAR(*)
C                    RETURN
C                    END
C
C     H           INITIAL STEPSIZE LENGTH (WITH SIGN!)
C                 USUALLY HAVING ABS(H)=1.E-3 OR 1.E-5 IS GOOD.
C                 IN CASE OF CONSTANT STEPSIZES THIS CHOICE IS VERY IMPORTANT.
C                 STUDY THE CHOSEN VALUES FOR A FEW STEPS IN SUBROUTINE SOLOUT
C                 WHEN YOU ARE NOT SURE
C                 THE VALUE TAKEN FOR THE FIRST TIME STEP IS 
C                 H=SGN(TEND-T)*MAX(RWORK(6),MIN(ABS(H),RWORK(7),ABS(TEND-T)))
C
C     ITOLY       SWITCH FOR RTOLY AND ATOLY:
C                   ITOLY=0: BOTH RTOLY AND ATOLY ARE SCALARS.
C                     THE CODE KEEPS, ROUGHLY, THE LOCAL ERROR OF
C                     Y(I)       BELOW   RTOLY*ABS(Y(I))+ATOLY
C                     WHEN SOLVING THE LARGE NONLINEAR SYSTEM THE CODE KEEPS
C                     ROUGHLY THE ERROR AT T OF
C                     Y(I)       BELOW   RWORK(4)*(RTOLY*ABS(Y(I))+ATOLY).
C
C                   ITOLY=1: BOTH RTOLY AND ATOLY ARE VECTORS.
C                     THE CODE KEEPS, ROUGHLY, THE LOCAL ERROR OF
C                     Y(I)       BELOW   RTOLY(I)*ABS(Y(I))+ATOLY(I)
C                     WHEN SOLVING THE LARGE NONLINEAR SYSTEM THE CODE KEEPS
C                     ROUGHLY THE ERROR AT T OF
C                     Y(I)       BELOW   RWORK(4)*(RTOLY(I)*ABS(Y(I))+ATOLY(I)).
C
C     RTOLY,ATOLY RELATIVE AND ABSOLUTE ERROR TOLERANCES FOR Y.
C                 THEY CAN BE BOTH SCALARS OR ELSE BOTH VECTORS OF LENGTH NY.
C
C     IOUT        SWITCH FOR CALLING THE SUBROUTINE SOLOUT:
C                   IOUT=0: SOLOUT IS NEVER CALLED
C                   IOUT=1: SOLOUT IS AVAILABLE FOR OUTPUT.
C
C     SOLOUT      NAME (EXTERNAL) OF SUBROUTINE PROVIDING THE
C                 NUMERICAL SOLUTION DURING INTEGRATION.
C                 IF (IOUT>=1) IT IS CALLED AFTER EVERY SUCCESSFUL STEP.
C                 SUPPLY A DUMMY SUBROUTINE IF IOUT=0.
C                    SUBROUTINE SOLOUT(NR,TSOLY,T,NY,NU,NV,Y,NS,ISNY,C,IC1CS,
C                  &                   HSOLY,NCONTY,CONTY,RPAR,IPAR,IRTRN)
Cc                    ARGUMENTS:                T,NY,NU,NV,Y,NS,
Cc                                                        RPAR,IPAR        AS FOR SPARK3
Cc                               NR            (INPUT) T IS THE NR-TH GRID-POINT
Cc                               TSOLY         (INPUT) THE PREVIOUS GRID-POINT
Cc                               ISNY(NS)      (INPUT) ARRAY CONTAINING NY*IS (IS=1,...,NS)
Cc                               C(NS)         (INPUT) NODES OF THE UNDERLYING QUADRATURE FORMULA
Cc                               IC1CS         (INPUT) SWITCH RELATED TO C(1)?=0.0 AND C(NS)?=1.0
Cc                               HSOLY         (INPUT) THE PREVIOUS STEPSIZE
Cc                               NCONTY        (INPUT) THE DIMENSION OF CONTY
Cc                               CONTY(NCONTY) (INPUT) VECTOR OF VALUES FOR THE CONTINUOUS SOLUTION  
Cc                               IRTRN         (OUTPUT) FLAG TO INTERRUPT SPARK3
C                    REAL TSOLY,T,Y(NY),C(NS),HSOLY,CONTY(NCONTY)
C                    INTEGER ISNY(NS),IC1CS
C                    REAL RPAR(*)
C                    INTEGER IPAR(*)
C                    ....  
C                    RETURN
C                    END
C
C                 SOLOUT FURNISHES THE SOLUTION Y AT THE NR-TH GRID-POINT T
C                   (THEREBY THE INITIAL VALUE IS THE FIRST GRID-POINT).
C                 TSOLY IS THE PREVIOUS GRID-POINT.
C                 IRTRN SERVES TO INTERRUPT THE INTEGRATION. IF IRTRN
C                   IS SET <0, SPARK3 RETURNS TO THE CALLING PROGRAM.
C
C          -----  CONTINUOUS OUTPUT: -----
C                 DURING CALLS TO SOLOUT, A CONTINUOUS SOLUTION FOR THE
C                 INTERVAL [TSOLY,T] IS AVAILABLE THROUGH THE REAL FUNCTION
C                 >>>   CONTRY(I,S,YTAG,NY,Y,NS,ISNY,C,IC1CS,HSOLY,TSOLY,NCONTY,CONTY)   <<<
C                 WHICH PROVIDES AN APPROXIMATION TO THE I-TH COMPONENT
C                 OF THE SOLUTION Y AT THE POINT S.
C                 THE VALUE S MUST LIE IN THE INTERVAL [TOLD,T].
C                 YTAG IS A LOGICAL FLAG INDICATING IF THE 
C                 CONTINUOUS OUTPUT POLYNOMIAL STARTS WITH CONSTANT Y(I)
C                 (YTAG=.TRUE.) OR WITH CONSTANT 0.0 (YTAG=.FALSE.).
C                 DO NOT CHANGE THE ENTRIES 
C                 NY,Y,NS,ISNY(NS),C(NS),IC1CS,HSOLY,TSOLY,NCONTY,CONTY(NCONTY).
C
C     LRWORK      DECLARED LENGTH OF ARRAY RWORK.
C                 LRWORK MUST BE AT LEAST
C                 128+... (KEEPS CHANGING AS LONG AS THE CODE IS STILL UNDER CHANGES)
C                 WHERE NSYS=NS*NY
C
C     RWORK       ARRAY OF WORKING SPACE OF LENGTH LRWORK.
C                 RWORK(1),...,RWORK(40) SERVE AS PARAMETERS
C                 FOR THE CODE. FOR STANDARD USE OF THE CODE
C                 RWORK(1),...,RWORK(40) MUST BE SET TO -1.0 BEFORE
C                 CALLING. SEE BELOW FOR A MORE SOPHISTICATED USE.
C                 RWORK(41),...,RWORK(LRWORK) SERVE AS WORKING SPACE
C                 FOR ALL VECTORS AND MATRICES.
C
C     LIWORK      DECLARED LENGTH OF ARRAY IWORK.
C                 LIWORK MUST BE AT LEAST
C                 64+... (KEEPS CHANGING AS LONG AS THE CODE IS STILL UNDER CHANGES)
C
C     IWORK       INTEGER WORKING SPACE OF LENGTH LIWORK.
C                 IWORK(1),...,IWORK(40) SERVE AS PARAMETERS
C                 FOR THE CODE. FOR STANDARD USE, SET
C                 IWORK(1),..,IWORK(40) TO -1 BEFORE CALLING.
C                 IWORK(41),...,IWORK(LIWORK) SERVE AS WORKING AREA.
C
C     LRPAR       DECLARED LENGTH OF ARRAY RPAR.
C
C     RPAR        REAL    PARAMETERS (OR PARAMETER ARRAY) WHICH
C                 CAN BE USED FOR COMMUNICATION BETWEEN YOUR CALLING
C                 PROGRAM AND THE FCNM,DFYCNM,DFYVECCNM,ECN,DEVCN,DEVVECCN,
C                 PRECDEC,PRECSOL,PRDECVN,PRSOLVN,SOLOUT SUBROUTINES.
C
C     LIPAR       DECLARED LENGTH OF ARRAY IPAR.
C
C     IPAR        INTEGER PARAMETERS (OR PARAMETER ARRAY) WHICH
C                 CAN BE USED FOR COMMUNICATION BETWEEN YOUR CALLING
C                 PROGRAM AND THE FCNM,DFYCNM,DFYVECCNM,ECN,DEVCN,DEVVECCN,
C                 PRECDEC,PRECSOL,PRDECVN,PRSOLVN,SOLOUT SUBROUTINES.
C
C-----------------------------------------------------------------------
C
C     SOPHISTICATED SETTING OF PARAMETERS
C     -----------------------------------
C               SEVERAL PARAMETERS OF THE CODE ARE TUNED TO MAKE IT WORK WELL.
C               THEY MAY BE DEFINED BY SETTING IWORK(1),..,IWORK(40)
C               AS WELL AS RWORK(1),..,RWORK(40) DIFFERENT FROM -1 AND -1.0.
C               FOR -1 AND -1.0 INPUT, THE CODE CHOOSES DEFAULT VALUES:
C
C     IWORK( 1) MAXIMUM NUMBER OF ALLOWED STEPS.
C        DEFAULT VALUE (FOR IWORK(1)<=0) IS IWORK(1)=100000.
C
C     IWORK( 2) MINIMUM NUMBER OF INEXACT APPROXIMATE SIMPLIFIED NEWTON 
C               ITERATIONS AT EACH STEP.
C        DEFAULT VALUE (FOR IWORK(2)<=0) IS IWORK(2)=1.
C
C     IWORK( 3) MAXIMUM NUMBER OF INEXACT APPROXIMATE SIMPLIFIED NEWTON 
C               ITERATIONS AT EACH STEP.
C        DEFAULT VALUE (FOR IWORK(3)<=0) IS IWORK(3)=7.
C
C     IWORK( 4) SWITCH FOR THE STARTING VALUES OF THE INEXACT APPROXIMATE 
C               SIMPLIFIED NEWTON ITERATIONS.
C                 IWORK(4)=0: THEY ARE SET TO ZERO
C        DEFAULT: IWORK(4)=1: THEY ARE SET WITH THE DENSE OUTPUT FORMULA
C        DEFAULT VALUE (FOR IWORK(4)<=-1 OR >=2) IS IWORK(4)=1.
C
C     IWORK( 5) SWITCH INDICATING IF ONE SET OF SPARK COEFFICIENTS USED FOR
C               THE DIFFERENTIAL EQUATION e(t,y)'=... IS NOT STIFFLY ACCURATE. IF YES
C               WE NEED TO SOLVE AN ADDITIONAL EQUATION FOR THE NUMERICAL SOLUTION v_n
C               AND IWORK(5) MUST BE SET TO 1.
C        DEFAULT: IWORK(5)=0: NV<=0 OR ONLY STIFFLY ACCURATE COEFFICIENTS ARE USED FOR e(t,y)'
C                 IWORK(5)=1:           NON-STIFFLY ACCURATE COEFFICIENTS ARE USED FOR e(t,y)'
C        DEFAULT VALUE (FOR IWORK(5)<=-1 OR >=2) IS IWORK(5)=0.
C
C     IWORK( 6) SWITCH FOR THE PRECONDITIONED LINEAR ITERATIVE METHOD.
C                 IWORK(6)=0: THERE IS NO LINEAR ITERATION, IT CONSISTS OF JUST ONE 
C                             APPLICATION OF THE PRECONDITIONER (LEADS TO "FIXED-POINT"
C                             ITERATIONS WHEN THE PRECONDITIONER IS JUST THE IDENTITY).
C                 IWORK(6)=1: RICHARDSON       (REQUIRES IWORK(28)>=1)
C        DEFAULT: IWORK(6)=2: GMRES(IWORK(29)) (REQUIRES IWORK(28)>=1) ???
C        DEFAULT VALUE (FOR IWORK(6)<=-1 OR >=3) IS IWORK(6)=2.
C
C     IWORK( 7) NUMBER OF MATRICES H_i TO DECOMPOSE
C        ON A SERIAL   COMPUTER IWORK(7)=1  IS FINE.
C        ON A PARALLEL COMPUTER IWORK(7)=NS.
C        DEFAULT VALUE IF (IWORK(7)<>1) AND (IWORK(7)<>NS) IS IWORK(7)=1
C
C     IWORK( 8) SWITCH FOR THE STEPSIZE CONTROL STRATEGY.
C                 IWORK(8)=0: CLASSICAL VARIABLE STEPSIZE CONTROL
C                 IWORK(8)=1: CONSTANT STEPSIZES
C        DEFAULT: IWORK(8)=2: PREDICTIVE VARIABLE STEPSIZE CONTROL OF GUSTAFSSON
C        DEFAULT VALUE (FOR IWORK(8)<=-1 OR >=3) IS IWORK(8)=2.
C
C     IWORK( 9) LENGTH OF EACH REAL    WORKSPACE  BHI USED FOR THE PRECONDITIONER TO
C                 H_i = [I O ] - h*sum_m gamma(i,m)*Fmy
C                       [O Ev]
C               IN SUBROUTINES PRECDEC AND PRECSOL.
C               REAL WORKSPACE REQUIRED BY PRECDEC AND/OR PRECSOL AND SPACE FOR
C               DATA TO BE COMMUNICATED FROM PRECDEC TO PRECSOL IS MADE AVAILABLE
C               IN THE FORM OF ARRAYS BHI WHICH ARE PARTS OF ARRAY RWORK.
C        DEFAULT VALUE (FOR IWORK(9)<=0) IS IWORK(9)=1.
C
C     IWORK(10) LENGTH OF  THE REAL    WORKSPACE  VP USED FOR THE PRECONDITIONER TO Ev
C               IN SUBROUTINES PRDECVN AND PRSOLVN.
C               REAL WORKSPACE REQUIRED BY PRDECVN AND/OR PRSOLVN AND SPACE FOR
C               DATA TO BE COMMUNICATED FROM PRDECVN TO PRSOLVN IS MADE AVAILABLE
C               IN THE FORM OF ARRAY VP WHICH IS PART OF ARRAY RWORK.
C        DEFAULT VALUE (FOR IWORK(10)<=0) IS IWORK(10)=1.
C
C     IWORK(11) LENGTH OF EACH INTEGER WORKSPACE IBHI USED FOR THE PRECONDITIONER TO
C                 H_i = [I O ] - h*sum_m gamma(i,m)*Fmy
C                       [O Ev]
C               IN SUBROUTINES PRECDEC AND PRECSOL.
C               INTEGER WORKSPACE REQUIRED BY PRECDEC AND/OR PRECSOL AND SPACE FOR
C               DATA TO BE COMMUNICATED FROM PRECDEC TO PRECSOL IS MADE AVAILABLE
C               IN THE FORM OF ARRAYS IBHI WHICH ARE PARTS OF ARRAY IWORK.
C        DEFAULT VALUE (FOR IWORK(11)<=0) IS IWORK(11)=1.
C
C     IWORK(12) LENGTH OF  THE INTEGER WORKSPACE IVP  USED FOR THE PRECONDITIONER TO Ev
C               IN SUBROUTINES PRDECVN AND PRSOLVN.
C               INTEGER WORKSPACE REQUIRED BY PRDECVN AND/OR PRSOLVN AND SPACE FOR
C               DATA TO BE COMMUNICATED FROM PRDECVN TO PRSOLVN IS MADE AVAILABLE
C               IN THE FORM OF ARRAY IVP WHICH IS PART OF ARRAY IWORK.
C        DEFAULT VALUE (FOR IWORK(12)<=0) IS IWORK(12)=1.
C
C     IWORK(13) NOT DEFINED
C
C     IWORK(14) NOT DEFINED
C
C     IWORK(15) NOT DEFINED
C
C     IWORK(16) NOT DEFINED
C
C     IWORK(17) NOT DEFINED
C
C     IWORK(18) NOT DEFINED
C
C     IWORK(19) NOT DEFINED
C
C     IWORK(20) NOT DEFINED
C
C     IWORK(21) NOT DEFINED
C
C     IWORK(22) NOT DEFINED
C
C     IWORK(23) NOT DEFINED
C
C     IWORK(24) NOT DEFINED
C
C     IWORK(25) NOT DEFINED
C
C     IWORK(26) NOT DEFINED
C
C     IWORK(27) NOT DEFINED
C
C     IWORK(28) MAXIMUM NUMBER OF ITERATIONS FOR THE PRECONDITIONED LINEAR ITERATIVE METHOD. 
C               IF (IWORK(28)=0) THERE IS NO LINEAR ITERATION, IT CONSISTS OF JUST ONE 
C               APPLICATION OF THE PRECONDITIONER (LEADS TO "FIXED-POINT" ITERATIONS WHEN
C               THE PRECONDITIONER IS JUST THE IDENTITY).
C        DEFAULT VALUE (FOR IWORK(28)<=-1) IS IWORK(28)=20.
C
C     IWORK(29) MAXIMUM DIMENSION OF THE KRYLOV SUBSPACE FOR GMRES (RESTART PARAMETER)
C        DEFAULT VALUE IF (IWORK(6)=2) (FOR IWORK(29)<=-1) IS IWORK(29)=10
C
C-----------------------------------------------------------------------
C
C     RWORK( 1) ROUNDING UNIT, SMALLEST NUMBER v  ON THE COMPUTER SATISFYING 1.0+v>1.0.
C                VALUE IS RWORK(1)=MAX(EPSILON(1.0)/2.0,RWORK(1))
C
C     RWORK( 2) THE SAFETY FACTOR IN STEPSIZE PREDICTION.
C               THIS FACTOR MUST BE IN [0.001,1.0].
C        DEFAULT VALUE (FOR RWORK(2)<0.001 OR >1.0 ) IS RWORK(2)=0.9.
C
C     RWORK( 3) REFERENCE RATE OF CONVERGENCE FOR THE INEXACT APPROXIMATE SIMPLIFIED 
C               NEWTON METHOD. RWORK(3) SHOULD NOT BE GREATER THAN 0.4.
C               DECREASE RWORK(3) TO 0.02 SAY FOR HIGH PRECISION REQUIREMENTS
C               IF THE PROBLEM IS NOT TOO NONLINEAR.
C        DEFAULT VALUE (FOR RWORK(3)<=0.0 OR >=1.0) IS RWORK(3)=0.15.
C
C     RWORK( 4) STOPPING CRITERION FOR THE INEXACT APPROXIMATE SIMPLIFIED 
C               NEWTON METHOD, USUALLY CHOSEN <1.
C               SMALLER VALUES OF RWORK(4) INCREASE THE NUMBER OF FUNCTION
C               EVALUATIONS, THIS MAKES THE CODE SLOWER, BUT SAFER.
C        DEFAULT VALUE (FOR RWORK(4)<=0.0) IS RWORK(4)=0.01.
C
C     RWORK( 5) STOPPING CRITERION FACTOR FOR THE PRECONDITIONED LINEAR ITERATIVE METHOD.
C               SMALLER VALUES OF RWORK(5) INCREASE THE NUMBER OF SOLVES
C               THIS MAKES THE CODE SLOWER, BUT SAFER.
C        DEFAULT VALUE (FOR RWORK(5)<0.0 OR >=1.0) IS RWORK(5)=0.1.
C
C     RWORK( 6) MINIMUM ABSOLUTE STEPSIZE LENGTH.
C        DEFAULT VALUE (FOR RWORK(6)<=0.0) IS RWORK(6)=ABS(SQRT(RWORK(1))).
C
C     RWORK( 7) MAXIMUM ABSOLUTE STEPSIZE LENGTH.
C        DEFAULT VALUE (FOR RWORK(7)<=0.0) IS RWORK(7)=ABS(TEND-T).
C
C     RWORK( 8, 9) PARAMETERS FOR STEPSIZE SELECTION.
C               THE NEW STEPSIZE IS CHOSEN SUBJECT TO THE RESTRICTION
C                 RWORK(8) <= HNEW/H <= RWORK(9)
C        DEFAULT VALUE (FOR RWORK(8)<=0.0 OR >1.0) IS RWORK(8)=0.2.
C        DEFAULT VALUE (FOR RWORK(9)<1.0) IS RWORK(9)=8.0.
C
C     RWORK(10) NOT DEFINED
C
C     RWORK(11) NOT DEFINED
C
C     RWORK(12,13) PARAMETERS FOR THE EVALUATION AND DECOMPOSITION OF A NEW APPROXIMATE JACOBIAN.
C               IF (THETA-ABS(H/HDEC-1.0)) > RWORK(12) THEN
C                  EVALUATE AND DECOMPOSE A NEW APPROXIMATE JACOBIAN;
C               IF  THETA                   > RWORK(13) THEN
C                               DECOMPOSE A NEW APPROXIMATE JACOBIAN.
C               OTHERWISE A NEW JACOBIAN DECOMPOSITION IS NOT COMPUTED PROVIDED THE INEXACT 
C               APPROXIMATE SIMPLIFIED NEWTON ITERATIONS WERE CONVERGING SUFFICIENTLY FAST 
C               DURING THE PREVIOUS STEP. THIS SAVES DECOMPOSITIONS AND COMPUTING TIME FOR
C               LARGE SYSTEMS. FOR SYSTEMS WITH CHEAP EVALUATIONS AND DECOMPOSITIONS OF THE 
C               JACOBIAN ONE MAY DECREASE THESE 2 PARAMETERS TO SAY 
C               RWORK(12)=0.01, RWORK(13)=0.01.
C               FOR SYSTEMS WITH COSTLY EVALUATIONS AND DECOMPOSITIONS OF THE JACOBIAN ONE MAY 
C               INCREASE THESE 2 PARAMETERS TO A MAXIMUM SAY OF 
C               RWORK(12)=0.2, RWORK(13)=0.2.
C               RWORK(12)=0.0 FORCES THE CODE TO EVALUATE AND DECOMPOSE THE APPROXIMATE
C               JACOBIAN AFTER EVERY ACCEPTED STEP.
C               RWORK(13)=0.0 FORCES THE CODE TO              DECOMPOSE THE APPROXIMATE
C               JACOBIAN AFTER EVERY ACCEPTED STEP.
C        DEFAULT VALUE (FOR RWORK(12)<0.0 OR >1.0) IS RWORK(12)=0.1.
C        DEFAULT VALUE (FOR RWORK(13)<0.0 OR >1.0) IS RWORK(13)=0.1.
C
C-----------------------------------------------------------------------
C
C     OUTPUT PARAMETERS
C     -----------------
C
C     T           T-VALUE FOR WHICH THE SOLUTION HAS BEEN COMPUTED
C                 (AFTER SUCCESSFUL RETURN T=TEND).
C
C     Y(NY)       NUMERICAL APPROXIMATION OF VECTOR Y AT T.
C
C     H           PREDICTED STEPSIZE OF THE LAST ACCEPTED STEP.
C
C     IDID        REPORTS ON SUCCESSFULNESS UPON RETURN:
C                   IDID= 1  COMPUTATION SUCCESSFUL;
C                   IDID= 2  COMPUTATION SUCCESSFUL INTERRUPTED BY SOLOUT;
C                   IDID=-1  INPUT INVALID;
C                   IDID=-2  MORE STEPS ARE NEEDED, 
C                            INCREASE IWORK( 2);
C                   IDID=-3  APPROXIMATE JACOBIAN IS SINGULAR;
C
C     IWORK(30)   (NFCN) TOTAL NUMBER OF CALLS TO NM FCNM (THOSE FOR NUMERICAL
C                 EVALUATION OF THE APPROXIMATE JACOBIANS Fmy ARE NOT COUNTED).  
C
C     IWORK(31)   (NECN) TOTAL NUMBER OF CALLS TO ECN (THOSE FOR NUMERICAL
C                 EVALUATION OF THE APPROXIMATE JACOBIAN  Ev  ARE NOT COUNTED).  
C
C     IWORK(32)   (NDFY) TOTAL NUMBER OF APPROXIMATE JACOBIANS Fmy EVALUATIONS
C                 (EITHER ANALYTICALLY OR NUMERICALLY).
C
C     IWORK(33)   (NDEV) TOTAL NUMBER OF APPROXIMATE JACOBIAN  Ev  EVALUATIONS 
C                 (EITHER ANALYTICALLY OR NUMERICALLY).
C
C     IWORK(34)   (NSTEP)   TOTAL NUMBER OF COMPUTED STEPS.
C
C     IWORK(35)   (NACCEPT) TOTAL NUMBER OF ACCEPTED STEPS.
C
C     IWORK(36)   (NREJECTERR) TOTAL NUMBER OF REJECTED STEPS (DUE TO ERROR TEST,
C                 STEP REJECTIONS IN THE FIRST STEP ARE NOT COUNTED).
C
C     IWORK(37)   (NLINIT) TOTAL NUMBER OF INNER         PRECONDITIONED LINEAR ITERATIONS.
C
C     IWORK(38)   (NNEWT)  TOTAL NUMBER OF OUTER APPROXIMATE SIMPLIFIED NEWTON ITERATIONS.
C
C     IWORK(39)   (NJACDEC) TOTAL NUMBER OF PRECONDITIONER DECOMPOSITIONS.
C
C     IWORK(40)   (NJACSOL) TOTAL NUMBER OF PRECONDITIONER SOLVES.
C
C     IWORK(41)   (NPVNDEC) TOTAL NUMBER OF PRECONDITIONER TO VN DECOMPOSITIONS.
C
C     IWORK(42)   (NPVNSOL) TOTAL NUMBER OF PRECONDITIONER TO VN SOLVES.
C
C     IWORK(43)   (NMATVECPROD) TOTAL NUMBER OF MATRIX-VECTOR PRODUCTS.
C
C     IWORK(44)   (NREJECTITER) TOTAL NUMBER OF REJECTED STEPS (DUE TO ITERATION
C                 PROBLEMS, DIVERGENCE OR TOO SLOW CONVERGENCE).
C
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: NS
      INTEGER, INTENT(IN   ) :: NM
      INTEGER, INTENT(IN   ) :: ME(*)
      REAL   , INTENT(INOUT) :: T
      REAL   , INTENT(IN   ) :: TEND
      INTEGER, INTENT(IN   ) :: NY
      INTEGER, INTENT(IN   ) :: NU
      INTEGER, INTENT(IN   ) :: NV
      REAL   , INTENT(INOUT) :: Y(*)
      EXTERNAL                  FCNM
      EXTERNAL                  DFYCNM
      INTEGER, INTENT(INOUT) :: IDFYCNM(NM)
      EXTERNAL                  DFYVECCNM
      INTEGER, INTENT(INOUT) :: IDFYVECCNM(NM)
      INTEGER, INTENT(INOUT) :: LDFYM(NM)
      EXTERNAL                  ECN
      EXTERNAL                  DEVCN
      INTEGER, INTENT(INOUT) :: IDEVCN
      EXTERNAL                  DEVVECCN
      INTEGER, INTENT(INOUT) :: IDEVVECCN
      INTEGER, INTENT(INOUT) :: LDEV
      EXTERNAL                  PRECDEC
      EXTERNAL                  PRECSOL
      EXTERNAL                  PRDECVN
      EXTERNAL                  PRSOLVN
      REAL   , INTENT(INOUT) :: H
      INTEGER, INTENT(IN   ) :: ITOLY
      REAL   , INTENT(IN   ) :: RTOLY(*)
      REAL   , INTENT(IN   ) :: ATOLY(*)
      INTEGER, INTENT(IN   ) :: IOUT
      EXTERNAL                  SOLOUT
      INTEGER, INTENT(IN   ) :: LRWORK
      REAL   , INTENT(INOUT) :: RWORK(*)
      INTEGER, INTENT(IN   ) :: LIWORK
      INTEGER, INTENT(INOUT) :: IWORK(*)
      INTEGER, INTENT(IN   ) :: LRPAR
      REAL   , INTENT(IN   ) :: RPAR(*)
      INTEGER, INTENT(IN   ) :: LIPAR
      INTEGER, INTENT(IN   ) :: IPAR(*)
      INTEGER, INTENT(  OUT) :: IDID
C    LOCAL PARAMETERS
      INTEGER, PARAMETER     :: LIWORKPARAMETER = 128
      INTEGER, PARAMETER     :: LRWORKPARAMETER =  64
C    LOCAL VARIABLES
      INTEGER :: I,IEA,IEAINV,IEB,IEBETA,IEBFBETA,IEBH,IEC
      INTEGER :: IECINV,IECONTY,IEDEV,IEDEVVEC,IEDFMYVEC
      INTEGER :: IEDFY,IEE,IEEN,IEERRC,IEE0,IEF,IEF0M,IEGAMMA,IEHWORK
      INTEGER :: IEKDFYM,IEIBH,IEIBHI,IEISM1TNYP1,IEISNY,IEIVP,IEOMEGA
      INTEGER :: IESCALYINV,IESTIFFLYACC,IETPCHIS,IETMP1NY,IETMP2NY
      INTEGER :: IEVEC,IEVECN,IEVP,IEVWORK,IEZNY,IEZY
      INTEGER :: ISTARTNEWT,ISTEPSIZE,LBHI,LBHINBHI,LDFY,LIBHI
      INTEGER :: LIBHINBHI,LINIT,LISTORE,LIVP,LNV,LRSTORE,LVP,M
      INTEGER :: MAXKRYLOV,MAXLINIT,MAXNEWT,MINNEWT,NBCOLVWORK,NBIGSYS
      INTEGER :: NCONTY,NMAX,NBHI,NSLNV,NSNM,NS2,NS2NM,NV2,NYNM,NYNMNS
      INTEGER :: NYNS,NY2
      LOGICAL                :: INVALID,NVGE1,SOLVEVN
      REAL                   :: ABSHMAX,ABSHMIN,FACL,FACR,FLINIT,FNEWT
      REAL                   :: SAFE,THET,THETADNEWEVAL,THETAJNEWDEC
      REAL                   :: UROUND
C
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE SPARK3
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C    INITIALIZATION OF IWORK OUTPUT VALUES
C-----------------------------------------------------------------------
      DO I=30,LIWORKPARAMETER
         IF ((IWORK(I))<=(-1)) IWORK(I)=0
      ENDDO
C-----------------------------------------------------------------------
C    SETTING THE PARAMETERS
C-----------------------------------------------------------------------
      INVALID=.FALSE.
      IF (NY<=0) THEN
         WRITE(6,*)' WARNING: NY=', NY,' <= 0'
         IDID=1
C --------  NO EQUATION TO BE SOLVED: SUCCESSFUL RETURN -----
         RETURN
      ENDIF
      IF     (NU< 0) THEN
         WRITE(6,*)' INVALID INPUT FOR NU=',NU
         WRITE(6,*)' NU=', NU,' MUST BE >= 0'
         INVALID=.TRUE.
      ELSEIF (NU>NY) THEN
         WRITE(6,*)' INVALID INPUT FOR NU=',NU
         WRITE(6,*)' NU=', NU,' MUST BE <= ',NY
         INVALID=.TRUE.
      ENDIF
      IF     (NV< 0) THEN
         WRITE(6,*)' INVALID INPUT FOR NV=',NV
         WRITE(6,*)' NV=', NV,' MUST BE >= 0'
         INVALID=.TRUE.
      ELSEIF (NV>NY) THEN
         WRITE(6,*)' INVALID INPUT FOR NV=',NV
         WRITE(6,*)' NV=', NV,' MUST BE <= ',NY
         INVALID=.TRUE.
      ENDIF
      NVGE1=(NV>=1)
      IF  (NU+NV/=NY) THEN
         WRITE(6,*)' INVALID INPUT FOR NY=',NY
         WRITE(6,*)'                   NU=',NU
         WRITE(6,*)'                OR NV=',NV
         WRITE(6,*)' NY=', NY,' MUST BE EQUAL TO NU+NV=',NU+NV
         INVALID=.TRUE.
      ENDIF

      IF     (NM<= 0) THEN
         WRITE(6,*)' INVALID INPUT FOR NM=',NM
         WRITE(6,*)' NM=', NM,' MUST BE >= 1'
         INVALID=.TRUE.
      ENDIF

      NS2    =NS*NS
      NSNM   =NS*NM
      NS2NM  =NS2*NM
      NYNS   =NY*NS
      NCONTY =NYNS
      NYNM   =NY*NM
      NYNMNS =NYNM*NS
      NY2    =NY*NY
      NV2    =NV*NV

C ----- NMAX: MAXIMUM NUMBER OF ALLOWED STEPS -----
      IF (IWORK(1)>=1) THEN
         NMAX=IWORK(1)
      ELSE
         NMAX=100000
      ENDIF
C ----- MINNEWT: MINIMUM NUMBER OF INEXACT APPROXIMATE SIMPLIFIED -----
C ----- NEWTON ITERATIONS AT EACH STEP                            -----
      IF (IWORK(2)>=1) THEN
         MINNEWT=IWORK(2)
      ELSE
         MINNEWT=1
      ENDIF
C ----- MAXNEWT: MAXIMUM NUMBER OF INEXACT APPROXIMATE SIMPLIFIED -----
C ----- NEWTON ITERATIONS AT EACH STEP                            -----
      IF (IWORK(3)>=1) THEN
         MAXNEWT=IWORK(3)
      ELSE
         MAXNEWT=7
      ENDIF
      IF (MINNEWT>MAXNEWT) THEN
         WRITE(6,*)' INVALID INPUT FOR IWORK(2)=',IWORK(2),
     &                             'OR IWORK(3)=',IWORK(3)
         WRITE(6,*)' WE MUST HAVE IWORK(2) <= IWORK(3)'
         INVALID=.TRUE.
      ENDIF
C ----- ISTARTNEWT: SWITCH FOR THE STARTING VALUES OF INEXACT -----
C ----- APPROXIMATE SIMPLIFIED NEWTON ITERATIONS              -----
      IF ((IWORK(4)>=0).AND.(IWORK(4)<=1)) THEN
         ISTARTNEWT=IWORK(4)
      ELSE
         ISTARTNEWT=1
      ENDIF
C ----- SOLVEVN: SWITCH FOR ADDITIONAL EQUATION TO BE SOLVED FOR v_n -----
      IF ((IWORK(5)>=0).AND.(IWORK(5)<=1)) THEN
         SOLVEVN=((IWORK(5)==1).AND.(NVGE1))
      ELSE
         SOLVEVN=.FALSE.
      ENDIF
      IF (SOLVEVN) THEN
         NBIGSYS=NYNS+NV
      ELSE
         NBIGSYS=NYNS
      ENDIF
C ----- LINIT: SWITCH FOR THE PRECONDITIONED LINEAR ITERATIVE METHOD -----
      IF ((IWORK(6)>=0).AND.(IWORK(6)<=2)) THEN
         LINIT=IWORK(6)
      ELSE
         LINIT=2
      ENDIF
C ----- NBHI: NUMBER OF MATRICES H_i TO DECOMPOSE -----
      IF ((IWORK(7)==1).OR.(IWORK(7)==NS)) THEN
         NBHI=IWORK(7)
      ELSE
         NBHI=1
      ENDIF
C ----- ISTEPSIZE: SWITCH FOR STEPSIZE CONTROL STRATEGY -----
      IF ((IWORK(8)>=0).AND.(IWORK(8)<=2)) THEN
         ISTEPSIZE=IWORK(8)
      ELSE
         ISTEPSIZE=2
      ENDIF
C ----- LBHI: LENGTH OF EACH REAL WORKSPACE BHI      -----
      LBHI =MAX(1,IWORK( 9))
C ----- LVP: LENGTH OF REAL WORKSPACE VP             -----
      LVP  =MAX(1,IWORK(10))
C ----- LIBHI: LENGTH OF EACH INTEGER WORKSPACE IBHI -----
      LIBHI=MAX(1,IWORK(11))
C ----- LIVP: LENGTH OF INTEGER WORKSPACE IVP        -----
      LIVP =MAX(1,IWORK(12))
C ----- IDFYCNM(M)   : SWITCHES FOR THE COMPUTATION OF    DFYCNM(M,...) -----
      DO M=1,NM
         IF (   (IDFYCNM(M)<=-1).OR.(   IDFYCNM(M)>=3)) THEN
            IDFYCNM(M)=0
         ENDIF
      ENDDO
C ----- IDFYVECCNM(M): SWITCHES FOR THE COMPUTATION OF DFYVECCNM(M,...) -----
      DO M=1,NM
         IF ((IDFYVECCNM(M)<=-1).OR.(IDFYVECCNM(M)>=3)) THEN
            IDFYVECCNM(M)=0
         ENDIF
      ENDDO
C ----- LDFY: LENGTH OF REAL WORKSPACE DFY -----
      LDFY=0
      DO M=1,NM
         IF (IDFYCNM(M)==0) LDFYM(M)=NY2
         IF ( LDFYM(M)<=-1) LDFYM(M)=0
         LDFY=LDFY+LDFYM(M)
      ENDDO
      LDFY=MAX(1,LDFY)
C ----- IDEVCN   : SWITCH FOR THE COMPUTATION OF DEVCN    -----
      IF     (.NOT.(NVGE1)) THEN
         IDEVCN=2
      ELSEIF ((IDEVCN<=-1).OR.(IDEVCN>=3)) THEN
         IDEVCN=0
      ENDIF
C ----- IDEVVECCN: SWITCH FOR THE COMPUTATION OF DEVVECCN -----
      IF ((IDEVVECCN<=-1).OR.(IDEVVECCN>=3)) THEN
         IDEVVECCN=0
      ENDIF
C ----- LDEV: LENGTH OF REAL WORKSPACE DEV -----
      LDEV=MAX(1,LDEV)
C ----- MAXLINIT: MAXIMUM NUMBER OF ITERATIONS FOR THE -----
C ----- PRECONDITIONED LINEAR ITERATIVE METHOD         -----
      MAXLINIT=IWORK(28)
      IF     (MAXLINIT<=-1) THEN
         MAXLINIT=20
      ELSEIF (MAXLINIT== 0) THEN
         LINIT=0
      ENDIF
      MAXKRYLOV=0
      IF     (LINIT==0) THEN
C ----- INITIALIZATIONS FOR NO INNER PRECONDITIONED LINEAR ITERATIONS -----
         MAXLINIT=0
      ELSEIF (LINIT==1) THEN
C ----- INITIALIZATIONS FOR RICHARDSON -----
      ELSEIF (LINIT==2) THEN
C ----- INITIALIZATIONS FOR GMRES      -----
C -------- MAXKRYLOV: MAXIMUM DIMENSION OF THE KRYLOV SUBSPACE FOR GMRES (RESTART PARAMETER) -----
         MAXKRYLOV=IWORK(29)
         IF     (MAXKRYLOV<=-1) THEN
            MAXKRYLOV=10
         ELSEIF (MAXKRYLOV== 0) THEN
            LINIT=0
         ENDIF
      ENDIF
C ----- UROUND: UNIT ROUNDOFF, SMALLEST NUMBER SATISFYING FL(1.0+UROUND)>FL(1.0)      -----
C ----- IN DOUBLE PRECISION IEEE ARITHMETIC, UROUND=2.0**(-53)=~1.110223024625157E-16 -----
      UROUND=MAX(EPSILON(1.0)/2.0,RWORK(1))
C ----- SAFE: SAFETY FACTOR IN STEPSIZE PREDICTION -----
      IF ((RWORK(2)>=0.001).AND.(RWORK(2)<=1.0)) THEN
         SAFE=RWORK(2)
      ELSE
         SAFE=0.9
      ENDIF
C ----- THET: REFERENCE RATE OF CONVERGENCE FOR THE INEXACT ----- 
C -----       APPROXIMATE SIMPLIFIED NEWTON METHOD          -----
      IF ((RWORK(3)>0.0).AND.(RWORK(3)<1.0)) THEN
         THET=RWORK(3)
      ELSE
         THET=0.15
      ENDIF
C ----- FNEWT: STOPPING CRITERION FOR THE INEXACT   -----
C -----        APPROXIMATE SIMPLIFIED NEWTON METHOD -----
      IF (RWORK(4)>0.0) THEN
         FNEWT=RWORK(4)
      ELSE
         FNEWT=0.01
      ENDIF
C ----- FLINIT: STOPPING CRITERION FACTOR FOR THE      -----
C -----         PRECONDITIONED LINEAR ITERATIVE METHOD -----
      IF ((RWORK(5)>=0.0).AND.(RWORK(5)<1.0)) THEN
         FLINIT=RWORK(5)
      ELSE
         FLINIT=0.1
      ENDIF
C ----- ABSHMIN: MINIMUM STEPSIZE LENGTH -----
      IF (RWORK(6)>0.0) THEN
         ABSHMIN=RWORK(6)
      ELSE
         ABSHMIN=ABS(SQRT(UROUND))
      ENDIF
C ----- ABSHMAX: MAXIMUM STEPSIZE LENGTH -----
      IF (RWORK(7)>0.0) THEN
         ABSHMAX=RWORK(7)
      ELSE
         ABSHMAX=ABS(TEND-T)
      ENDIF
C ----- FACL, FACR: PARAMETERS FOR STEPSIZE SELECTION -----
      IF ((RWORK(8)>0.0).AND.(RWORK(8)<=1.0)) THEN
         FACL=1.0/RWORK(8)
      ELSE
         FACL=5.0
      ENDIF
      IF (RWORK(9)>=1.0) THEN
         FACR=1.0/RWORK(9)
      ELSE
         FACR=1.0/8.0
      ENDIF
C ----- PARAMETERS FOR THE EVALUATION AND DECOMPOSITION OF A NEW APPROXIMATE JACOBIAN -----
      IF ((RWORK(12)>=0.0).AND.(RWORK(12)<=1.0)) THEN
         THETADNEWEVAL=RWORK(12)
      ELSE
         THETADNEWEVAL=0.1
      ENDIF
      IF ((RWORK(13)>=0.0).AND.(RWORK(13)<=1.0)) THEN
         THETAJNEWDEC=RWORK(13)
      ELSE
         THETAJNEWDEC=0.1
      ENDIF
C ----- CHECK IF TOLERANCES ARE OK -----
      IF (ITOLY==0) THEN
         IF (ATOLY(1)<=0.0) THEN
            WRITE(6,*)' INVALID INPUT FOR ATOLY=',ATOLY(1)
            WRITE(6,*)' ATOLY MUST BE > 0.0'
            INVALID=.TRUE.
         ENDIF
         IF (RTOLY(1)<UROUND) THEN
            WRITE(6,*)' INVALID INPUT FOR RTOLY=',RTOLY(1)
            WRITE(6,*)' RTOLY MUST BE >=',UROUND
            INVALID=.TRUE.
         ENDIF
      ELSE
         DO I=1,NY
            IF (ATOLY(I)<=0.0) THEN
               WRITE(6,*)' INVALID INPUT FOR ATOLY(',I,')=',ATOLY(I)
               WRITE(6,*)' ATOLY(',I,') MUST BE > 0.0'
               INVALID=.TRUE.
            ENDIF
            IF (RTOLY(I)<UROUND) THEN
               WRITE(6,*)' INVALID INPUT FOR RTOLY(',I,')=',RTOLY(I)
               WRITE(6,*)' RTOLY(',I,') MUST BE >=',UROUND
               INVALID=.TRUE.
            ENDIF
         ENDDO
      ENDIF
C-----------------------------------------------------------------------
C    COMPUTATION OF ARRAY ENTRIES
C-----------------------------------------------------------------------
      LNV=MAX(1,NV)
      NSLNV   =NS*LNV
      LBHINBHI = LBHI*NBHI
      LIBHINBHI=LIBHI*NBHI

      IF     (LINIT==0) THEN
C ----- NUMBER OF VECTORS NEEDED FOR NO INNER PRECONDITIONED LINEAR ITERATIONS -----
         NBCOLVWORK=2
      ELSEIF (LINIT==1) THEN
C ----- NUMBER OF VECTORS NEEDED FOR RICHARDSON -----
         NBCOLVWORK=4
      ELSEIF (LINIT==2) THEN
C ----- NUMBER OF VECTORS NEEDED FOR GMRES      -----
         NBCOLVWORK=4+MAXKRYLOV
      ENDIF
C ----- PREPARE THE ENTRY-POINTS FOR THE ARRAYS IN RWORK (REAL WORKSPACE) -----
      IEDFMYVEC    =1           +LRWORKPARAMETER
      IEDFY        =IEDFMYVEC   +NY
      IEDEVVEC     =IEDFY       +LDFY
      IEDEV        =IEDEVVEC    +LNV
      IEB          =IEDEV       +LDEV
      IEC          =IEB         +NS
      IECINV       =IEC         +NS
      IEA          =IECINV      +NS
      IEAINV       =IEA         +NS2NM
      IEBETA       =IEAINV      +NS2NM
      IEBFBETA     =IEBETA      +NS
      IEGAMMA      =IEBFBETA    +NSNM
      IEOMEGA      =IEGAMMA     +NSNM
      IEERRC       =IEOMEGA     +NS2NM
      IETPCHIS     =IEERRC      +(1+NS)
      IECONTY      =IETPCHIS    +NS
      IETMP1NY     =IECONTY     +NCONTY
      IETMP2NY     =IETMP1NY    +NY
      IESCALYINV   =IETMP2NY    +NY
      IEZY         =IESCALYINV  +NY
      IEZNY        =IEZY        +NYNS
      IEF0M        =IEZNY       +NY
      IEF          =IEF0M       +NYNM
      IEE0         =IEF         +NYNMNS
      IEE          =IEE0        +LNV
      IEEN         =IEE         +NSLNV
      IEBH         =IEEN        +LNV
      IEVP         =IEBH        +LBHINBHI
      IEVEC        =IEVP        +LVP
      IEVECN       =IEVEC       +NYNS
      IEVWORK      =IEVECN      +LNV
      IEHWORK      =IEVWORK     +NBCOLVWORK*NBIGSYS
C ----- TOTAL STORAGE REQUIREMENT -----
      LRSTORE      =IEHWORK     +(MAXKRYLOV+1)*(MAXKRYLOV+3)-1
      IF (LRSTORE>LRWORK) THEN
         WRITE(6,*)' INSUFFICIENT STORAGE FOR RWORK'
         WRITE(6,*)' MINIMUM LRWORK=',LRSTORE
         INVALID=.TRUE.
      ELSE
         WRITE(6,*)' STORAGE FOR RWORK, MINIMUM LRWORK=',LRSTORE
         DO I=LRWORKPARAMETER+1,LRSTORE
            RWORK(I)=0.0
         ENDDO
      ENDIF

C ----- PREPARE THE ENTRY-POINTS FOR THE ARRAYS IN IWORK (INTEGER WORKSPACE) -----
      IEKDFYM      =1           +LIWORKPARAMETER
      IEISNY       =IEKDFYM     +NM
      IEISM1TNYP1  =IEISNY      +NS
      IEIBHI       =IEISM1TNYP1 +NS
      IEIBH        =IEIBHI      +NS
      IESTIFFLYACC =IEIBH       +LIBHINBHI
      IEIVP        =IESTIFFLYACC+NM
C ----- TOTAL STORAGE REQUIREMENT -----
      LISTORE      =IEIVP       +LIVP-1
      IF (LISTORE>LIWORK) THEN
         WRITE(6,*)' INSUFFICIENT STORAGE FOR IWORK'
         WRITE(6,*)' MINIMUM LIWORK=',LISTORE
         INVALID=.TRUE.
      ELSE
         WRITE(6,*)' STORAGE FOR IWORK, MINIMUM LIWORK=',LISTORE
         DO I=LIWORKPARAMETER+1,LISTORE
            IWORK(I)=0
         ENDDO
      ENDIF
C ----- WHEN A FAIL HAS OCCURED, WE RETURN WITH IDID=-1 -----
 100  CONTINUE
      IF (INVALID) THEN
         IDID=-1
         RETURN
      ENDIF
C ----- CALL TO CORE INTEGRATOR -----
      CALL SPARK3COR(NM,ME,NS,NBHI,T,TEND,NY,NU,NV,NBIGSYS,LNV,
     &   IWORK(IEISNY),IWORK(IEISM1TNYP1),NVGE1,Y,
     &   FCNM,DFYCNM,IDFYCNM,DFYVECCNM,IDFYVECCNM,
     &   RWORK(IEDFMYVEC),IWORK(IEKDFYM),LDFYM,LDFY,RWORK(IEDFY),
     &   ECN ,DEVCN ,IDEVCN ,DEVVECCN ,IDEVVECCN,
     &   RWORK(IEDEVVEC)                      ,LDEV,RWORK(IEDEV),
     &   PRECDEC,PRECSOL,PRDECVN,PRSOLVN,
     &   H,ABSHMIN,ABSHMAX,FACL,FACR,THETADNEWEVAL,THETAJNEWDEC,
     &   RTOLY,ATOLY,ITOLY,SOLOUT,IOUT,IDID,NMAX,UROUND,SAFE,
     &   THET,FNEWT,MINNEWT,MAXNEWT,ISTARTNEWT,SOLVEVN,
     &   FLINIT,LINIT,MAXLINIT,MAXKRYLOV,ISTEPSIZE,
     &   IWORK(30),IWORK(31),IWORK(32),IWORK(33),IWORK(34),IWORK(35),
     &   IWORK(36),IWORK(37),IWORK(38),IWORK(39),IWORK(40),IWORK(41),
     &   IWORK(42),IWORK(43),IWORK(44),LRPAR,RPAR,RWORK(IEB),RWORK(IEC),
     &   RWORK(IECINV),RWORK(IEA),RWORK(IEAINV),RWORK(IEBETA),
     &   RWORK(IEBFBETA),RWORK(IEGAMMA),RWORK(IEOMEGA),RWORK(IEERRC),
     &   IWORK(IESTIFFLYACC),RWORK(IETPCHIS),NCONTY,
     &   RWORK(IECONTY),RWORK(IETMP1NY),RWORK(IETMP2NY),
     &   RWORK(IESCALYINV),RWORK(IEZY),RWORK(IEZNY),RWORK(IEF0M),
     &   RWORK(IEF),RWORK(IEE0),RWORK(IEE),RWORK(IEEN),IWORK(IEIBHI),
     &   LBHI ,RWORK(IEBH) ,LVP ,RWORK(IEVP),
     &   RWORK(IEVEC),RWORK(IEVECN),
     &   NBCOLVWORK,RWORK(IEVWORK),RWORK(IEHWORK),LIPAR,IPAR,
     &   LIBHI,IWORK(IEIBH),LIVP,IWORK(IEIVP))

      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE SPARK3
C-----------------------------------------------------------------------
