      SUBROUTINE SPARK3COR(NM,ME,NS,NBHI,T,TEND,
     &   NY,NU,NV,NBIGSYS,LNV,ISNY,ISM1TNYP1,NVGE1,Y,
     &   FCNM,DFYCNM,IDFYCNM,DFYVECCNM,IDFYVECCNM,
     &   DFMYVEC,KDFYM,LDFYM,LDFY,DFY,
     &   ECN ,DEVCN ,IDEVCN ,DEVVECCN ,IDEVVECCN ,
     &   DEVVEC             ,LDEV,DEV,
     &   PRECDEC,PRECSOL,PRDECVN,PRSOLVN,
     &   H,ABSHMIN,ABSHMAX,FACL,FACR,THETADNEWEVAL,THETAJNEWDEC,
     &   RTOLY,ATOLY,ITOLY,
     &   SOLOUT,IOUT,IDID,NMAX,UROUND,SAFE,
     &   THET,FNEWT,MINNEWT,MAXNEWT,ISTARTNEWT,SOLVEVN,
     &   FLINIT,LINIT,MAXLINIT,MAXKRYLOV,ISTEPSIZE,
     &   NFCN,NECN,NDFY,NDEV,NSTEP,NACCEPT,NREJECTERR,NLINIT,NNEWT,
     &   NJACDEC,NJACSOL,NPVNDEC,NPVNSOL,NMATVECPROD,NREJECTITER,
     &   LRPAR,RPAR,B,C,CINV,A,AINV,BETA,BFBETA,
     &   GAMMA,OMEGA,ERRC,STIFFLYACC,TPCHIS,
     &   NCONTY,CONTY,TMP1NY,TMP2NY,SCALYINV,ZY,ZNY,F0M,F,E0,E,EN,
     &   IBHI,LBHI, BH, LVP, VP,VEC,VECN,
     &   NBCOLVWORK,VWORK,HWORK,LIPAR,IPAR,
     &       LIBHI,IBH,LIVP,IVP)
C-----------------------------------------------------------------------
C     CORE INTEGRATOR FOR SPARK3
C     SAME PARAMETERS AS IN SPARK3 WITH WORKSPACE ADDED
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: NM
      INTEGER, INTENT(IN   ) :: ME(NM)
      INTEGER, INTENT(IN   ) :: NS
      INTEGER, INTENT(IN   ) :: NBHI
      REAL   , INTENT(INOUT) :: T
      REAL   , INTENT(IN   ) :: TEND
      INTEGER, INTENT(IN   ) :: NY
      INTEGER, INTENT(IN   ) :: NU
      INTEGER, INTENT(IN   ) :: NV
      INTEGER, INTENT(IN   ) :: NBIGSYS
      INTEGER, INTENT(IN   ) :: LNV
      INTEGER, INTENT(IN   ) :: ISNY(NS)
      INTEGER, INTENT(IN   ) :: ISM1TNYP1(NS)
      LOGICAL, INTENT(IN   ) :: NVGE1
      REAL   , INTENT(INOUT) :: Y(NY)
      EXTERNAL                  FCNM
      EXTERNAL                  DFYCNM
      INTEGER, INTENT(IN   ) :: IDFYCNM(NM)
      EXTERNAL                  DFYVECCNM
      INTEGER, INTENT(IN   ) :: IDFYVECCNM(NM)
      REAL   , INTENT(  OUT) :: DFMYVEC(NY)
      INTEGER, INTENT(IN   ) :: KDFYM(NM)
      INTEGER, INTENT(IN   ) :: LDFYM(NM)
      INTEGER, INTENT(IN   ) :: LDFY
      REAL   , INTENT(  OUT) :: DFY(LDFY)
      EXTERNAL                  ECN
      EXTERNAL                  DEVCN
      INTEGER, INTENT(IN   ) :: IDEVCN
      EXTERNAL                  DEVVECCN
      INTEGER, INTENT(IN   ) :: IDEVVECCN
      REAL   , INTENT(  OUT) :: DEVVEC(LNV)
      INTEGER, INTENT(IN   ) :: LDEV
      REAL   , INTENT(  OUT) :: DEV(LDEV)
      EXTERNAL                  PRECDEC
      EXTERNAL                  PRECSOL
      EXTERNAL                  PRDECVN
      EXTERNAL                  PRSOLVN
      REAL   , INTENT(INOUT) :: H
      REAL   , INTENT(IN   ) :: ABSHMIN
      REAL   , INTENT(IN   ) :: ABSHMAX
      REAL   , INTENT(IN   ) :: FACL
      REAL   , INTENT(IN   ) :: FACR
      REAL   , INTENT(IN   ) :: THETADNEWEVAL
      REAL   , INTENT(IN   ) :: THETAJNEWDEC
      REAL   , INTENT(IN   ) :: RTOLY(*)
      REAL   , INTENT(IN   ) :: ATOLY(*)
      INTEGER, INTENT(IN   ) :: ITOLY
      EXTERNAL                  SOLOUT
      INTEGER, INTENT(IN   ) :: IOUT
      INTEGER, INTENT(  OUT) :: IDID
      INTEGER, INTENT(IN   ) :: NMAX
      REAL   , INTENT(IN   ) :: UROUND 
      REAL   , INTENT(IN   ) :: SAFE
      REAL   , INTENT(IN   ) :: THET
      REAL   , INTENT(IN   ) :: FNEWT
      INTEGER, INTENT(IN   ) :: MINNEWT
      INTEGER, INTENT(IN   ) :: MAXNEWT
      INTEGER, INTENT(IN   ) :: ISTARTNEWT
      LOGICAL, INTENT(IN   ) :: SOLVEVN
      REAL   , INTENT(IN   ) :: FLINIT
      INTEGER, INTENT(IN   ) :: LINIT
      INTEGER, INTENT(IN   ) :: MAXLINIT
      INTEGER, INTENT(IN   ) :: MAXKRYLOV
      INTEGER, INTENT(IN   ) :: ISTEPSIZE
      INTEGER, INTENT(  OUT) :: NFCN
      INTEGER, INTENT(  OUT) :: NECN
      INTEGER, INTENT(  OUT) :: NDFY
      INTEGER, INTENT(  OUT) :: NDEV
      INTEGER, INTENT(  OUT) :: NSTEP
      INTEGER, INTENT(  OUT) :: NACCEPT
      INTEGER, INTENT(  OUT) :: NREJECTERR
      INTEGER, INTENT(  OUT) :: NLINIT
      INTEGER, INTENT(  OUT) :: NNEWT
      INTEGER, INTENT(  OUT) :: NJACDEC
      INTEGER, INTENT(  OUT) :: NJACSOL
      INTEGER, INTENT(  OUT) :: NPVNDEC
      INTEGER, INTENT(  OUT) :: NPVNSOL
      INTEGER, INTENT(  OUT) :: NMATVECPROD
      INTEGER, INTENT(  OUT) :: NREJECTITER
      INTEGER, INTENT(IN   ) :: LRPAR
      REAL   , INTENT(IN   ) :: RPAR(*)
      REAL   , INTENT(  OUT) :: B(NS)
      REAL   , INTENT(  OUT) :: C(NS)
      REAL   , INTENT(  OUT) :: CINV(NS)
      REAL   , INTENT(  OUT) :: A(NS,NS,NM)
      REAL   , INTENT(  OUT) :: AINV(NS,NS,NM)
      REAL   , INTENT(  OUT) :: BETA(NS)
      REAL   , INTENT(  OUT) :: BFBETA(NS,NM)
      REAL   , INTENT(  OUT) :: GAMMA(NS,NM)
      REAL   , INTENT(  OUT) :: OMEGA(NS,NS,NM)
      REAL   , INTENT(  OUT) :: ERRC(NS+1)
      INTEGER, INTENT(  OUT) :: STIFFLYACC(NM) 
      REAL   , INTENT(  OUT) :: TPCHIS(NS)
      INTEGER, INTENT(IN   ) :: NCONTY
      REAL   , INTENT(  OUT) :: CONTY(NCONTY)
      REAL   , INTENT(  OUT) :: TMP1NY(NY)
      REAL   , INTENT(  OUT) :: TMP2NY(NY)
      REAL   , INTENT(  OUT) :: SCALYINV(NY)
      REAL   , INTENT(  OUT) :: ZY(NY,NS)
      REAL   , INTENT(  OUT) :: ZNY(NY)
      REAL   , INTENT(  OUT) :: F0M(NY,NM)
      REAL   , INTENT(  OUT) :: F(NY,NM,NS)
      REAL   , INTENT(  OUT) :: E0(LNV)
      REAL   , INTENT(  OUT) :: E(LNV,NS)
      REAL   , INTENT(  OUT) :: EN(LNV)
      INTEGER, INTENT(IN   ) :: LBHI
      INTEGER, INTENT(  OUT) :: IBHI(NS)
      REAL   , INTENT(  OUT) :: BH(LBHI,NBHI)
      INTEGER, INTENT(IN   ) :: LVP
      REAL   , INTENT(  OUT) :: VP(LVP)
      REAL   , INTENT(  OUT) :: VEC(NY,NS)
      REAL   , INTENT(  OUT) :: VECN(LNV)
      INTEGER, INTENT(IN   ) :: NBCOLVWORK
      REAL   , INTENT(  OUT) :: VWORK(NBIGSYS,NBCOLVWORK)
      REAL   , INTENT(  OUT) :: HWORK(MAXKRYLOV+1,MAXKRYLOV+3)
      INTEGER, INTENT(IN   ) :: LIPAR
      INTEGER, INTENT(IN   ) :: IPAR(*)
      INTEGER, INTENT(IN   ) :: LIBHI
      INTEGER, INTENT(  OUT) :: IBH(LIBHI,NBHI)
      INTEGER, INTENT(IN   ) :: LIVP
      INTEGER, INTENT(  OUT) :: IVP(LIVP)
C    LOCAL PARAMETERS
      REAL   , PARAMETER     :: THETAMAX = 0.9
C    LOCAL VARIABLES
      INTEGER :: IC1CS,ICOLX,ICOLY,IER,IERRJAC,IREVCOM,IRTRN,IS
      INTEGER :: ISM1TNYP1IS,ITER,JS,M,NEWT,NRSOL,NSM1,NSP1,VNPTR,VPTR
      LOGICAL :: CALDEV,CALDFY,CALJAC,CALJACVN,C1EQ0,CONVRESTRICT
      LOGICAL :: DELTYCOMPUTED,DEVTOCOMPUTE,DFYTOCOMPUTE,DIVERGING,FIRST
      LOGICAL :: JACTOCOMPUTE,JACVNTOCOMPUTE,NEWTCONV,REJECTERR
      LOGICAL :: REJECTITER,SETTOL,THETADNEWEVALEQ0
      REAL    :: ABSHNEW,CFAC,DELTV,DELTY,DNORMR0,DXSTARNTOL
      REAL    :: DXSTARNTOLOLD,DYTH,EMBORDERP1,ERR,ERRACCEPT,ERRFAC
      REAL    :: ERRREJECT,EXPERR,EXPM,FACCON,FACNORMNBIGSYS,FACNORMNY
      REAL    :: FLIN,HACCEPT,HDEC,HNEW,HNEWFACINV,HOLD,HREJECT,HSOLY
      REAL    :: ORDERP1,PINVBNTOL,POSNEG,THETA,THETAFACCON,THETAFLIN
      REAL    :: THETAOLD,THQ,THQOLD,TOL,TOLD,TPH,TSOLY,XCOM
C    LEVEL 1 BLAS FUNCTIONS
      DOUBLE PRECISION       :: DDOT
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE SPARK3COR
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C    INITIALIZATIONS
C-----------------------------------------------------------------------
C ----- COMPUTATION OF THE SPARK COEFFICIENTS -----
      CALL COEF(NM,ME,NS,NBHI,B,C,A,AINV,BETA,
     &          BFBETA,IBHI,GAMMA,OMEGA,ERRC,
     &          ORDERP1,EMBORDERP1,ERRFAC,EXPM,EXPERR,
     &          IERRJAC,STIFFLYACC)

      CALL INITCONSTANTS(NM,LDFYM,MAXNEWT,NSTEP,NY,NU,NV,NBIGSYS,
     &         NS,C,CINV,ABSHMIN,ABSHMAX,
     &         T,TEND,THETADNEWEVAL,
     &         IRTRN,KDFYM,CFAC,FACNORMNY,FACNORMNBIGSYS,
     &         NSM1,NSP1,VPTR,VNPTR,C1EQ0,IC1CS,
     &         ISNY,ISM1TNYP1,
     &         FIRST,REJECTITER,REJECTERR,
     &         POSNEG,H,HNEWFACINV,DIVERGING,CONVRESTRICT,
     &         THETADNEWEVALEQ0,HOLD,TOLD,THETAOLD,THETA)

   5  CONTINUE
C-----------------------------------------------------------------------
C    MAIN LOOP
C    FIRST STEP OR NEW STEP AFTER PREVIOUSLY ACCEPTED STEP
C-----------------------------------------------------------------------
c      Y is already set
      CALDFY=.FALSE.
      CALDEV=(.NOT.(NVGE1))
      HSOLY=HOLD
      TSOLY=TOLD
      IF (IOUT==1) THEN
         NRSOL=NACCEPT+1
         CALL SOLOUT(NRSOL,TSOLY,T,NY,NU,NV,Y,NS,ISNY,C,IC1CS,
     &               HSOLY,NCONTY,CONTY,RPAR,IPAR,IRTRN)
         IF (IRTRN<0) GOTO 178
      ENDIF
      IF (POSNEG*(T-TEND)>=0.0) THEN
         H=H/HNEWFACINV
         CALJAC  =.FALSE.
         CALJACVN=(.NOT.(SOLVEVN))
         IDID=1
C -------- SUCCESSFUL RETURN -----
         RETURN
      ENDIF
      IF (NSTEP>=NMAX) GOTO 177
      CALL SETF0ME0(DELTYCOMPUTED,DELTY,DELTV,UROUND,
     &              NM,T,NY,NU,VPTR,NV,LNV,NVGE1,Y,FCNM,
     &              IDFYVECCNM,ECN,IDEVVECCN,H,RPAR,IPAR,
     &              NECN,F0M,E0)

  10  CONTINUE
C-----------------------------------------------------------------------
C    CURRENT STEP
C-----------------------------------------------------------------------
      JACTOCOMPUTE=.TRUE.
      JACVNTOCOMPUTE=(SOLVEVN)
C-----------------------------------------------------------------------
C    REJECTION HANDLING
C-----------------------------------------------------------------------
      IF (REJECTITER) THEN
         NREJECTITER=NREJECTITER+1
         IF ((CALJAC).AND.(CALJACVN)) THEN
            IF ((CALDFY).AND.(CALDEV)) THEN
               IF ((HNEWFACINV>1.0).OR.(DIVERGING)) THEN
                  HNEWFACINV=MAX(1.5,MIN(3.0,HNEWFACINV))
                  DIVERGING=.FALSE.
               ELSE
                  HNEWFACINV=2.0
               ENDIF
            ELSE
               DFYTOCOMPUTE=.TRUE.
               DEVTOCOMPUTE=(NVGE1)
               GOTO 15
            ENDIF
         ELSE
            GOTO 20
         ENDIF
      ENDIF
C-----------------------------------------------------------------------
C    BASIC INTEGRATION STEP
C-----------------------------------------------------------------------
      CALL INITSTEP(HNEWFACINV,THETA,HDEC,THETADNEWEVALEQ0,
     &              T,TEND,POSNEG,NVGE1,ABSHMIN,ABSHMAX,
     &              THETADNEWEVAL,THETAJNEWDEC,THET,
     &              FNEWT,MINNEWT,MAXNEWT,ISTARTNEWT,SOLVEVN,H,
     &              NSTEP,HNEW,ABSHNEW,CALJAC,CALJACVN,
     &              DFYTOCOMPUTE,DEVTOCOMPUTE,
     &              JACTOCOMPUTE,JACVNTOCOMPUTE)

  15  CONTINUE
C--------------------------------------------------------------------------
C       COMPUTE QUANTITIES NEEDED FOR THE APPROXIMATE JACOBIANS Fmy
C--------------------------------------------------------------------------
      IF (DFYTOCOMPUTE) THEN
c -------- when f(t,y) is linear in y we should enter this if statement only once!
         DFYTOCOMPUTE=.FALSE.
         DO M=1,NM
            CALL COMPUTEDFYM(M,T,NY,NU,NV,Y,FCNM,DFYCNM,IDFYCNM(M),
     &                       IDFYVECCNM(M),LDFYM(M),DFY(KDFYM(M)),
     &                       F0M(1,M),UROUND,RPAR,IPAR)
         ENDDO
         CALDFY      =.TRUE.
         NDFY=NDFY+1
      ENDIF
  16  CONTINUE
C-----------------------------------------------------------------------
C       COMPUTE QUANTITIES NEEDED FOR THE APPROXIMATE JACOBIAN Ev
C-----------------------------------------------------------------------
      IF (DEVTOCOMPUTE) THEN
c -------- when e(t,y) is linear in y we should enter this if statement only once!
         DEVTOCOMPUTE=.FALSE.
            CALL COMPUTEDEV (  T,NY,NU,NV,Y,ECN ,DEVCN ,IDEVCN    ,
     &                                     LDEV    ,DEV          ,
     &                       E0      ,UROUND,RPAR,IPAR)
         CALDEV      =.TRUE.
         NDEV=NDEV+1
      ENDIF      
  20  CONTINUE
C-----------------------------------------------------------------------
C       COMPUTATION OF THE PRECONDITIONER
C-----------------------------------------------------------------------
      IF (JACTOCOMPUTE) THEN
         JACTOCOMPUTE=.FALSE.
         CALJAC      =.TRUE.
         NJACDEC=NJACDEC+1
         HDEC=H
C-----------------------------------------------------------------------
C          COMPUTATION AND DECOMPOSITION OF THE BLOCKS H_i FOR THE
C          PRECONDITIONER. ONLY THE NONZERO PARTS NEED TO BE COMPUTED
C-----------------------------------------------------------------------
         DO IS=1,NBHI
            IER=0
            CALL PRECDEC(IS,NS,T,H,NY,NU,NV,Y,NM,GAMMA,
     &                   KDFYM,LDFYM,LDFY,DFY,LDEV,DEV,
     &                   BH(1,IS),IBH(1,IS),IER,RPAR,IPAR)
            IF (IER/=0) GOTO 176
         ENDDO
      ENDIF
      IF (JACVNTOCOMPUTE) THEN
         JACVNTOCOMPUTE=.FALSE.
         CALJACVN      =.TRUE.
         NPVNDEC=NPVNDEC+1
C-----------------------------------------------------------------------
C          COMPUTATION AND DECOMPOSITION OF THE BLOCKS FOR THE
C          PRECONDITIONER TO Ev. ONLY THE NONZERO PARTS NEED TO BE 
C          COMPUTED
C-----------------------------------------------------------------------
            IER=0
            CALL PRDECVN(T,NY,NU,NV,Y,LDEV,DEV,VP,IVP,IER,RPAR,IPAR)
            IF (IER/=0) GOTO 176
      ENDIF
  30  CONTINUE
      DO IS=1,NS
         TPCHIS(IS)=T+C(IS)*H
      ENDDO
      TPH=T+H
C-----------------------------------------------------------------------
C    STARTING VALUES FOR THE INEXACT APPROXIMATE SIMPLIFIED NEWTON 
C    ITERATIONS
C-----------------------------------------------------------------------
      DO IS=1,NS
         CALL STARTVAL(FIRST,C1EQ0,ISTARTNEWT,TPCHIS(IS),IS  ,NY,Y,
     &                NS,ISNY,C,IC1CS,HSOLY,TSOLY,NCONTY,CONTY,ZY(1,IS))
      ENDDO
      IF (SOLVEVN) THEN
         CALL STARTVAL(FIRST,C1EQ0,ISTARTNEWT,TPH       ,NSP1,NY,Y,
     &                NS,ISNY,C,IC1CS,HSOLY,TSOLY,NCONTY,CONTY,ZNY     )
      ENDIF

      NEWT=0
c      THETAFACCON=MIN(THETAMAX,MAX(THET,2.0*THETAOLD))
      THETAFACCON=MIN(THETAMAX,MAX(THET,THETAOLD))
      FACCON=THETAFACCON/(1.0-THETAFACCON)
c      THETAFLIN  =             MIN(THET,0.5*THETAOLD)
      THETAFLIN  =             MIN(THET,THETAOLD)
      HNEWFACINV=0.0
C-----------------------------------------------------------------------
C    INEXACT APPROXIMATE SIMPLIFIED NEWTON ITERATIONS LOOP
C-----------------------------------------------------------------------
      DO WHILE (NEWT<MAXNEWT)

      CALL COMPUTESCAL(NY,Y,RTOLY,ATOLY,ITOLY,SOLVEVN,ZY(1,NS),ZNY,
     &                 SCALYINV)

      DO IS=1,NS
         CALL EFISM(NM,NY,NU,NV,LNV,NVGE1,Y,FCNM,ECN,
     &              RPAR,TPCHIS(IS),IPAR,ZY(1,IS),
     &              TMP1NY,F(1,1,IS),E(1,IS))
      ENDDO
      NFCN=NFCN+NS
      IF (NVGE1) NECN=NECN+NS

      IF (SOLVEVN) THEN
         CALL ENSP1(   NY,NU,NV,LNV      ,Y     ,ECN,
     &              RPAR,TPH       ,IPAR,ZNY     ,
     &              TMP1NY          ,EN     )
         NECN=NECN+1
      ENDIF


C ----- COMPUTE THE RIGHT-HAND SIDE                     -----
C ----- b = - G(x_k) (k=NEWT)                           -----
C ----- VEC_ <-- ...                                    -----
C ----- INITIALIZATIONS FOR THE LINEAR ITERATIVE SOLVER -----
C ----- THE RIGHT-HAND SIDE IS SET                      -----
C ----- VWORK(:,ICOLX) (ICOLX=2)                        -----
      ICOLX=2

      DO IS=1,NS
         CALL       DCOPY(NU              ,ZY( 1,IS),1,VEC(   1,IS),1)
         CALL       DSCAL(NU,-1.0                     ,VEC(   1,IS),1)
         CALL       DCOPY(NV              ,E0       ,1,VEC(VPTR,IS),1)
c --------- warning ill-conditioned substraction!
         CALL       DAXPY(NV,         -1.0,E(  1,IS),1,VEC(VPTR,IS),1)
         DO JS=1,NS
            DO M=1,NM
               CALL DAXPY(NY,+H*A(IS,JS,M),F(1,M,JS),1,VEC(   1,IS),1)
            ENDDO
         ENDDO
         CALL DCOPY(NY,VEC(1,IS),1,VWORK(ISM1TNYP1(IS),ICOLX),1)
      ENDDO

      IF (SOLVEVN) THEN
         CALL       DCOPY(NV                   ,  EN       ,1,VECN,1)
         CALL       DSCAL(NV,-1.0                            ,VECN,1)
         DO JS=1,NS
            CALL    DAXPY(NV,          BETA(JS),  E(  1,JS),1,VECN,1)
            DO M=1,NM
               IF (STIFFLYACC(M)==0) THEN
                  CALL DAXPY(NV,H*BFBETA(JS,M),F(VPTR,M,JS),1,VECN,1)
               ENDIF
            ENDDO
         ENDDO
         CALL DCOPY(NV,VECN     ,1,VWORK(        VNPTR,ICOLX),1)
      ENDIF

      ITER=MAXLINIT
      IREVCOM=0
      TOL=0.0
      SETTOL=.FALSE.
      IER=0

  40  CONTINUE

      IF     (LINIT==0) THEN            
C ------ NO INNER PRECONDITIONED LINEAR ITERATIONS -----
         CALL NOSYS(NBIGSYS                   ,VWORK,NBIGSYS,
     &              IREVCOM,ICOLX,ICOLY,XCOM,IER)
C-----------------------------------------------------------------------
C    SOLVE THE LINEAR SYSTEM APPROXIMATELY USING A PRECONDITIONED LINEAR
C    ITERATIVE METHOD: RICHARDSON OR GMRES
C    CALL TO THE LINEAR ITERATIVE SOLVER USING REVERSE COMMUNICATION 
C-----------------------------------------------------------------------
      ELSEIF (LINIT==1) THEN
C------ RICHARDSON                               -----
         CALL RICHD(NBIGSYS          ,ITER,TOL,VWORK,NBIGSYS,
     &              IREVCOM,ICOLX,ICOLY,XCOM,IER)
      ELSEIF (LINIT==2) THEN
C------ GMRES                                    -----
         CALL GMRES(NBIGSYS,MAXKRYLOV,ITER,TOL,VWORK,NBIGSYS,HWORK,
     &              IREVCOM,ICOLX,ICOLY,XCOM,IER)
      ENDIF

      IF     (IREVCOM==1) THEN

C -------- PERFORM THE MATRIX-VECTOR PRODUCT   -----
C -------- VWORK(:,ICOLY) <-- K*VWORK(:,ICOLX) -----
         CALL MATVECPROD(NM,ME,T,NY,NU,NV,LNV,NVGE1,Y,
     &      FCNM,DFYVECCNM,IDFYVECCNM,KDFYM,LDFYM,LDFY,DFY,
     &      ECN ,DEVVECCN ,IDEVVECCN             ,LDEV,DEV,
     &      H,
     &      RPAR,IPAR,
     &      NS,A,BETA,BFBETA,STIFFLYACC,
     &      TMP1NY,
     &      F0M,E0,
     &      TMP2NY,DFMYVEC,
     &      SOLVEVN,
     &      VWORK(1,ICOLX),VWORK(VNPTR,ICOLX),
     &      VWORK(1,ICOLY),VWORK(VNPTR,ICOLY),
     &      DELTY,DELTV,VPTR)
         NMATVECPROD=NMATVECPROD+1

         GOTO 40

      ELSEIF (IREVCOM==2) THEN

C -------- PERFORM THE LEFT PRECONDITIONING         -----
C -------- VWORK(:,ICOLY) <-- P^{-1}*VWORK(:,ICOLX) -----

         DO IS=1,NS
            CALL DCOPY(NY,VWORK(ISM1TNYP1(IS),ICOLX),1,VEC(1,IS),1)
         ENDDO
         IF (SOLVEVN) THEN
            CALL DCOPY(NV,VWORK(        VNPTR,ICOLX),1,VECN     ,1)
         ENDIF
         CALL LEFTPREC(NM,ME,T,NY,NU,NV,LNV,NVGE1,Y,
     &      FCNM,DFYVECCNM,IDFYVECCNM,KDFYM,LDFYM,LDFY,DFY,
     &      ECN ,DEVVECCN ,IDEVVECCN             ,LDEV,DEV,
     &      PRECSOL,PRSOLVN,
     &      H,
     &      RPAR,IPAR,
     &      NS,OMEGA,STIFFLYACC,
     &      TMP1NY,
     &      F0M,E0,
     &      TMP2NY,DFMYVEC,
     &      NBHI,IBHI, 
     &       LBHI, BH, LVP, VP,SOLVEVN,
     &      VEC,VECN,
     &      VWORK(1,ICOLY),VWORK(VNPTR,ICOLY),
     &      LIBHI,IBH,LIVP,IVP,
     &      DELTY,DELTV,VPTR,IER)
         NJACSOL=NJACSOL+1

         GOTO 40

      ELSEIF (IREVCOM==3) THEN

C ----- PERFORM THE D MULTIPLICATION        -----
C ----- VWORK(:,ICOLY) <-- D*VWORK(:,ICOLX) -----

         DO IS=1,NS
            ISM1TNYP1IS=ISM1TNYP1(IS)
            CALL DIAGVEC(NY,SCALYINV      ,
     &                      VWORK(ISM1TNYP1IS,ICOLX),
     &                      VWORK(ISM1TNYP1IS,ICOLY),1,.FALSE.)
         ENDDO
         IF (SOLVEVN) THEN
            CALL DIAGVEC(NV,SCALYINV(VPTR),
     &                      VWORK(      VNPTR,ICOLX),
     &                      VWORK(      VNPTR,ICOLY),1,.FALSE.)
         ENDIF
         GOTO 40

      ELSEIF (IREVCOM==4) THEN

C ----- PERFORM THE SCALAR PRODUCT              -----
C -----  XCOM <-- VWORK(:,ICOLX)*VWORK(:,ICOLY) -----
         XCOM=DDOT(NBIGSYS,VWORK(1,ICOLX),1,VWORK(1,ICOLY),1)

         IF (.NOT.(SETTOL)) THEN

C -------- PINVBNTOL = ||P^{-1}*b||_TOL -----
            DNORMR0=SQRT(XCOM)
            PINVBNTOL=DNORMR0*FACNORMNBIGSYS
            FLIN=PINVBNTOL*THETAFLIN/(3.0*(1.5)**NEWT+THETAFLIN)
            FLIN=MAX(FLIN,FNEWT)*FLINIT
c            IF (NEWT==0) THEN
c               FLINFAC=MIN(FLINIT,0.01)
c            ELSE
c               FLINFAC=FLINIT
c            ENDIF
c            FLIN=MAX(FLIN,FNEWT)*FLINFAC

            IF (PINVBNTOL<=FLIN) THEN

C-----------------------------------------------------------------------
C             QUICK EXIT
C-----------------------------------------------------------------------
               ITER=0
               IF (NEWT<=1) THETA=0.0
               NEWTCONV=.TRUE.
               GOTO 80   

            ELSE

C ----------- SET THE CONVERGENCE TOLERANCE TOL FOR THE LINEAR ITERATIVE METHOD -----
               TOL=FLIN/DNORMR0
               SETTOL=.TRUE.
               GOTO 40

            ENDIF

         ENDIF

         GOTO 40

      ELSEIF (IREVCOM==5) THEN

C ----- PERFORM THE D^{-1} MULTIPLICATION        -----
C ----- VWORK(:,ICOLY) <-- D^{-1}*VWORK(:,ICOLX) -----

         DO IS=1,NS
            ISM1TNYP1IS=ISM1TNYP1(IS)
            CALL DIAGVEC(NY,SCALYINV      ,
     &                      VWORK(ISM1TNYP1IS,ICOLX),
     &                      VWORK(ISM1TNYP1IS,ICOLY),1,.TRUE.)
         ENDDO
         IF (SOLVEVN) THEN
            CALL DIAGVEC(NV,SCALYINV(VPTR),
     &                      VWORK(      VNPTR,ICOLX),
     &                      VWORK(      VNPTR,ICOLY),1,.TRUE.)
         ENDIF

         GOTO 40

      ELSEIF (IREVCOM==(-1)) THEN

C ------- EXIT OF REVERSE COMMUNICATION LOOP -----
         IF (LINIT==0) ITER=0
         NLINIT=NLINIT+ITER
         IF (IER/=0) THEN
C--------------------------------------------------------------------
C ------- NO CONVERGENCE OF LINEAR ITERATIONS HAS BEEN OBSERVED -----
C--------------------------------------------------------------------
c         WRITE(6,*) 'WARNING: NO CONVERGENCE OF LINEAR ITERATIVE SOLVER'
c         WRITE(6,*) 'ITER,T,TOL',ITER,T,TOL
         ENDIF

C ----- XCOM = ||Dx_k^l||_TOL -----
         DXSTARNTOL=XCOM*FACNORMNY
         IF (DXSTARNTOL>=1.E20) THEN
C ----------- NO CONVERGENCE OF INEXACT APPROXIMATE SIMPLIFIED -----
C ----------- NEWTON ITERATIONS                                -----
c            WRITE(6,*) 'DXSTARNTOL IS TOO LARGE, DXSTARNTOL=',DXSTARNTOL
            REJECTITER=.TRUE.
            write(6,*) '2 REJECTITER'
            GOTO 10
         ENDIF

      ENDIF

C-------------------------------------------------------------------
C    PRECONDITIONED LINEAR ITERATIONS SUCCESSFULLY COMPLETED
C    END OF ONE INEXACT APPROXIMATE SIMPLIFIED NEWTON ITERATION
C    THE SOLUTION OF THE LINEAR SYSTEM RESIDES IN VWORK(:,1) AND
C    ITS TOL-NORM IN DXSTARNTOL
C ------------------------------------------------------------------

      IF ((NEWT>=1).AND.(NEWT<=MAXNEWT-2)) THEN
c         IF ((NEWT>=2).AND.(DXSTARNTOL>
c     &            (MIN(100.0*THETA,THETAUNEXPECT)*DXSTARNTOLOLD))) THEN
cC ----------- TOTALLY UNEXPECTED VALUE OF DXSTARNTOL, MACHINE PRECISION MUST -----
cC ----------- HAVE BEEN REACHED AND NO FURTHER IMPROVEMENT IS POSSIBLE       -----
c            NEWTCONV=.TRUE.
c            GOTO 80
c         ELSE
            THQ=DXSTARNTOL/DXSTARNTOLOLD
c         ENDIF
         IF (NEWT==1) THEN
            THETA=THQ
         ELSE
            THETA=SQRT(THQ*THQOLD)
         ENDIF
         THETAFLIN=THETA
         HNEWFACINV=THETA/THET
         THQOLD=THQ
         IF (THETA<=THETAMAX) THEN
            FACCON=THETA/(1.0-THETA)
            IF (NEWT>=2) THEN
               DYTH=FACCON*(THETA**(MAXNEWT-2-NEWT))*DXSTARNTOL
               IF (DYTH>=FNEWT) THEN
                  REJECTITER=.TRUE.
                  write(6,*) '3 REJECTITER'
                  GOTO 10
               ENDIF
            ENDIF
         ELSE
            REJECTITER=.TRUE.
            DIVERGING =.TRUE.
            write(6,*) '4 REJECTITER',NSTEP
            GOTO 10
         ENDIF
      ENDIF

      DXSTARNTOLOLD=MAX(DXSTARNTOL,UROUND)

C -------- UPDATE OF NEWTON APPROXIMATION -----
      DO IS=1,NS
         CALL DAXPY(NY,1.0,VWORK(ISM1TNYP1(IS),1),1,ZY(1,IS) ,1)
      ENDDO

c      NEWTCONV=(((MAX(FACCON,FNEWT)*DXSTARNTOL)<=(FNEWT)).AND.
c     &          (NEWT>=MINNEWT))
      NEWTCONV=(((FACCON*DXSTARNTOL)<=(FNEWT)).AND.(NEWT>=MINNEWT))

  80  CONTINUE

      NEWT =NEWT +1
      NNEWT=NNEWT+1

      IF ((SOLVEVN).OR.(NEWTCONV)) THEN
         DO JS=1,NS
            IF (JS==1) THEN
               CALL DCOPY(NU         ,ZY(1, 1),1,ZNY,1)
               CALL DSCAL(NU,BETA( 1)           ,ZNY,1)
            ELSE
               CALL DAXPY(NU,BETA(JS),ZY(1,JS),1,ZNY,1)
            ENDIF
            DO M=1,NM
               IF (STIFFLYACC(M)==0) THEN
                  CALL DAXPY(NU,H*BFBETA(JS,M),F(1,M,JS),1,ZNY,1)
               ENDIF
            ENDDO
         ENDDO
      ENDIF

      IF (SOLVEVN) THEN
C ---- UPDATE CURRENT APPROXIMATION TO delta v_n -----
         CALL DAXPY(NV,1.0,VWORK(        VNPTR,1),1,ZNY(VPTR),1)
      ENDIF

      IF (NEWTCONV) EXIT

      ENDDO
C-----------------------------------------------------------------------
C    END OF INEXACT APPROXIMATE SIMPLIFIED NEWTON ITERATIONS LOOP
C-----------------------------------------------------------------------

      IF (NEWTCONV) THEN
C ------------------------------------------------------------
C ----- INEXACT APPROXIMATE SIMPLIFIED NEWTON ITERATIONS -----
C ----- SUCCESSFULLY COMPLETED -------------------------------
C ------------------------------------------------------------
         REJECTITER=.FALSE.
         IF     (MAXNEWT<=1) THEN
            THETA=1.0
         ELSEIF (NEWT   <=1) THEN
            THETA=0.0
         ENDIF
         THETAOLD=THETA
      ELSE
c         WRITE(6,*) 'WARNING: NO FULL CONVERGENCE OF NEWTON'
c         WRITE(6,*) 'NEWT,T,DXSTARNTOL',NEWT,T,DXSTARNTOL
         REJECTITER=.TRUE.
         write(6,*) '5 REJECTITER'
         GOTO 10
      ENDIF

      IF     ((.NOT.(SOLVEVN)).AND.(NVGE1)) THEN
C -------- stiff accuracy for the v-components must hold -----
         CALL DCOPY(NV,ZY(VPTR,NS),1,ZNY(VPTR),1)
      ENDIF

C -- ERROR ESTIMATION -----
      IER=0
         CALL ERROREST(IERRJAC,ERR,
     &                 EXPM,ERRFAC,FACNORMNY,
     &                 NS,NY,NU,NV,Y,PRECSOL,RTOLY,ATOLY,ITOLY,
     &                 ISTEPSIZE,RPAR,ERRC,
     &                 ZY,ZNY,LBHI , BH(1,IERRJAC),IPAR,
     &                        LIBHI,IBH(1,IERRJAC),
     &                 TMP1NY,SCALYINV)
C-----------------------------------------------------------------------
C    COMPUTATION OF HNEWFACINV FOR NEW STEPSIZE HNEW
C-----------------------------------------------------------------------    
      CALL NEWSTEPSIZE(ISTEPSIZE,HNEWFACINV,ERR,EXPERR,
     &                 FIRST,CONVRESTRICT,NEWT,MAXNEWT,
     &                 SAFE,CFAC,FACR,FACL,H,NSTEP,
     &                 HACCEPT,          ERRACCEPT,
     &                 HREJECT,REJECTERR,ERRREJECT,
     &                 CALJAC,CALJACVN)

      IF (REJECTERR) THEN
C -------- STEP IS REJECTED -----
         IF (FIRST) THEN
            HNEWFACINV=10.0
         ELSE
            NREJECTERR=NREJECTERR+1
         ENDIF
         GOTO 10
      ELSE
C -------- STEP IS ACCEPTED -----
         NACCEPT=NACCEPT+1
         FIRST=.FALSE.
         HOLD=H
         TOLD=T
         T=TPH
C ----- UPDATE THE SOLUTION VECTOR Y -----
c         Y=Y+ZNY
         CALL DAXPY(NY,1.0,ZNY,1,Y,1)

C ----- FILL CONTY FOR DENSE OUTPUT ----- 
         CALL DENSEOUTPUT(NS,NY,NCONTY,CONTY,ZY,ZNY,ISNY,IC1CS,C,CINV)
C-----------------------------------------------------------------------
C        BACK TO THE MAIN LOOP
C-----------------------------------------------------------------------
         GOTO 5

      ENDIF

C ----- FAIL EXIT -----
 176  CONTINUE
      WRITE(6,979) T
      WRITE(6,*) ' APPROXIMATE JACOBIAN IS SINGULAR, IER=',IER
      IDID=-3
      RETURN
 177  CONTINUE
      WRITE(6,979) T
      WRITE(6,*) ' MORE STEPS ARE NEEDED'
      WRITE(6,*) ' SET IWORK( 2) > ',NMAX
      IDID=-2
      RETURN
 178  CONTINUE
C ----- EXIT CAUSED BY SOLOUT -----
      WRITE(6,979) T
      IDID=2
      RETURN
 979  FORMAT(' EXIT OF SPARK3 AT T=',E18.4)
C-----------------------------------------------------------------------
      END SUBROUTINE SPARK3COR
C-----------------------------------------------------------------------
