      SUBROUTINE DFYCNM(M,T,NY,NU,NV,Y,LDFMY,DFMY,RPAR,IPAR)
C-----------------------------------------------------------------------
C     ONLY THE NONZERO ELEMENTS OF DFMY NEED TO BE SET
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: M
      REAL   , INTENT(IN   ) :: T
      INTEGER, INTENT(IN   ) :: NY
      INTEGER, INTENT(IN   ) :: NU
      INTEGER, INTENT(IN   ) :: NV
      REAL   , INTENT(IN   ) :: Y(NY)
      INTEGER, INTENT(IN   ) :: LDFMY
      REAL   , INTENT(  OUT) :: DFMY(5,NY)
      REAL   , INTENT(IN   ) :: RPAR(*)
      INTEGER, INTENT(IN   ) :: IPAR(*)
C    LOCAL VARIABLES
      INTEGER                :: I,IU,IV,N,N2
      REAL                   :: GAMMA,GAMMA2,UI,UIVI,UI2,VI
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE DFYCNM
C-----------------------------------------------------------------------
      GAMMA =RPAR(1)
      GAMMA2=RPAR(2)
      N =IPAR(1)
      N2=IPAR(2)
       IF (M==1) THEN
      DO I=1,N
         IU=2*I-1
         IV=2*I
         UI=Y(IU)
         VI=Y(IV)
         UIVI=UI*VI
         UI2=UI*UI
         DFMY(3,IU)=2.0*UIVI-4.0-GAMMA2
         DFMY(2,IV)=UI2
         DFMY(4,IU)=3.0-2.0*UIVI
         DFMY(3,IV)=-UI2-GAMMA2
         DFMY(2,IU)=0.0
         DFMY(4,IV)=0.0
      ENDDO
      DO I=1,N2-2
         DFMY(1,I+2)=GAMMA
         DFMY(5,I  )=GAMMA
      ENDDO
       ENDIF
      RETURN
C-----------------------------------------------------------------------
      END SUBROUTINE DFYCNM
C-----------------------------------------------------------------------
