      SUBROUTINE FCNM(M,T,NY,NU,NV,Y,FM,RPAR,IPAR)
C-----------------------------------------------------------------------
C     ONLY THE NONZERO ELEMENTS OF FM NEED TO BE SET
C-----------------------------------------------------------------------
C    DECLARATIONS
C-----------------------------------------------------------------------
      IMPLICIT  NONE
C    SUBROUTINE VARIABLES
      INTEGER, INTENT(IN   ) :: M
      REAL   , INTENT(IN   ) :: T
      INTEGER, INTENT(IN   ) :: NY
      INTEGER, INTENT(IN   ) :: NU
      INTEGER, INTENT(IN   ) :: NV
      REAL   , INTENT(IN   ) :: Y(NY)
      REAL   , INTENT(  OUT) :: FM(NY)
      REAL   , INTENT(IN   ) :: RPAR(*)
      INTEGER, INTENT(IN   ) :: IPAR(*)
C    LOCAL VARIABLES
      INTEGER                :: I,IU,IV,N,N2
      REAL                   :: GAMMA,GAMMA2,PROD,UI,UIM,UIP,VI,VIM,VIP
C-----------------------------------------------------------------------
C    BEGINNING OF SUBROUTINE FCNM
C-----------------------------------------------------------------------
      GAMMA=RPAR(1)
      GAMMA2=RPAR(2)
      N=IPAR(1)
      N2=IPAR(2)
       IF (M==1) THEN
      I=1
      IU=2*I-1
      IV=2*I
      UI=Y(IU)
      VI=Y(IV)
      UIM=1.0
      VIM=3.0
      UIP=Y(IU+2)
      VIP=Y(IV+2)
      PROD=UI*UI*VI
      FM(IU)=1.0+PROD-4.0*UI+GAMMA*(UIM-2.0*UI+UIP)
      FM(IV)=3.0*UI-PROD+GAMMA*(VIM-2.0*VI+VIP)
      DO I=2,N-1
         IU=2*I-1
         IV=2*I
         UI=Y(IU)
         VI=Y(IV)
         UIM=Y(IU-2)
         VIM=Y(IV-2)
         UIP=Y(IU+2)
         VIP=Y(IV+2)
         PROD=UI*UI*VI
         FM(IU)=1.0+PROD-4.0*UI+GAMMA*(UIM-2.0*UI+UIP)
         FM(IV)=3.0*UI-PROD+GAMMA*(VIM-2.0*VI+VIP)
      ENDDO
      I=N
      IU=2*I-1
      IV=2*I
      UI=Y(IU)
      VI=Y(IV)
      UIM=Y(IU-2)
      VIM=Y(IV-2)
      UIP=1.0
      VIP=3.0
      PROD=UI*UI*VI
      FM(IU)=1.0+PROD-4.0*UI+GAMMA*(UIM-2.0*UI+UIP)
      FM(IV)=3.0*UI-PROD+GAMMA*(VIM-2.0*VI+VIP)
       ENDIF
      RETURN
      END
C-----------------------------------------------------------------------
C    END OF SUBROUTINE FCNM
C-----------------------------------------------------------------------
